<?php
/**
 * @package    Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */

if (!defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Act_admin
 *
 * Публикация/скрытие элемента
 */
class Act_admin extends Diafan
{
	/**
	 * Публикует/скрывает элемент
	 *
	 * @return void
	 */
	public function act()
	{
		// Прошел ли пользователь проверку идентификационного хэша
		if (!$this->diafan->_user->checked)
		{
			echo "{error: 'HASH'}";
			return;
		}

		//проверка прав пользователя на активацию/блокирование
		if (! $this->diafan->_user->roles('edit', $this->diafan->rewrite))
		{
			echo "{error: 'ERROR'}";
			return;
		}

		//учитывается языковая версия, если это необходимо
		$lang = $this->diafan->variable_multilang("act") ? _LANG : '';
		$ids = array ();
		$redirect = URL;

		if (!empty( $_POST["id"] ))
		{
			if ($this->diafan->config("parent"))
			{
				$ids = $this->diafan->get_children($_POST["id"], $this->diafan->table, array (), false);
				$parent_id = DB::query_result("SELECT parent_id FROM {".$this->diafan->table."} WHERE id=%d LIMIT 1", $_POST["id"]);
				if($parent_id && $this->diafan->parent != $parent_id)
				{
					$redirect = str_replace('parent'.$this->diafan->parent.'/', '', $redirect).'parent'.$parent_id.'/';
				}
			}
			$ids[] = intval($_POST["id"]);
		}
		else {
			if (!empty( $_POST['ids'] ))
			{
				foreach ($_POST["ids"] as $id)
				{
					$id = intval($id);
					if (!in_array($id, $ids))
					{
						if ($this->diafan->config("parent"))
						{
							$array = $this->diafan->get_children($id, $this->diafan->table, array (), false);
							$ids = array_merge($ids, $array);
						}
						$ids[] = $id;
					}
				}
			}
		}
		if (!empty( $ids ))
		{
			DB::query("UPDATE {".$this->diafan->table."} SET act".$lang."='".( $_POST["action"] == "block" ? "1".( $this->diafan->is_variable("timeedit") ? "', timeedit='".time() : '' ) : '0' )."' WHERE id IN (".implode(',', $ids).")");
		}
		/*
		 // делаем категори неактивной - все основные элементы в ней тоже неактивны
		if ($this->diafan->config('category'))
		{
			DB::query("UPDATE {".str_replace('_category', '', $this->diafan->table)."} SET act".$lang."='".( $_POST["action"] == "block" ? "1".( $this->diafan->is_variable("timeedit") ? "', timeedit='".time() : '' ) : '0' )."' WHERE cat_id IN (".implode(',', $ids).")");
		}*/
		if (! $dirr = opendir(ABSOLUTE_PATH.'modules'))
		{
			throw new Exception('Папка '.ABSOLUTE_PATH.'modules не существует.');
		}
		while (( $module = readdir($dirr) ) !== false)
		{
			if (file_exists(ABSOLUTE_PATH.'modules/'.$module.'/admin/'.$module.'.admin.inc.php'))
			{
				Customization::inc('modules/'.$module.'/admin/'.$module.'.admin.inc.php');
				$class = ucfirst($module).'_admin_inc';
				if (method_exists($class, 'act'))
				{
					$class_admin_act = new $class($this->diafan);
					$class_admin_act->act($this->diafan->table, $ids, ( $_POST["action"] == "block" ? 1 : 0 ));
				}
			}
		}
		$this->diafan->_cache->delete("", $this->diafan->module);
		include_once ABSOLUTE_PATH.'plugins/json.php';
		$result["redirect"] = $redirect;
		echo to_json($result);
	}
}