<?php
/**
 * Demo-версия
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */
if(! defined('DIAFAN'))
{
	include(dirname(dirname(__FILE__)).'/includes/404.php');
}

/**
 * Demo
 */
class Demo extends Diafan
{
	/**
	 * @var array модули для установки
	 */
	private $modules = array('core', 'users', 'messages', 'map', 'news', 'clauses', 'feedback', 'faq', 'shop', 'ab', 'files', 'search', 'bs', 'comments', 'rating', 'tags', 'photo', 'votes', 'subscribtion', 'forum', 'keywords', 'mistakes', 'consultant', 'webeffector', 'filemanager', 'captcha');

	/**
	 * @var object
	 */
	private $install;

	/**
	 * Установка
	 *
	 * @return void
	 */
	function install()
	{
		DB::query("CREATE TABLE {sessions} (
			`user_id` int(11) unsigned NOT NULL DEFAULT '0',
			`session_id` varchar(64) NOT NULL DEFAULT '',
			`hostname` varchar(128) NOT NULL DEFAULT '',
			`user_agent` varchar(255) NOT NULL DEFAULT '',
			`timestamp` int(10) unsigned NOT NULL,
			`session` text NOT NULL,
			PRIMARY KEY (`session_id`),
			KEY `user_id` (`user_id`)
		) CHARSET=utf8;");

		DB::query("CREATE TABLE {users} (
			`id` int(3) unsigned NOT NULL AUTO_INCREMENT,
			`name` varchar(60) NOT NULL DEFAULT '',
			`password` varchar(32) NOT NULL DEFAULT '',
			`mail` varchar(64) NOT NULL DEFAULT '',
			`created` int(12) unsigned NOT NULL DEFAULT '0',
			`fio` varchar(250) NOT NULL DEFAULT '',
			`role_id` int(3) unsigned NOT NULL DEFAULT '0',
			`act` enum('0','1') NOT NULL DEFAULT '0',
			`trash` enum('0','1') NOT NULL DEFAULT '0',
			`htmleditor` enum('0','1') NOT NULL,
			`subscribtion` varchar(255) NOT NULL,
			`language` tinyint(2) NOT NULL,
			`background` varchar(255) NOT NULL,
			PRIMARY KEY (`id`),
			KEY `name` (`name`(1))
		) CHARSET=utf8;");

		DB::query("CREATE TABLE {users_demo} (
			`id` int(11) unsigned NOT NULL AUTO_INCREMENT,
			`session_id` varchar(64) CHARACTER SET utf8 NOT NULL,
			`ip` varchar(62) CHARACTER SET utf8 NOT NULL,
			`timestart` int(10) unsigned NOT NULL,
			`timeend` int(10) unsigned NOT NULL,
			`timenow` int(10) unsigned NOT NULL,
			PRIMARY KEY (`id`)
		) CHARSET=utf8;");

		DB::query("CREATE TABLE {users_role} (
			`id` int(3) unsigned NOT NULL AUTO_INCREMENT,
			`name` varchar(64) NOT NULL DEFAULT '',
			`trash` enum('0','1') NOT NULL DEFAULT '0',
			PRIMARY KEY (`id`)
		) CHARSET=utf8;");

		DB::query("CREATE TABLE {users_role_perm} (
			`id` int(11) unsigned NOT NULL AUTO_INCREMENT,
			`role_id` tinyint(3) unsigned NOT NULL,
			`perm` text NOT NULL,
			`rewrite` text NOT NULL,
			`type` enum('site','admin') NOT NULL,
			PRIMARY KEY (`id`)
		) CHARSET=utf8;");

		DB::query("INSERT INTO {users} (`id`, `name`, `password`, `mail`, `created`, `fio`, `role_id`, `act`, `trash`, `htmleditor`, `subscribtion`, `language`, `background`) VALUES
(1, 'demo', 'fb676e6eb353fd0d2224ec2711f9e571', 'mail@diafan.ru', 1301601600, 'Иванов Иван', 4, '1', '0', '1', '', 0, '');");

		DB::query("INSERT INTO {users_role} (`id`, `name`, `trash`) VALUES
(4, 'Администратор', '0');");

		DB::query("INSERT INTO {users_role_perm} (`id`, `role_id`, `perm`, `rewrite`, `type`) VALUES
(1, 4, 'all', 'all', 'admin');");
	}

	/**
	 * Инициализация demo-версии
	 *
	 * @return void
	 */
	function init()
	{
		$session_id = preg_replace('/[0-9]+/', '', session_id());
		define("DB_PREFIX", $session_id.DB_PREFIX_DEMO);
		define("USERFILES", 'userfiles/'.$session_id);

		if(! $this->diafan->_user->id)
		{
			exit;
		}

		if(! DB::query_result("SELECT id FROM ".DB_PREFIX_DEMO."users_demo WHERE session_id='%s' AND timeend=0 LIMIT 1", session_id()))
		{
			$this->start();
			$this->clear();
		}
		$this->config();
	}

	/**
	 * Старт demo-сессии
	 *
	 * @return void
	 */
	function start()
	{	
		if(DB::query_result("SELECT COUNT(*) FROM ".DB_PREFIX_DEMO."users_demo WHERE timeend=0") > 10)
		{
			$this->clear();
			throw new Exception('Извините, в данный момент просмотр демо версии diafan.CMS невозможен. Попробуйте обратиться к системе через 15 минут. Благодарим за понимание!');
		}
		$_SESSION["install_name"] = 'Бумажный зоопарк';
	
		foreach($this->modules as $module)
		{
			$_POST[$module] = true;
		}
		$_POST["lang_yes"] = true;
	
		$userfiles = explode('/', USERFILES);
		Files_inc::create_dir($userfiles[1], $userfiles[0]);
	
		include_once(ABSOLUTE_PATH."includes/install.php");
		$this->install = new Install(array(1,2));

		$_SESSION["install_admin_name"] = 'admin';
		$_SESSION["install_admin_pass"] = '123';
		$_SESSION["install_admin_fio"] = 'Администратор';
		$_SESSION["install_admin_mail"] = 'test@test.ru';

		foreach($this->modules as $module)
		{
			$this->install->install($module, true);
		}
		DB::query("INSERT INTO ".DB_PREFIX_DEMO."users_demo (session_id, ip, timestart) VALUES ('%s', '%s', %d)",
				  session_id(), getenv('REMOTE_ADDR')." ".getenv('HTTP_X_FORWARDED_FOR'), time());
		
		include_once(DEMO_PATH."searchindex.php");
		foreach($sql as $s)
		{
			DB::query($s);
		}
	}

	/**
	 * Формирует параметры сайта
	 *
	 * @return void
	 */
	function config()
	{
		$fields = array(
			'EMAIL_CONFIG',
			'MOBILE_VERSION',
			'SMTP_MAIL',
			'SMTP_HOST',
			'SMTP_LOGIN',
			'SMTP_PASSWORD',
			'SMTP_PORT',
			'CACHE_MEMCACHED',
			'CACHE_MEMCACHED_HOST',
			'CACHE_MEMCACHED_PORT',
			'TIMEZONE',
			'SMS',
			'SMS_KEY',
			'SMS_ID',
			'SMS_SIGNATURE',
			'LAST_1C_EXPORT',
			'ROUTE_END',
			'ROUTE_AUTO_MODULE',
		);
		for($i = 1; $i<11; $i++)
		{
			$fields[] = 'TIT'.$i;
		}
		$default = array(
			'DB_URL' => 'mysqli://user:pass@localhost/dbname',
			'DB_PREFIX' => 'diafan_',
			'DB_CHARSET' => 'utf8',
			'EMAIL_CONFIG' => 'demo@'.$_SERVER['HTTP_HOST'], 
			'USERFILES' => 'userfiles',
			'ADMIN_FOLDER' => 'admin',
			'TIMEZONE' => 'Europe/Moscow',
			'LAST_1C_EXPORT' => "1.04.2013 13:21",
			'ROUTE_END' => '/',
			'ROUTE_AUTO_MODULE' => true,
			'TIT1' => 'Демо версия сайта',
			'TIT2' => 'Demo',
		);
		// определяем дефолтные значения для модуля "Параметры сайта"
		foreach($default as $k => $v)
		{
			if(! isset($_SESSION["CONFIG_".$v]))
			{
				$_SESSION["CONFIG_".$k] = $v;
			}
		}
		// назначаем параметрам сайта из списка значения, определенные пользователем
		foreach($fields as $field)
		{
			if(! isset($_SESSION["CONFIG_".$field]))
			{
				$_SESSION["CONFIG_".$field] = '';
			}
			define($field, $_SESSION["CONFIG_".$field]);
		}
	}

	/**
	 * Удаляет демо-данные
	 *
	 * @param string $session_id идентификатор сессии, если не передан, чистит старые сессии
	 * @return void
	 */
	public function clear($session_id = '')
	{
		include_once(ABSOLUTE_PATH."includes/install.php");

		$sessions = array();
		if(! $session_id)
		{
			// удаляем старые сессии, не текущие
			DB::query("DELETE FROM ".DB_PREFIX_DEMO."sessions WHERE timestamp<%d AND session_id<>'%s'", time() - 1440, session_id());
			// выбираем все активные сессии
			$sql = DB::query("SELECT session_id FROM ".DB_PREFIX_DEMO."sessions");
			while($row = DB::fetch_array($sql))
			{
				$sessions[] = $row["session_id"];
			}
			// выбираем все созданные на сайте песочницы
			$sql = DB::query("SELECT session_id FROM ".DB_PREFIX_DEMO."users_demo WHERE timeend=0");
		}
		else
		{
			// удаляем текущую сессию
			DB::query("DELETE FROM ".DB_PREFIX_DEMO."sessions WHERE session_id='%s'", $session_id);
			// выбираем текущую песочницу
			$sql = DB::query("SELECT session_id FROM ".DB_PREFIX_DEMO."users_demo WHERE session_id='%h' LIMIT 1", $session_id);
		}
		$install_modules = array();
		while($row = DB::fetch_array($sql))
		{
			// если песочницы нет в активных сессиях, удаляем ее
			if(! in_array($row["session_id"], $sessions))
			{
				DB::query("DELETE FROM ".DB_PREFIX_DEMO."users_demo WHERE session_id='%s'", $row["session_id"]);

				$row["session_id"] = preg_replace('/[0-9]+/', '', $row["session_id"]);
				if(! $row["session_id"]) continue;

				if(empty($install_modules))
				{
					$install_modules = $this->get_modules();
				}
				foreach($install_modules as $module)
				{
					if(! isset($modules[$module]))
					{
						if(! $this->install)
						{
							unset($db);
							if($module == 'core')
							{
								include ABSOLUTE_PATH."installation/core.php";
							}
							else
							{
								include ABSOLUTE_PATH."modules/".$module.'/'.$module.".install.php";
							}
							if(! empty($db["tables"]))
							{
								$modules[$module] = $db["tables"];
							}
							else
							{
								$modules[$module] = array();
							}
						}
						else
						{
							$modules[$module] = $this->install->modules[$module]["tables"];
						}
					}
					foreach($modules[$module] as $r)
					{
						DB::query("DROP TABLE ".$row["session_id"].DB_PREFIX_DEMO.$r["name"].";");
					}
				}
				Files_inc::delete_dir('userfiles/'.$row["session_id"]);	
			}
		}
		DB::free_result($sql);
	}

	/**
	 * Получает список модулей
	 *
	 * @return array
	 */
	private function get_modules()
	{
		$modules = array('core');
		$dirr = opendir(ABSOLUTE_PATH."modules");
		while (($module = readdir($dirr)) !== false)
		{	  
			if (file_exists(ABSOLUTE_PATH.'modules/'.$module.'/'.$module.'.install.php'))
			{
				$modules[] = $module;
			}
		}
		closedir($dirr);
		return $modules;
	}
}