<?php
/**
 * Статистика просмотров
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Ab_admin_counter
 */
class Ab_admin_counter extends Frame_admin
{
	/**
	 * Подготавливает конфигурацию модуля
	 * @return void
	 */
	public function prepare_config()
	{
		if ($this->diafan->edit)
		{
			include_once ABSOLUTE_PATH.'includes/404.php';
		}
	}

	/**
	 * Выводит статистику просмотров
	 * @return void
	 */
	public function show()
	{
		$where = "";
		$inner = "";
		if ($this->diafan->cat)
		{
			$inner = " INNER JOIN {ab_category_rel} AS r ON r.element_id=s.id";
			$where = " AND r.cat_id=".$this->diafan->cat;
		}

		$this->diafan->_paginator->page    = $this->diafan->page;
		$this->diafan->_paginator->navlink = 'ab/counter/'.($this->diafan->cat ? 'cat'.$this->diafan->cat.'/' : '');
		$this->diafan->_paginator->nen     = DB::query_result("SELECT COUNT(DISTINCT s.id) FROM {ab} AS s".$inner." WHERE s.trash='0'".$where);
		$result["links"] = $this->diafan->_paginator->get();

		$result["rows"] = array();
		
		//забираем все заказы, удовлетворяющие фильтру
		$result_q = DB::query_range("SELECT s.id, s.[name], cn.count_view FROM {ab} AS s
		LEFT JOIN {ab_counter} AS cn ON cn.element_id=s.id
		".$inner."
		WHERE s.trash='0'".$where." GROUP BY s.id ORDER BY cn.count_view DESC", $this->diafan->_paginator->polog, $this->diafan->_paginator->nastr);
		
		while ($row = DB::fetch_array($result_q))
		{
			$result["rows"][] = $row;
		}
		DB::free_result($result_q);
		$this->template($result);
	}

	/**
	 * Шаблон вывода
	 * @return boolean true
	 */
	public function template($result)
	{
		if(! $this->diafan->configmodules("counter", "ab"))
		{
			echo '<div class="error">'.$this->diafan->_('Подключите счетчик просмотров в настройках модуля.').'</div>';
		}
		if ($this->diafan->configmodules("cat", "ab"))
		{
			$cats_filter = array();
			$res = DB::query(
				"SELECT id, [name], parent_id FROM {ab_category} WHERE trash='0'"
				." ORDER BY sort ASC, id ASC"
			);
			while ($row = DB::fetch_array($res))
			{
				$cats_filter[$row["parent_id"]][] = $row;
			}
			DB::free_result($res);
			if($cats_filter)
			{
				echo '<div class="block">'.$this->diafan->_('Категория') . ': <select rel="' . $this->diafan->get_admin_url('cat', 'site') . '" class="redirect" name="cat">'
				. '<option value="">' . $this->diafan->_('Все') . '</option>';
				echo $this->diafan->get_options($cats_filter, $cats_filter[0], array($this->diafan->cat))
				. '</select></div>';
			}
		}

		echo '
		<table class="list">
		<tr>
			<td><b>'.$this->diafan->_('Название').'</b></td>
			<td><b>'.$this->diafan->_('Просмотров').'</b></td>
		</tr>';
		foreach ($result["rows"] as $row)
		{
			echo '<tr altcolor="#eeeeee" class="tr">
			<td><a href="'.BASE_PATH_HREF.'ab/edit'.$row["id"].'/">'.$row["name"].'</a></td>
			<td>'.($row["count_view"] ? $row["count_view"] : 0).'</td>
			</tr>';
		}
		
		echo '<tr><td></td><td colspan=3 align=left><br>'.$this->diafan->_tpl->get('get_admin', 'paginator', $result["links"]).'<br></td></tr>';
		
		echo '</table>';
	}
}