<?php
/**
 * Редактирование дополнительных характеристик объявлений
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */
if ( ! defined('DIAFAN'))
{
    include dirname(dirname(dirname(__FILE__))) . '/includes/404.php';
}

/**
 * Ab_admin_param
 */
class Ab_admin_param extends Frame_admin
{
    /**
     * @var string таблица в базе данных
     */
    public $table = 'ab_param';

	/**
	 * @var array поля в базе данных для редактирования
	 */
	public $variables = array (
		'main' => array (
			'name' => array(
				'type' => 'text',
				'name' => 'Название',
				'help' => 'Имя дополнительной характеристики объявления, доступно для заполнения при редактировании товара.',
				'multilang' => true,
			),
			'type' => array(
				'type' => 'select',
				'name' => 'Тип',
			),
			'max_count_attachments' => array(
				'type' => 'none',
				'name' => 'Максимальное количество добавляемых файлов',
				'help' => 'Количество добавляемых файлов. Если значение равно нулю, то форма добавления файлов не выводится. Параметр выводится, если тип характеристики задан как «файлы».',
				'no_save' => true,
			),
			'attachment_extensions' => array(
				'type' => 'none',
				'name' => 'Доступные типы файлов (через запятую)',
				'help' => 'Параметр выводится, если тип характеристики задан как «файлы».',
				'no_save' => true,
			),
			'recognize_image' => array(
				'type' => 'none',
				'name' => 'Распознавать изображения',
				'help' => 'Позволяет прикрепленные файлы в формате JPEG, GIF, PNG отображать как изображения. Параметр выводится, если тип характеристики задан как «файлы».',
				'no_save' => true,
			),
			'attach_big' => array(
				'type' => 'none',
				'name' => 'Размер для большого изображения',
				'help' => 'Размер изображения, отображаемый в пользовательской части сайта при увеличении изображения предпросмотра. Параметр выводится, если тип характеристики задан как «файлы» и отмечена опция «Распознавать изображения».',
				'no_save' => true,
			),
			'attach_medium' => array(
				'type' => 'none',
				'name' => 'Размер для маленького изображения',
				'help' => 'Размер изображения предпросмотра. Параметр выводится, если тип характеристики задан как «файлы» и отмечена опция «Распознавать изображения».',
				'no_save' => true,
			),
			'attach_use_animation' => array(
				'type' => 'none',
				'name' => 'Использовать анимацию при увеличении изображений',
				'help' => 'Параметр добавляет JavaScript код, позволяющий включить анимацию при увеличении изображений. Параметр выводится, если отмечена опция «Распознавать изображения». Параметр выводится, если тип характеристики задан как «файлы» и отмечена опция «Распознавать изображения».',
				'no_save' => true,
			),
			'upload_max_filesize' => array(
				'type' => 'none',
				'name' => 'Максимальный размер загружаемых файлов',
				'help' => 'Параметр показывает максимально допустимый размер загружаемых файлов, установленный в настройках хостинга. Параметр выводится, если тип характеристики задан как «файлы».',
				'no_save' => true,
			),
			'images_variations' => array(
				'type' => 'none',
				'name' => 'Генерировать размеры изображений',
				'help' => 'Размеры изображений, заданные в модуле «Изобаражения». Параметр выводится, если тип характеристики задан как «изображение».',
				'no_save' => true,
			),
			'param_select' => array(
				'type' => 'function',
				'name' => 'Значения, псевдоссылка',
				'help' => 'Поле появляется для характеристик с типом «галочка», «выпадающий список» и «список с выбором нескольких значений».',
			),
			'required' => array(
				'type' => 'checkbox',
				'name' => 'Обязательно для заполнения из пользовательской части',
			),
			'measure_unit' => array(
				'type' => 'text',
				'name' => 'Единица измерения',
				'help' => 'Параметр выводится, если тип характеристики задан как «число».',
				'multilang' => true,
			),
			'page' => array(
				'type' => 'checkbox',
				'name' => 'Отдельная страница для значений',
				'help' => 'Поле появляется для характеристик с типом «выпадающий список» и «список с выбором нескольких значений». Если опция отмечена, то на сайте появляется страница с объявлениями, объединенными одной характеристикой. Например, город: Краснодар. Странице можно задать ЧПУ, для этого рядом с полем «Значение» выводится дополнительное поля «Псевдоссылка».',
			),
			'category' => array(
				'type' => 'function',
				'name' => 'Категория',
				'help' => 'Категории объявлений, для которых действует данный параметр. Если не указана ни одна категория, то характеристика считается общей.',
			),
			'sort' => array(
				'type' => 'function',
				'name' => 'Сортировка: установить перед',
				'help' => 'Редактирование порядка следования характеристики в списке',
			),
			'hr1' => 'hr',
			'search' => array(
				'type' => 'checkbox',
				'name' => 'Использовать в форме поиска',
				'help' => 'Позволяет отображать характеристику в форме поиска, выводимой тегом show_search.',
			),
			'list' => array(
				'type' => 'checkbox',
				'name' => 'Показывать в списке',
				'help' => 'Позволяет выводить значение характеристики для объявлений в списке объявлений на сайте.',
			),
			'block' => array(
				'type' => 'checkbox',
				'name' => 'Показывать в блоке объявлений',
				'help' => 'Позволяет выводить значение характеристики для объявлений в блоке объявлений, выводимом тегом show_block.',
			),
			'display_in_sort' => array(
				'type' => 'function',
				'name' => 'Отображать параметры в блоке для сортировки объявлений',
				'help' => 'Позволяет выводить характеристику в виде ссылки для сортировки объявлений по значению характеристики.',
			),
			'hr2' => 'hr',
			'text' => array(
				'type' => 'textarea',
				'name' => 'Описание характеристики',
				'help' => 'Поле используется для комментирования характеристик в списке. В пользовательской части поле не используется.',
				'multilang' => true,
			),
		),
	);

	/**
	 * @var array настройки модуля
	 */
	public $config = array (
		'del', // удалить
		'order', // сортируется
		'trash', // использовать корзину
	);

	/**
	 * @var array значения списков
	 */
	public $select_arr = array(
		'type' => array(
			'text' => 'строка',
			'numtext' => 'число',
			'date' => 'дата',
			'datetime' => 'дата и время',
			'textarea' => 'текстовое поле',
			'checkbox' => 'галочка',
			'select' => 'выпадающий список',
			'multiple' => 'список с выбором нескольких значений',
			'email' => 'электронный ящик',
			'editor' => 'поле с визуальным редактором',
			'title' => 'заголовок группы характеристик',
			'attachments' => 'файлы',
			'images' => 'изображения',
		),
	);

	/**
	 * @var array выводить в списке содержание полей:
	 */
	public $config_other_row = array (
		'type' => array('type' => 'select', 'class' => 'param_type'),
		'id' => 'function',
	);

	/**
	 * Подготавливает конфигурацию модуля
	 * @return void
	 */
	public function prepare_config()
	{
        if ( ! $this->diafan->configmodules("cat", "ab", $this->diafan->site))
        {
            $this->diafan->variable_unset("cat_id");
        }
    }

	/**
	 * Выводит ссылку на добавление
	 * @return void
	 */
	public function show_add()
	{
        $this->diafan->addnew_init('Добавить характеристику');
	}

    /**
     * Выводит список дополнительных характеристик товара
     * @return void
     */
    public function show()
    {
        $this->diafan->list_row();
    }

	/**
	 * Поиск
	 *
	 * @return string
	 */
	public function show_search()
	{
		if($this->diafan->edit)
				return '';

		if ($this->diafan->cat)
		{
			$this->diafan->where .= " AND e.id IN (SELECT element_id FROM {ab_param_category_rel} WHERE cat_id='" . $this->diafan->cat . "')";
		}

		$html = '';

		if ($this->diafan->configmodules("cat", "ab", $this->diafan->site))
		{
			$cats = array();
			$result = DB::query("SELECT id, [name], parent_id FROM {ab_category} WHERE trash='0'" . ($this->diafan->site ? " AND site_id=" . $this->diafan->site : "") . " ORDER BY sort ASC");
			while ($row = DB::fetch_array($result))
			{
				$cats[$row["parent_id"]][] = $row;
			}
			DB::free_result($result);
			if($cats)
			{
				$html = '<td class="name"></td>
				<td class="param_type"></td>
				<td class="param_cats"><select rel="' . $this->diafan->get_admin_url('cat', 'site') . '" class="redirect" name="cat">'
				. '<option value="">' . $this->diafan->_('Все') . '</option>';
				$html .= $this->diafan->get_options($cats, $cats[0], array($this->diafan->cat))
				. '</select></td>';
			}
		}

		return $html;
	}

	/**
	 * Выводит тип характеристики в списке характеристик
	 * @return string
	 */
	public function other_row_id($row)
	{
		$cats = array();
		$result = DB::query("SELECT s.[name] FROM {ab_param_category_rel} as c INNER JOIN {ab_category} as s ON s.id=c.cat_id"
						. " WHERE element_id=%d", $row["id"]);
		while ($row_cat = DB::fetch_array($result))
		{
			$cats[] = $row_cat["name"];
		}
		DB::free_result($result);
		if ( ! $cats)
		{
			$cats[] = $this->diafan->_('Общие');
		}
		return '<td class="param_cats">' . implode(', ', $cats).'</td>';
	}

	/**
	 * Редактирование поля "Параметры"
	 * @return void
	 */
	public function edit_variable_param_select()
	{
		$value = array();
		if (empty($this->diafan->values["type"]))
		{
			$this->diafan->values["type"] = '';
		}
		if ( ! $this->diafan->addnew && in_array($this->diafan->values["type"], array('select', 'multiple', 'checkbox')))
		{
			$result_select = DB::query("SELECT [name], value, id, sort FROM {ab_param_select} WHERE param_id=%d ORDER BY sort DESC", $this->diafan->edit);
			while ($row_select = DB::fetch_array($result_select))
			{
				if ($this->diafan->values["type"] == 'checkbox')
				{
					$value[$row_select["value"]] = $row_select["name"];
				}
				else
				{
					$row_select["rewrite"] = DB::query_result("SELECT rewrite FROM {rewrite} WHERE module_name='ab' AND param_id=%d LIMIT 1", $row_select["id"]);
					$value[] = $row_select;
				}
			}
			DB::free_result($result_select);
		}

		echo '
		<script type="text/javascript" src="' . BASE_PATH . 'js/admin/admin.param_select.js"></script>
		<script type="text/javascript" src="' . BASE_PATH . 'modules/ab/admin/ab.admin.param.js"></script>

		<tr id="param" valign="top">
			<td class="td_first">' . $this->diafan->variable_name() . '</td>
			<td>
			<div class="param_table">
			<a href="#" class="param_sort_name">'.$this->diafan->_('Сортировать по алфавиту').'</a>
			<table>';

		$fields = false;
		$param_textarea = '';
		if (in_array($this->diafan->values["type"], array('select', 'multiple')))
		{
			foreach ($value as $row)
			{
				echo '
				<tr class="param">
					<td>
						<input type="hidden" name="param_id[]" value="' . $row["id"] . '">
						<input type="text" name="paramv[]" size="30" value="' . str_replace('"', '&quot;', $row["name"]) . '">
						<input type="text" name="param_rewrite[]" size="20" value="' . $row["rewrite"] . '">
						<span class="param_actions">
							<a href="javascript:void(0)" action="delete_param" confirm="' . $this->diafan->_('Вы действительно хотите удалить запись?') . '"><img src="' . BASE_PATH . 'adm/img/delete.png" width="13" height="13" alt="' . $this->diafan->_('Удалить') . '"></a>
							<a href="javascript:void(0)" action="up_param"><img src="' . BASE_PATH . 'adm/img/up.gif" width="14" height="16" alt="' . $this->diafan->_('Выше') . '"></a>
							<a href="javascript:void(0)" action="down_param"><img src="' . BASE_PATH . 'adm/img/down.gif" width="14" height="16" alt="' . $this->diafan->_('Ниже') . '"></a>
						</span>
					</td>
				</tr>';
				$fields = true;
				$param_textarea .= str_replace(array('<', '>'), array('&lt;', '&gt;'), $row["name"].';'.$row["rewrite"])."\n" ;
			}
		}
		if ( ! $fields)
		{
			echo '
			<tr class="param">
				<td>
					<input type="hidden" name="param_id[]" value="">
					<input type="text" name="paramv[]" size="30" value="">
					<input type="text" name="param_rewrite[]" size="20" value="">
					<span class="param_actions">
						<a href="javascript:void(0)" action="delete_param" confirm="' . $this->diafan->_('Вы действительно хотите удалить запись?') . '">
							<img src="' . BASE_PATH . 'adm/img/delete.png" width="15" height="15" alt="' . $this->diafan->_('Удалить') . '">
						</a>
						<a href="javascript:void(0)" action="up_param"><img src="'.BASE_PATH.'adm/img/up.gif" width="14" height="16" alt="'.$this->diafan->_('Выше').'"></a>
						<a href="javascript:void(0)" action="down_param"><img src="'.BASE_PATH.'adm/img/down.gif" width="14" height="16" alt="'.$this->diafan->_('Ниже').'"></a>
					</span>
				</td>
			</tr>';
		}
		echo '</table>
				<a href="javascript:void(0)" class="param_plus" title="' . $this->diafan->_('Добавить') . '"><img src="' . BASE_PATH . 'adm/img/add.png" width="16" height="16" alt="' . $this->diafan->_('Добавить') . '"></a>
				</div>
				<input type="checkbox" value="1" name="param_textarea_check"> '.$this->diafan->_('Быстрое редактирование').'
				<div class="param_textarea">
				<textarea name="param_textarea" cols="49" rows="10">'.$param_textarea.'</textarea>
				</div>
			</td>
		</tr>
		<tr id="param_check">
			<td class="td_first">' . $this->diafan->variable_name() . '</td>
			<td>
				' . $this->diafan->_('да') . ' <input type="text" name="paramk_check1" size="20" value="'
		. ( ! empty($value[1]) && $this->diafan->values["type"] == 'checkbox' ? str_replace('"', '&quot;', $value[1]) : '')
		. '">
				&nbsp;&nbsp;
				' . $this->diafan->_('нет') . ' <input type="text" name="paramk_check0" size="20" value="'
		. ( ! empty($value[0]) && $this->diafan->values["type"] == 'checkbox' ? str_replace('"', '&quot;', $value[0]) : '') . '">
			</td>
		</tr>';
		Customization::inc('modules/attachments/admin/attachments.admin.inc.php');
		$attachment = new Attachments_admin_inc($this->diafan);
		$attachment->edit_config_param(! empty($this->diafan->values["config"]) ? $this->diafan->values["config"] : '');

		Customization::inc('modules/images/admin/images.admin.inc.php');
		$images = new Images_admin_inc($this->diafan);
		$images->edit_config_param(! empty($this->diafan->values["config"]) ? $this->diafan->values["config"] : '');
	}

	/**
	 * Редактирование поля "Категория"
	 * 
	 * @return void
	 */
	public function edit_variable_category()
	{
		if(! $this->diafan->configmodules("cat", "ab"))
		{
			return;
		}
		$as_pages = array();
		$as_page_result = DB::query("SELECT id, [name] FROM {site} WHERE trash='0' AND module_name='ab'");
		while ($row = DB::fetch_array($as_page_result))
		{
			$as_pages[$row['id']] = $row['name'];
		}
		DB::free_result($as_page_result);

		echo '
		<tr valign="top">
			<td align="right">'.$this->diafan->_('Категория') . '</td>
			<td>';

		$result = DB::query("SELECT id, [name], parent_id, site_id FROM {ab_category} WHERE trash='0' ORDER BY sort ASC");
		while ($row = DB::fetch_array($result))
		{
			$cats[$row["site_id"]][$row["parent_id"]][] = $row;
		}
		DB::free_result($result);

		$values = array();
		if ( ! $this->diafan->addnew)
		{
			$result = DB::query("SELECT cat_id FROM {ab_param_category_rel} WHERE element_id=%d AND cat_id>0", $this->diafan->edit);
			while ($row = DB::fetch_array($result))
			{
				$values[] = $row["cat_id"];
			}
			DB::free_result($result);
		}

		echo ' <select name="cat_ids[]" multiple="multiple" size="11">
		<option value="all"'.(empty($values) ? ' selected' : '').'>'.$this->diafan->_('Все').'</option>';
		foreach($as_pages as $site_id => $name)
		{
			if(! empty($cats[$site_id]))
			{
				if(count($as_pages) > 1)
				{
					echo '<optgroup label="'.$name.'">';
				}
				echo $this->diafan->get_options($cats[$site_id], $cats[$site_id][0], $values);
				if(count($as_pages) > 1)
				{
					echo '</optgroup>';
				}
			}
		}
		echo '</select>';

		echo $this->diafan->help() . '
			</td>
		</tr>';
	}

	/**
	 * Сохранение поля "Параметры"
	 * @return void
	 */
	public function save_variable_param_select()
	{
		switch ($_POST["type"])
		{
			case "select":
			case "multiple":
				if(! empty($_POST["param_textarea_check"]))
				{
					$result = DB::query("SELECT id, [name] FROM {ab_param_select} WHERE param_id=%d", $this->diafan->save);
					while($row = DB::fetch_array($result))
					{
						$values[$row["name"]] = $row["id"];
					}
					DB::free_result($result);
					$strings = explode("\n", $_POST["param_textarea"]);
					$sort = count($strings);
					foreach($strings as $string)
					{
						$data = explode(";", trim($string));
						$data[0] = trim($data[0]);
						if(empty($data[0]))
						{
							continue;
						}
						$id = (! empty($values[$data[0]]) ? $values[$data[0]] : '');
						if($id)
						{
							DB::query("UPDATE {ab_param_select} SET [name]='%h', sort=%d WHERE id=%d", $data[0], $sort, $id);
						}
						else
						{
							$id = DB::query("INSERT INTO {ab_param_select} (param_id, [name], sort) VALUES (%d, '%h', %d)", $this->diafan->save, $data[0], $sort);
						}
						if(empty($data[1]))
						{
							$data[1] = '';
						}
						else
						{
							$data[1] = trim($data[1]);
						}
						if($data[1])
						{
							if(empty($site_id))
							{
								$site_id = DB::query_result("SELECT id FROM {site} WHERE [act]='1' AND trash='0' AND module_name='ab' LIMIT 1");
							}
							$rewrite = DB::query_fetch_array("SELECT id, rewrite, site_id FROM {rewrite} WHERE module_name='ab' AND param_id=%d LIMIT 1", $id);
							if ( ! empty($rewrite["id"]))
							{
	
								if ($rewrite["rewrite"] != $data[1] || $site_id != $rewrite["site_id"])
								{
									DB::query("UPDATE {rewrite} SET site_id=%d, rewrite='%h' WHERE param_id=%d", $site_id, $data[1], $id);
								}
							}
							else
							{
								DB::query("INSERT INTO {rewrite} (module_name, site_id, param_id, rewrite) VALUES ('ab', %d, %d, '%h')", $site_id, $id, $data[1]);
							}
						}
						else
						{
							DB::query("DELETE FROM {rewrite} WHERE module_name='ab' AND param_id=%d", $id);
						}
						$sort--;
						$ids[] = $id;
					}
				}
				else
				{
					$ids = array();
					if(! empty($_POST["paramv"]))
					{
						$sort = count($_POST["paramv"]);
						foreach ($_POST["paramv"] as $key => $value)
						{
							$value = trim($value);
							if (! $value)
								continue;

							$id = 0;
							if ( ! empty($_POST["param_id"][$key]))
							{
								$id = $_POST["param_id"][$key];
							}
							if ($id)
							{
								DB::query("UPDATE {ab_param_select} SET [name]='%h', sort=%d WHERE id=%d", $value, $sort, $id);
							}
							else
							{
								$id = DB::query("INSERT INTO {ab_param_select} (param_id, [name], sort) VALUES (%d, '%h', %d)", $this->diafan->save, $value, $sort);
							}
							$sort--;

							if ( ! empty($_POST["param_rewrite"][$key]))
							{
								if(empty($site_id))
								{
									$site_id = DB::query_result("SELECT id FROM {site} WHERE [act]='1' AND trash='0' AND module_name='ab' LIMIT 1");
								}
								$rewrite = DB::query_fetch_array("SELECT id, rewrite, site_id FROM {rewrite} WHERE module_name='ab' AND param_id=%d LIMIT 1", $id);
								if ( ! empty($rewrite["id"]))
								{
		
									if ($rewrite["rewrite"] != trim($_POST["param_rewrite"][$key]) || $site_id != $rewrite["site_id"])
									{
										DB::query("UPDATE {rewrite} SET site_id=%d, rewrite='%h' WHERE param_id=%d", $site_id, trim($_POST["param_rewrite"][$key]), $id);
									}
								}
								else
								{
									DB::query("INSERT INTO {rewrite} (module_name, site_id, param_id, rewrite) VALUES ('ab', %d, %d, '%h')", $site_id, $id, trim($_POST["param_rewrite"][$key]));
								}
							}
							else
							{
								DB::query("DELETE FROM {rewrite} WHERE module_name='ab' AND param_id=%d", $id);
							}
							$ids[] = $id;
						}
					}
				}

				if ( ! empty($ids))
				{
					$del_ids = array();
					$result = DB::query("SELECT id FROM {ab_param_select} WHERE param_id=%d AND id NOT IN (%s)", $this->diafan->save, implode(",", $ids));
					while($row = DB::fetch_array($result))
					{
						$del_ids[] = $row["id"];
					}
					DB::free_result($result);
					if($del_ids)
					{
						DB::query("DELETE FROM {ab_param_select} WHERE id IN (%s)", implode(",", $del_ids));
						DB::query("DELETE FROM {ab_param_element} WHERE param_id=%d AND value".$this->diafan->language_base_site." IN (%s)", $this->diafan->save, implode(",", $del_ids));
						DB::query("DELETE FROM {rewrite} WHERE module_name='ab' AND param_id IN (%s)", implode(",", $del_ids));
					}
				}

				break;
			case "checkbox":

				if ($this->diafan->oldrow["type"] == "checkbox" && ($_POST["paramk_check1"] || $_POST["paramk_check0"]))
				{
					$result = DB::query("SELECT id, value FROM {ab_param_select} WHERE param_id=%d", $this->diafan->save);
					while ($row = DB::fetch_array($result))
					{
						if ($row["value"] == 1)
						{
							DB::query("UPDATE {ab_param_select} SET [name]='%h' WHERE id=%d", $_POST["paramk_check1"], $row["id"]);
							$check1 = true;
						}
						elseif ($row["value"] == 0)
						{
							DB::query("UPDATE {ab_param_select} SET [name]='%h' WHERE id=%d", $_POST["paramk_check0"], $row["id"]);
							$check0 = true;
						}
					}
					DB::free_result($result);
					DB::query("DELETE FROM {ab_param_select} WHERE param_id=%d AND value NOT IN (0,1)", $this->diafan->save);
				}
				else
				{
					DB::query("DELETE FROM {ab_param_select} WHERE param_id=%d", $this->diafan->save);
				}
				if (empty($check0) && $_POST["paramk_check0"])
				{
					DB::query("INSERT INTO {ab_param_select} (param_id, value, [name]) VALUES (%d, 0, '%h')", $this->diafan->save, $_POST["paramk_check0"]);
				}
				if (empty($check1) && $_POST["paramk_check1"])
				{
					DB::query("INSERT INTO {ab_param_select} (param_id, value, [name]) VALUES (%d, 1, '%h')", $this->diafan->save, $_POST["paramk_check1"]);
				}

				break;

			default:
				DB::query("DELETE FROM {ab_param_select} WHERE param_id=%d", $this->diafan->save);
		}
		Customization::inc('modules/attachments/admin/attachments.admin.inc.php');
		$attachment = new Attachments_admin_inc($this->diafan);
		$attachment->save_config_param();

		Customization::inc('modules/images/admin/images.admin.inc.php');
		$images = new Images_admin_inc($this->diafan);
		$images->save_config_param();
	}

	/**
	 * Сохранение поля "Отдельная страница для значений"
	 * 
	 * @return void
	 */
	public function save_variable_page()
	{
		$this->diafan->set_query("page='%d'");
		$this->diafan->set_value(($_POST["type"] == 'multiple' || $_POST["type"] == 'select') && ! empty($_POST["page"]) ? 1 : 0);
	}

	/**
	 * Сохранение поля "Категория"
	 * 
	 * @return void
	 */
	public function save_variable_category()
	{
		DB::query("DELETE FROM {ab_param_category_rel} WHERE element_id=%d", $this->diafan->save);
		if(! empty($_POST["cat_ids"]) && in_array("all", $_POST["cat_ids"]))
		{
			$_POST["cat_ids"] = array();
		}

		if(! empty($_POST["cat_ids"]))
		{
			foreach ($_POST["cat_ids"] as $cat_id)
			{
				DB::query("INSERT INTO {ab_param_category_rel} (element_id, cat_id) VALUES(%d, %d)", $this->diafan->save, $cat_id);
			}
		}
		else
		{
			DB::query("INSERT INTO {ab_param_category_rel} (element_id) VALUES(%d)", $this->diafan->save);
		}
	}
}