<?php
/**
 * Шаблон список объявлений
 *
 * Шаблон вывода списка объявлений
 * в категории объявлений, в результатах поиска или если группировка не используется
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */
if (!defined('DIAFAN'))
{
    include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

if(empty($result["ajax"]))
{
	echo '<div class="ab_list">';
}

//вывод описания текущей категории
if (!empty($result["text"]))
{
	echo '<div class="ab_cat_text">';
	$this->htmleditor($result['text'], true);
	echo '</div>';
}

//рейтинг категории
if (! empty($result["rating"]))
{
	echo $result["rating"];
}

//вывод изображений текущей категории
if (!empty($result["img"]))
{
	echo '<div class="ab_cat_all_img">';
	foreach ($result["img"] as $img)
	{
		switch ($img["type"])
		{
			case 'animation':
				echo '<a href="'.BASE_PATH.$img["link"].'" rel="prettyPhoto[gallery'.$result["id"].'as]">';
				break;
			case 'large_image':
				echo '<a href="'.BASE_PATH.$img["link"].'" rel="large_image" width="'.$img["link_width"].'" height="'.$img["link_height"].'">';
				break;
			default:
				echo '<a href="'.BASE_PATH_HREF.$img["link"].'">';
				break;
		}
		echo '<img src="'.$img["src"].'" width="'.$img["width"].'" height="'.$img["height"].'" alt="'.$img["alt"].'" title="'.$img["title"].'">'
		. '</a> ';
	}
	echo '</div>';
}

//вывод подкатегории
if (!empty($result["children"]))
{
	foreach ($result["children"] as $child)
	{
		echo '<div class="ab_cat_link">';

		//вывод изображений подкатегории
		if (!empty($child["img"]))
		{
			echo '<div class="ab_cat_img">';
			foreach ($child["img"] as $img)
			{
				switch ($img["type"])
				{
					case 'animation':
						echo '<a href="'.BASE_PATH.$img["link"].'" rel="prettyPhoto[gallery'.$child["id"].'as]">';
						break;
					case 'large_image':
						echo '<a href="'.BASE_PATH.$img["link"].'" rel="large_image" width="'.$img["link_width"].'" height="'.$img["link_height"].'">';
						break;
					default:
						echo '<a href="'.BASE_PATH_HREF.$img["link"].'">';
						break;
				}
				echo '<img src="'.$img["src"].'" width="'.$img["width"].'" height="'.$img["height"].'" alt="'.$img["alt"].'" title="'.$img["title"].'">'
				. '</a> ';
			}
			echo '</div>';
		}

		//название и ссылка подкатегории
		echo '<a href="'.BASE_PATH_HREF.$child["link"].'">'.$child["name"].' ('.$child["count"].')</a>';

		//рейтинг подкатегории
		if (! empty($child["rating"]))
		{
			echo $child["rating"];
		}

		//краткое описание подкатегории
		if ($child["anons"])
		{
			echo '<div class="ab_cat_anons">';
			$this->htmleditor($child['anons']);
			echo '</div>';
		}

		//вывод списка объявлений подкатегории
		if (!empty($child["rows"]))
		{
			//вывод сортировки объявлений
			if(! empty($child["link_sort"]))
			{
				$this->get('sort_block', 'ab', $result);
			}
		
			foreach ($child["rows"] as $row)
			{
				echo '<table class="ab"><tr><td colspan=2 valign=top>';
		
				//вывод названия и ссылки
				echo '<div class="ab_name">';
				echo '<a href="'.BASE_PATH_HREF.$row["link"].'">'.$row["name"].'</a>';
				//рейтинг объявления
				if (!empty($row["rating"]))
				{
					echo ' '.$row["rating"];
				}
				echo '</div>';
		
				echo '</td></tr><tr><td valign=top width=5%>';
		
				//вывод изображений объявления
				if (!empty($row["img"]))
				{
					echo '<div class="ab_img">';
					foreach ($row["img"] as $img)
					{
						switch ($img["type"])
						{
							case 'animation':
								echo '<a href="'.BASE_PATH.$img["link"].'" rel="prettyPhoto[gallery'.$row["id"].'as]">';
								break;
							case 'large_image':
								echo '<a href="'.BASE_PATH.$img["link"].'" rel="large_image" width="'.$img["link_width"].'" height="'.$img["link_height"].'">';
								break;
							default:
								echo '<a href="'.BASE_PATH_HREF.$img["link"].'">';
								break;
						}
						echo '<img src="'.$img["src"].'" width="'.$img["width"].'" height="'.$img["height"].'" alt="'.$img["alt"].'" title="'.$img["title"].'">'
						. '</a> ';
					}
					echo '</div>';
				}
		
				echo '</td>';
				echo '<td valign=top>';

				// автор
				if (! empty($row["author"]))
				{
					echo '<div class="ab_author">'.$this->diafan->_('Автор').': ';
					if(is_array($row["author"]))
					{
						$name = $row["author"]["fio"].($row["author"]["name"] ? ' ('.$row["author"]["name"].')' : '');
						if (! empty($row["author"]["avatar"]))
						{
							echo '<img src="'.$row["author"]["avatar"].'" width="'.$row["author"]["avatar_width"].'" height="'.$row["author"]["avatar_height"].'" alt="'.$row["author"]["fio"].' ('.$row["author"]["name"].')" class="avatar"> ';
						}
						if(! empty($row["author"]["user_page"]))
						{
							$name = '<a href="'.$row["author"]["user_page"].'">'.$name.'</a>';
						}
					}
					else
					{
						$name = $row["author"];
					}
					echo $name.'</div>';
				}
		
				//дата
				if (! empty($row["date"]))
				{
					echo '<div class="ab_date">'.$row["date"].'</div>';
				}
		
				//вывод параметров объявления
				if (!empty($row["param"]))
				{
					$this->get('param', 'ab', array("rows" => $row["param"], "id" => $row["id"]));
				}
				//вывод краткого описания объявления
				if (!empty($row["anons"]))
				{
					echo '<div class="ab_anons">';
					$this->htmleditor($row['anons']);
					echo '</div>';
				}

				//теги объявления
				if (!empty($row["tags"]))
				{
					echo $row["tags"];
				}
				echo '</td></tr></table>';
			}
			echo '<div class="clear"></div>';
		}
		echo '</div>';
	}
}

//вывод списка объявлений
if (!empty($result["rows"]))
{
	//вывод сортировки объявлений
	if(! empty($result["link_sort"]))
	{
		$this->get('sort_block', 'ab', $result);
	}
	echo '<table>';

	foreach ($result["rows"] as $row)
	{
		echo '<tr class="ab">
			<td>';
			//дата
			if (! empty($row["date"]))
			{
				echo '<div class="ab_date">'.$row["date"].'</div>';
			}

			// автор
			if (! empty($row["author"]))
			{
				echo '<div class="ab_author">'.$this->diafan->_('Автор').': ';
				if(is_array($row["author"]))
				{
					$name = $row["author"]["fio"].($row["author"]["name"] ? ' ('.$row["author"]["name"].')' : '');
					if (! empty($row["author"]["avatar"]))
					{
						echo '<img src="'.$row["author"]["avatar"].'" width="'.$row["author"]["avatar_width"].'" height="'.$row["author"]["avatar_height"].'" alt="'.$row["author"]["fio"].' ('.$row["author"]["name"].')" class="avatar"> ';
					}
					if(! empty($row["author"]["user_page"]))
					{
						$name = '<a href="'.$row["author"]["user_page"].'">'.$name.'</a>';
					}
				}
				else
				{
					$name = $row["author"];
				}
				echo $name.'</div>';
			}
			
			echo '</td><td width="30%">';
			
			//вывод названия и ссылки
			echo '<div class="ab_name">';
			echo '<a href="'.BASE_PATH_HREF.$row["link"].'">'.$row["name"].'</a>';
			//рейтинг объявления
			if (!empty($row["rating"]))
			{
				echo ' '.$row["rating"];
			}
			echo '</div>';
			if (!empty($row["anons"]))
			{
				echo '<div class="ab_anons">';
				$this->htmleditor($row['anons']);
				echo '</div>';
			}

			//теги объявления
			if (!empty($row["tags"]))
			{
				echo $row["tags"];
			}

			echo '</td><td>';

			//вывод изображений объявления
			if (!empty($row["img"]))
			{
				echo '<div class="ab_img">';
				foreach ($row["img"] as $img)
				{
					switch ($img["type"])
					{
						case 'animation':
							echo '<a href="'.BASE_PATH.$img["link"].'" rel="prettyPhoto[gallery'.$row["id"].'as]">';
							break;
						case 'large_image':
							echo '<a href="'.BASE_PATH.$img["link"].'" rel="large_image" width="'.$img["link_width"].'" height="'.$img["link_height"].'">';
							break;
						default:
							echo '<a href="'.BASE_PATH_HREF.$img["link"].'">';
							break;
					}
					echo '<img src="'.$img["src"].'" width="'.$img["width"].'" height="'.$img["height"].'" alt="'.$img["alt"].'" title="'.$img["title"].'">'
					. '</a> ';
				}
				echo '</div>';
			}

			echo '</td><td>';

			//вывод параметров объявления
			if (!empty($row["param"]))
			{
				$this->get('param', 'ab', array("rows" => $row["param"], "id" => $row["id"]));
			}
			
			echo '</td><td class="ab_actions">';

			//ссылка на редактирование
			if ($row["edit_access"])
			{
				echo '<a href="'.BASE_PATH_HREF.$row["edit_link"].'"><img src="'.BASE_PATH.'modules/ab/img/edit.gif" width="12" height="14"'
				.' title="'.$this->diafan->_('Редактировать', false).'" alt="'.$this->diafan->_('Редактировать', false).'"></a>';
			}

			//ссылка на блокирование/разблокирование
			if ($row["block_access"])
			{
				echo ' <a href="'.BASE_PATH_HREF.$row["block_link"].'"><img src="'.BASE_PATH.'modules/ab/img/'.(empty($row["unblock"]) ? 'un' : '').'block.gif" width="12" height="18"'
				.' title="'.$this->diafan->_((! empty($row["unblock"]) ? 'Разблокировать' : 'Блокировать'), false).'" alt="'.$this->diafan->_((! empty($row["unblock"]) ? 'Разблокировать' : 'Блокировать'), false).'"></a>';
			}

			//ссылка на удаление
			if ($row["delete_access"])
			{
				echo ' <a href="'.BASE_PATH_HREF.$row["delete_link"].'"><img src="'.BASE_PATH.'modules/ab/img/delete.gif" width="15" height="15"'
				.' title="'.$this->diafan->_('Удалить', false).'" alt="'.$this->diafan->_('Удалить', false).'"></a>';
			}
			echo '</td></tr>';
	}
	echo '</table>';
}

//постраничная навигация
if (!empty($result["paginator"]))
{
	echo $result["paginator"];
}

//вывод комментариев ко всей категории объявлений (комментарии к конкретному товару в функции id())
if (!empty($result["comments"]))
{
	echo $result["comments"];
}

//ссылки на предыдущую и последующую категории
if (!empty($result["previous"]) || !empty($result["next"]))
{
	echo '<div class="previous_next_links">';
	if (!empty($result["previous"]))
	{
		echo '<div class="previous_link"><a href="'.BASE_PATH_HREF.$result["previous"]["link"].'">&larr; '.$result["previous"]["text"].'</a></div>';
	}
	if (!empty($result["next"]))
	{
		echo '<div class="next_link"><a href="'.BASE_PATH_HREF.$result["next"]["link"].'">'.$result["next"]["text"].' &rarr;</a></div>';
	}
	echo '</div>';
}

if(empty($result["ajax"]))
{
	echo '</div>';

	//форма добавления объявления
	if (! empty($result["form"]))
	{
		$this->get('form', 'ab', $result["form"]);
	}
}
echo '<script type="text/javascript" src="'.BASE_PATH.'modules/ab/js/ab.js"></script>';