<?php
/**
 * Контроллер
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Bs
 */
class Bs extends Controller
{
	/**
	 * Шаблонная функция: выводит баннеры
	 * 
	 * @param array $attributes атрибуты шаблонного тега
	 * count - количество выводимых баннеров. По умолчанию 1. Значение **all** выведет все баннеры
	 * id - идентификатор баннера, если задан, атрибут **count** игнорируется
	 * sort - сортировка баннеров: **date** – по дате (по умолчанию), **rand** – в случайном порядке
	 * cat_id - категория баннеров, если в настройках модуля отмечено «Использовать категории»
	 * template - шаблон тега (файл modules/bs/views/bs.view.show_block_**template**.php; по умолчанию шаблон modules/bs/views/bs.view.show_block.php)
	 * 
	 * @return void
	 */
	public function show_block($attributes)
	{
		$attributes = $this->get_attributes($attributes, 'count', 'id', 'sort', 'cat_id', 'template');
		
		$id   = intval($attributes["id"]);
		$sort = ($attributes["sort"] ? $attributes["sort"] : 'date');
		if($attributes["count"] === "all")
		{
			$count = "all";
		}
		else
		{
			$count   = intval($attributes["count"]);
			if($count < 1)
			{
				$count = 1;
			}
		}
		$cat_id  = intval($attributes["cat_id"]);

		$result = $this->model->show_block($id, $count, $sort, $cat_id);
		if (! $attributes["template"] || ! $this->diafan->_tpl->get('show_block_'.$attributes["template"], 'bs', $result))
		{
			$this->diafan->_tpl->get('show_block', 'bs', $result);
		}
	}
}