<?php
/**
 * Редактирование вопросов для капчи
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Captcha_admin
 */
class Captcha_admin extends Frame_admin
{
	/**
	 * @var string таблица в базе данных
	 */
	public $table = 'captcha';

	/**
	 * @var array поля в базе данных для редактирования
	 */
	public $variables = array (
		'main' => array (
			'name' => array(
				'type' => 'text',
				'name' => 'Вопрос',  
				'help' => 'Вопрос, на который должен ответить посетитель сайта для того, чтобы пройти проверку.',
				'multilang' => true,
			),
			'act' => array(
				'type' => 'checkbox',
				'name' => 'Опубликовать на сайте',
				'help' => 'Если не отмечено, то вопрос не будет участвовать в проверке.',
				'default' => true,
				'multilang' => true,
			),
			'answers' => array(
				'type' => 'function',
				'name' => 'Ответы',
				'help' => 'Возможные варианты ответов с указанием правильного.',
			),
		),
	);

	/**
	 * @var array настройки модуля
	 */
	public $config = array (
		'del', // удалить
		'act', // показать/скрыть
		'trash', // использовать корзину
	);

	/**
	 * Выводит ссылку на добавление
	 * @return void
	 */
	public function show_add()
	{
		echo '<center>CAPTCHA - фильтр спам-ботов и реальных пользователей сайта, которые оставляют сообщения в формах различных модулей сайта, таких как «Обратная связь», «Комментарии», «Обратная связь», «Форум» и т.д. Капча может быть трех видов, классический «Код на картинке», более сложная вариация «reCAPTCHA», или «Вопрос-Ответ», когда администратор задает вопрос и варианты ответа, а пользователь должен выбрать правильный, чтобы его сообщение было принято на сайте.</center><br><br>';
		if($this->diafan->configmodules('type') != 'qa')
		{
			echo '<div class="error">'.sprintf($this->diafan->_('Настройке подлежит только капча «Вопрос-Ответ». Выберите в  %sнастройках%s модуля необходимый вид капчи для модулей.'), '<a href="'.BASE_PATH_HREF.'captcha/config/">', '</a>').'</div>';
		}
		else {
			echo "<h2>Вопрос-Ответ</h2>";
			$this->diafan->addnew_init('Добавить вопрос');
		}
	}

	/**
	 * Выводит список вопросов
	 * @return void
	 */
	public function show()
	{
		if($this->diafan->configmodules('type') == 'qa')
		{
			$this->diafan->list_row();
		}
	}

	/**
	 * Редактирование поля "Ответы"
	 * @return void
	 */
	public function edit_variable_answers()
	{
		$answers = array();
		if(! $this->diafan->addnew)
		{
			$result = DB::query("SELECT id, [text], is_right FROM {captcha_answers} WHERE captcha_id=%d", $this->diafan->edit);
			while($row  = DB::fetch_array($result))
			{
				$answers[] = $row;
			}
			DB::free_result($result);
		}
		echo '
		<script type="text/javascript" src="'.BASE_PATH.'modules/captcha/admin/captcha.admin.js"></script>
		<tr valign="top">
			<td class="td_first">'.$this->diafan->variable_name().'</td>
			<td><table>';
		foreach($answers as $row)
		{
			echo '<tr class="param"><td>
				<input type="hidden" name="answer_id[]" value="'.$row["id"].'">
				<input type="text" name="answer_text[]" size="20" value="'.str_replace('"', '&quot;', $row["text"]).'">
				<input type="hidden" name="answer_is_right[]" value="'.$row["is_right"].'">
				<input type="radio" name="is_right" class="answer_is_right"'.($row["is_right"] ? ' checked' : '').'>
				'.$this->diafan->_('правильный ответ').'
				<span class="param_actions">
					<a href="javascript:void(0)" action="delete_param" confirm="'.$this->diafan->_('Вы действительно хотите удалить запись?').'"><img src="'.BASE_PATH.'adm/img/delete.png" width="13" height="13" alt="'.$this->diafan->_('Удалить').'"></a>
				</span>
			</td></tr>';
			
		}
		echo '<tr class="param"><td>
				<input type="hidden" name="answer_id[]" value="">
				<input type="text" name="answer_text[]" size="20" value="">
				<input type="hidden" name="answer_is_right[]" value="">
				<input type="radio" name="is_right" '.(empty($answers) ? ' checked' : '').'>
				'.$this->diafan->_('правильный ответ').'
				<span class="param_actions">
					<a href="javascript:void(0)" action="delete_param" confirm="'.$this->diafan->_('Вы действительно хотите удалить запись?').'"><img src="'.BASE_PATH.'adm/img/delete.png" width="13" height="13" alt="'.$this->diafan->_('Удалить').'"></a>
				</span>
			</td></tr>
			</table>
			<a href="javascript:void(0)" class="param_plus" title="'.$this->diafan->_('Добавить').'"><img src="'.BASE_PATH.'adm/img/add.png" width="16" height="16" alt="'.$this->diafan->_('Добавить').'"></a>
			'.$this->diafan->help().'
			</td>
		</tr>';
	}

	/**
	 * Сохранение поля "Ответы"
	 * @return void
	 */
	public function save_variable_answers()
	{
		if(! empty($_POST["answer_text"]))
		{
			foreach($_POST["answer_text"] as $i => $text)
			{
				if(empty($text))
					continue;

				if(! empty($_POST["answer_id"][$i]))
				{
					DB::query("UPDATE {captcha_answers} SET [text]='%h', is_right='%d' WHERE id=%d AND captcha_id=%d", $text, $_POST["answer_is_right"][$i], $_POST["answer_id"][$i], $this->diafan->save);
					$id = intval($_POST["answer_id"][$i]);
					if($id)
					{
						$ids[] = $id;
					}
				}
				else
				{
					$ids[] = DB::query("INSERT INTO {captcha_answers} ([text], is_right, captcha_id) VALUES ('%h', '%d', %d)", $text, $_POST["answer_is_right"][$i], $this->diafan->save);
				}
			}
		}
		DB::query("DELETE FROM {captcha_answers} WHERE ".(! empty($ids) ? "id NOT IN(".implode(",", $ids).") AND" : "")." captcha_id=%d", $this->diafan->save);
	}

	/**
	 * Сопутствующие действия при удалении элемента модуля
	 * @return void
	 */
	public function delete($del_id, $trash_id)
	{
		$this->diafan->del_or_trash_where("captcha_answers", "captcha_id=".$del_id, $trash_id);
	}
}