<?php
/**
 * Обработка Ajax-запросов
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */
if (!defined('DIAFAN'))
{
include dirname(dirname(dirname(__FILE__))) . '/includes/404.php';
}

/**
 * Cart_ajax
 *
 */
class Cart_ajax extends Ajax 
{
	/**
	 * Обрабатывает полученные данные из формы
	 * 
	 * @return boolean
	 */
	public function ajax_request()
	{
		if (! empty($_POST['module']) && $_POST['module'] == 'cart' && (! $this->diafan->configmodules('security_user', 'shop') || $this->diafan->_user->id) || empty($_POST["action"]))
		{
			switch($_POST["action"])
			{
				case 'recalc':
					return $this->recalc();

				case 'order':
					return $this->order();

				case 'one_click':
					return $this->one_click();

				case 'upload_image':
					return $this->upload_image();

				case 'delete_image':
					return $this->delete_image();

				default :
					return false;
			}
		}
		return false;
	}

	/**
	 * Пересчет суммы заказа
	 * 
	 * @return boolean
	 */
	private function recalc()
	{
		$cart = $this->diafan->_cart->get();
		$newcount = 0;
		if ($cart)
		{
			foreach ($cart as $good_id => $array)
			{
				foreach ($array as $param => $c)
				{
					$index = $good_id.'_'.str_replace(array('{',':',';','}',' ','"',"'"), '', $param);
					if (! empty($_POST['del'.$index]))
					{
						$_POST['editshop'.$index] = 0;
					}
					$newcount += $_POST['editshop'.$index];
					if($err = $this->diafan->_cart->set($_POST['editshop'.$index], $good_id, $param, "count"))
					{
						$json["error"] = $err;
					}
				}
			}
		}

		if (empty($json["error"]))
		{
			$this->diafan->_cart->write();

			$json["error"] = $this->diafan->_('Изменения сохранены!', false);
		}
		if(! $newcount)
		{
			include_once ABSOLUTE_PATH.'plugins/json.php';
			$json["redirect"] = BASE_PATH_HREF.$this->diafan->_route->module('cart', true);
			echo to_json($json);
			exit;
		}

		$_SESSION["cart_delivery"] = $this->diafan->get_param($_POST, 'delivery_id', 0, 2);

		$_SESSION["cart_additional_cost"] = array();
		if(! empty($_POST["additional_cost_ids"]))
		{
			foreach ($_POST["additional_cost_ids"] as $additional_cost_id)
			{
				$_SESSION["cart_additional_cost"][] = intval($additional_cost_id);
			}
		}

		if (!empty($_POST['ajax']))
		{
			Customization::inc('modules/cart/cart.model.php');
			$model  = new Cart_model($this->diafan);
			$result = $model->form_table();

			$json["table"] = $this->diafan->_tpl->get('table', 'cart', $result);
			if (! $this->diafan->_cart->get())
			{
				$json["empty"] = 1;
			}
			$json["target"]           = "#show_cart";
			$cart_tpl = $model->show_block();
			$json["data"]             = $this->diafan->_tpl->get('info', 'cart', $cart_tpl);

			include_once ABSOLUTE_PATH.'plugins/json.php';
			echo to_json($json);
		}
		else
		{
			$this->diafan->redirect($this->diafan->_route->current_link() . '?error=cart&mess-table=' . $json["error"]);
		}
		return true;
	}

	/**
	 * Оформление заказа
	 * 
	 * @return boolean
	 */
	private function order()
	{
		$this->module = 'shop';
		$this->tag = 'cart';
		$where = "show_in_form".($_POST["action"] == "one_click" ? "_one_click" : '')."='1'";
		$params = $this->get_params(array("module" => "shop", "table" => "shop_order", "where" => $where, "fields" => "info"));

		$this->empty_required_field(array("params" => $params));

		if ($this->send_errors())
			return true;

		$summ = 0;
		$status_id = DB::query_result("SELECT id FROM {shop_order_status} WHERE status='0' LIMIT 1");

		$order_id = DB::query("INSERT INTO {shop_order} (user_id, created, status, status_id, lang_id) VALUES (%d, %d, '0', %d, %d)",
			$this->diafan->_user->id,
			time(),
				$status_id,
			_LANG
		);

		if(! empty($_POST["tmpcode"]))
		{
			DB::query("UPDATE {images} SET element_id=%d, tmpcode='' WHERE module_name='shop_order' AND element_id=0 AND tmpcode='%s'", $order_id, $_POST["tmpcode"]);
		}

		$this->insert_values(array("id" => $order_id, "table" => "shop_order", "params" => $params));

		if ($this->send_errors())
			return true;

		// товары
		$goods_summ = 0;
		$cart = $this->diafan->_cart->get();
		foreach ($cart as $good_id => $array)
		{
			foreach ($array as $param => $c)
			{
				$price = 0;
				$select_depend = 0;
				$sparams = unserialize($param);

				$shop_good_id = DB::query("INSERT INTO {shop_order_goods} (order_id, good_id, count_goods) VALUES (%d, %d, %d)", $order_id, $good_id, $c["count"]);

				foreach ($sparams as $id => $value)
				{
					DB::query("INSERT INTO {shop_order_goods_param} (order_good_id, value, param_id) VALUES ('%d', '%d', '%d')", $shop_good_id, $value, $id);
				}	 
				$row = $this->diafan->_shop->price_get($good_id, $sparams);

				DB::query("UPDATE {shop_order_goods} SET price=%f, discount_id=%d WHERE id=%d", $row["price"], $row["discount_id"], $shop_good_id);
				$goods_summ += $row["price"] * $c["count"];
			}
		}
		$summ += $goods_summ;

		if($discount = $this->get_discount_total($goods_summ))
		{
			$summ -= $discount["discount_summ"];
		}
		else
		{
			$discount["discount_summ"] = 0;
			$discount["discount_id"] = 0;
		}

		// дополнительная стоимость
		$cart_additional_cost = ! empty($_SESSION["cart_additional_cost"]) ? $_SESSION["cart_additional_cost"] : array();
		$result = DB::query("SELECT id, price, percent, amount, required FROM {shop_additional_cost} WHERE [act]='1' AND trash='0'");
		while ($row = DB::fetch_array($result))
		{
			if (in_array($row["id"], $cart_additional_cost) || $row["required"])
			{
				$row["summ"] = $row['price'];
				if($row['percent'])
				{
					$row["summ"] = $goods_summ * $row['percent'] / 100;
				}
				if (! empty($row['amount']))
				{
					if ($row['amount'] < $goods_summ)
					{
						$row["summ"] = 0;
					}
				}
				DB::query("INSERT INTO {shop_order_additional_cost} (order_id, additional_cost_id, summ) VALUES (%d, %d, %f)", 
						$order_id, $row["id"], $row["summ"]);
				$summ += $row['summ'];
			}
		}
		DB::free_result($result);

		// доставка
		$delivery_summ = 0;
		$delivery_id = 0;
		if(! empty($_SESSION["cart_delivery"]))
		{
			$result = DB::query("SELECT id FROM {shop_delivery} WHERE [act]='1' AND trash='0'AND id=%d LIMIT 1", $_SESSION["cart_delivery"]);
			if ($row = DB::fetch_array($result))
			{
				$delivery_summ = DB::query_result("SELECT price FROM {shop_delivery_thresholds} WHERE delivery_id=%d AND amount<=%f ORDER BY amount DESC LIMIT 1", $_SESSION["cart_delivery"], $summ);
				$delivery_id = $row["id"];
				$summ += $delivery_summ;
			}
			DB::free_result($result);
			DB::query("UPDATE {shop_order} SET delivery_summ=%f, delivery_id=%d WHERE id=%d", $delivery_summ, $delivery_id, $order_id);
		}
		DB::query("UPDATE {shop_order} SET summ=%f, discount_id=%d, discount_summ=%f WHERE id=%d", $summ, $discount["discount_id"], $discount["discount_summ"], $order_id);
		
		$this->send_mails($order_id, $params);
		$this->send_sms();

		$_SESSION["order"][] = $order_id;

		$this->diafan->_cart->set();
		$this->diafan->_cart->write();

		unset($_SESSION["cart_delivery"]);
		unset($_SESSION["cart_additional_cost"]);

		// если у пользователя купон на скидку с ограниченным действием, используем один раз купон
		$coupon_result = DB::query("SELECT c.id, c.count_use, c.used, c.discount_id FROM {shop_discount} AS d"
			." INNER JOIN {shop_discount_coupon} AS c ON c.discount_id=d.id"
			." INNER JOIN {shop_discount_person} AS p ON p.discount_id=d.id AND p.coupon_id=c.id"
			." WHERE d.act='1' AND d.trash='0' AND (c.count_use=0 OR c.count_use>c.used) AND (p.user_id>0 AND p.user_id=%d OR p.session_id='%s')"
			." GROUP BY c.id",
			$this->diafan->_user->id, session_id());
		while($coupon = DB::fetch_array($coupon_result))
		{
			DB::query("UPDATE {shop_discount_coupon} SET used=used+1 WHERE id=%d", $coupon["id"]);
			if(! DB::query_result("SELECT COUNT(*) FROM {shop_discount_coupon} WHERE discount_id=%d AND (count_use=0 OR count_use>used)", $coupon["discount_id"]))
			{
				DB::query("UPDATE {shop_discount} SET act='0' WHERE id=%d", $coupon["discount_id"]);
				$this->diafan->_shop->price_calc(0, $coupon["discount_id"]);
			}
		}
		DB::free_result($coupon_result);
		if(empty($_POST["payment_id"]))
		{
			if($this->diafan->configmodules('order_redirect', 'shop'))
			{
				if(preg_match("/^[0-9]+$/", $this->diafan->configmodules('order_redirect', 'shop')))
				{
					$this->result["redirect"] = BASE_PATH_HREF.$this->diafan->_route->link($this->diafan->configmodules('order_redirect', 'shop'));
				}
				else
				{
					$this->result["redirect"] = BASE_PATH_HREF.$this->diafan->configmodules('order_redirect', 'shop');
				}
			}
			else
			{
				$this->result["form_hide"] = true;
				$this->result["target_hide"] = '.cart_table_form';
				$this->result["form"] = $this->diafan->configmodules('mes', 'shop');
			}
		}
		else
		{
			DB::query("UPDATE {shop_order} SET payment_id=%d WHERE id=%d", $_POST["payment_id"], $order_id);
			$payment = DB::query_fetch_array("SELECT payment, [text] FROM {shop_payment} WHERE id=%d LIMIT 1", $_POST["payment_id"]);
			
			if($payment["payment"])
			{
				$this->result["redirect"] = BASE_PATH_HREF.$this->diafan->_route->link($this->diafan->cid, "cart").'step2/show'.$order_id.'/';
			}
			elseif($this->diafan->configmodules('order_redirect', 'shop'))
			{
				if(preg_match("/^[0-9]+$/", $this->diafan->configmodules('order_redirect', 'shop')))
				{
					$this->result["redirect"] = BASE_PATH_HREF.$this->diafan->_route->link($this->diafan->configmodules('order_redirect', 'shop'));
				}
				else
				{
					$this->result["redirect"] = BASE_PATH_HREF.$this->diafan->configmodules('order_redirect', 'shop');
				}
			}
			else
			{
				Customization::inc('modules/cart/cart.model.php');
				$model  = new Cart_model($this->diafan);
				$cart_tpl = $model->show_block();
				$this->result["target"] = "#show_cart";
				$this->result["data"]   = $this->diafan->_tpl->get('info', 'cart', $cart_tpl);

				$this->result["target2"] = '.cart_order';
				$this->result["data2"] = $this->diafan->configmodules('mes', 'shop').$this->diafan->_tpl->get('result', 'cart', $payment);

				$this->result["redirect"] = BASE_PATH_HREF.$this->diafan->_route->link($this->diafan->cid, "cart").'#top';
			}
		}

		return $this->send_errors();
	}

	/**
	 * Получает скидку от общей суммы товаров
	 */
	private function get_discount_total($cart_summ)
	{
		$discount = false;
		$order_summ = 0;
		if($this->diafan->_user->id)
		{
			$order_summ = DB::query_result("SELECT SUM(summ) FROM {shop_order} WHERE user_id=%d AND (status='1' OR status='3')", $this->diafan->_user->id);
		}

		//скидка на общую сумму заказа
		$person_discount_ids = $this->diafan->_shop->price_get_person_discounts();
		$result = DB::query("SELECT id, discount, amount, deduction, threshold, threshold_cumulative FROM"
			." {shop_discount} WHERE act='1' AND trash='0' AND (threshold_cumulative>0 OR threshold>0)"
			." AND role_id".($this->diafan->_user->role_id ? ' IN (0, '.$this->diafan->_user->role_id.')' : '=0')
			." AND (person='0'".($person_discount_ids ? " OR id IN(".implode(",", $person_discount_ids).")" : "").")"
			." AND date_start<=%d AND (date_finish=0 OR date_finish>=%d)"
			." AND (threshold_cumulative>0 AND threshold_cumulative<=%f"
			." OR threshold>0 AND threshold<=%f)",
			time(), time(), $order_summ, $cart_summ
		);
		while ($row = DB::fetch_array($result))
		{
			$row["discount_id"] = $row["id"];
			if($row['deduction'])
			{
				if($row['deduction'] < $cart_summ)
				{
					$row["discount_summ"] = $row["deduction"];
				}
				else
				{
					$row["discount_summ"] = 0;
				}
			}
			else
			{
				$row["discount_summ"] = $cart_summ * $row["discount"] / 100;
			}
			if(empty($discount) || $discount["discount_summ"] < $row["discount_summ"])
			{
				$discount = $row;
			}
		}
		DB::free_result($result);
		return $discount;
	}

	/**
	 * Загружает изображение
	 *
	 * @return boolean
	 */
	private function upload_image()
	{
		if(empty($_POST["tmpcode"]))
		{
			return false;
		}
		if(empty($_POST["images_param_id"]))
		{
			return false;
		}
		$param_id = $this->diafan->get_param($_POST, "images_param_id", '', 2);

		$this->result["success"] = true;
		if (! empty($_FILES['images'.$param_id]) && $_FILES['images'.$param_id]['tmp_name'] != '' && $_FILES['images'.$param_id]['name'] != '')
		{
			try
			{
				$this->diafan->_images->upload(0, "shop_order", 0, $_FILES['images'.$param_id]['tmp_name'], $_FILES['images'.$param_id]['name'], false, false, $param_id, $_POST["tmpcode"]);
			}
			catch(Exception $e)
			{
				Dev::$exception_field = 'p'.$param_id;
				Dev::$exception_result = $this->result;
				throw new Exception($e->getMessage());
			}
			$images = $this->diafan->_images->get('large', 0, "shop_order", 0, '', $param_id, false, 0, '', $_POST["tmpcode"]);
			$this->result["data"] = $this->diafan->_tpl->get('images', "shop_order", $images);
		}
		return $this->send_errors();
	}

	/**
	 * Удаляет изображение
	 *
	 * @return boolean
	 */
	private function delete_image()
	{
		if(empty($_POST["id"]))
		{
			return false;
		}
		if(empty($_POST["tmpcode"]))
		{
			return false;
		}
		$row = DB::query_fetch_array("SELECT * FROM {images} WHERE module_name='shop_order' AND id=%d AND tmpcode='%s'", $_POST["id"], $_POST["tmpcode"]);
		if(! $row)
		{
			return false;
		}
		$this->diafan->_images->delete(0, "shop_order", $row["id"]);
		return true;
	}

	/**
	 * Оформление быстрого заказа
	 * 
	 * @return boolean
	 */
	private function one_click()
	{
		if ($this->diafan->configmodules('security_user') && ! $this->diafan->_user->id)
		{
			return false;
		}
		if(! empty($_POST["good_id"]))
		{
				$cart = $this->diafan->_cart->get();
				if ($cart)
				{
					foreach ($cart as $good_id => $array)
					{
						foreach ($array as $param => $c)
						{
							$err = $this->diafan->_cart->set(0, $good_id, $param, "count");
						}
					}
				}
				$good_id = $this->diafan->get_param($_POST, 'good_id', 0, 2);
				$this->tag = 'shop'.$good_id;
		
				$row = DB::query_fetch_array("SELECT id, is_file FROM {shop} WHERE id=%d AND trash='0' AND [act]='1' LIMIT 1", $good_id);
		
				if (empty($row['id']))
				{
					$this->result["errors"][0] = 'ERROR';
					return $this->send_errors();
				}
		
				$params = array();
		
				$result = DB::query(
						"SELECT p.[name], p.id FROM {shop_param} AS p"
						." INNER JOIN {shop_param_element} AS e ON e.element_id=%d AND e.param_id=p.id"
						." WHERE p.`type`='multiple' AND p.required='1' GROUP BY p.id",
						$good_id
					);
				while ($row_param = DB::fetch_array($result))
				{
					if (empty($_POST["param".$row_param["id"]]))
					{
						$this->result["errors"][0] = $this->diafan->_('Пожалуйста, выберите', false).' '.$row_param["name"];
						$this->send_errors();
						return true;
					}
					$params[$row_param["id"]] = $this->diafan->get_param($_POST, "param".$row_param["id"], 0, 2);
				}
				DB::free_result($result);
		
				$count = $this->diafan->get_param($_POST, "count", 1, 2);
				$count = $count > 0 ? $count : 1;
		
				$count_good = $this->diafan->_cart->get($good_id, $params, "count");
				$count_good += $count;
		
				$cart = array(
						"count" => $count_good,
						"is_file" => $row['is_file'],
					);
		
				if($err = $this->diafan->_cart->set($cart, $good_id, $params))
				{
					$this->result["errors"][0] = $err;
					return $this->send_errors();	
				}
				$this->diafan->_cart->write();
		
				DB::query("UPDATE {shop} SET counter_buy=counter_buy+1 WHERE id='%d'", $good_id);
		}
		return $this->order();
	}

	/**
	 * Отправляет письма администратору сайта и пользователю, сделавшему заказ
	 *
	 * @param integer $order_id номер заказа
	 * @param array $params поля формы, заполняемой пользователем
	 * @return boolean
	 */
	public function send_mails($order_id, $params)
	{
		require_once (ABSOLUTE_PATH.'includes/mail.php');

		Customization::inc('modules/cart/cart.model.php');

		$model = new Cart_model($this->diafan);
		$result_cart = $model->form();
		$result_cart["hide_form"] = true;
		$cart = $this->diafan->_tpl->get('table', 'cart', $result_cart);
		$payment_name = '';
		$code = md5(mt_rand(0, 999999999));
		if(! empty($_POST["payment_id"]))
		{
			$payment = DB::query_fetch_array("SELECT [name], payment FROM {shop_payment} WHERE id=%d LIMIT 1", $_POST["payment_id"]);
			$payment_name = $payment["name"];
			if($payment["payment"] == 'non_cash')
			{
				$payment_name .= ', <a href="'.BASE_PATH.'cart/payment/non_cash/ul/'.$order_id.'/'.$code.'/">'.$this->diafan->_('Счет для юридических лиц', false).'</a>,
				<a href="'.BASE_PATH.'cart/payment/non_cash/fl/'.$order_id.'/'.$code.'/">'.$this->diafan->_('Квитанция для физических лиц', false).'</a>';
			}
		}
		DB::query("UPDATE {shop_order} SET `code`='%s' WHERE id=%d", $code, $order_id);

		//send mail admin
		$subject = str_replace(array('%title', '%url', '%id', '%message'),
				   array(TITLE, BASE_URL, $order_id, strip_tags($this->message_admin_param)),
				   $this->diafan->configmodules('subject_admin', 'shop')
				  );

		$message = str_replace(
			array('%title',
				'%url',
				'%id',
				'%message',
				'%order',
				'%payment'
			),
			array(
				TITLE,
				BASE_URL,
				$order_id,
				$this->message_admin_param,
				$cart,
				$payment_name
			),
			$this->diafan->configmodules('message_admin', 'shop'));

		send_mail(
				$this->diafan->configmodules("emailconfadmin", 'shop') ? $this->diafan->configmodules("email_admin", 'shop') : EMAIL_CONFIG,
				$subject,
				$message,
				$this->diafan->configmodules("emailconf", 'shop') ? $this->diafan->configmodules("email", 'shop') : ''
			);

		$user_email = $this->diafan->_user->mail;
		$user_phone = $this->diafan->_user->phone;
		$user_fio = $this->diafan->_user->fio;
		foreach($params as $param)
		{
			if ($param["type"] == "email")
			{
				$user_email = $_POST["p".$param["id"]];
			}
			if ($param["info"] == "phone")
			{
				$user_phone = $_POST["p".$param["id"]];
			}
			if ($param["info"] == "name")
			{
				$user_fio = $_POST["p".$param["id"]];
			}
		}
		if(! empty($user_phone))
		{
			$phone = preg_replace('/[^0-9]+/', '', $user_phone);
			if(! DB::query_result("SELECT id FROM {subscribtion_phones} WHERE phone='%s' AND trash='0'", $user_phone))
			{
				DB::query("INSERT INTO {subscribtion_phones} (phone, name, created, act) VALUES ('%s', '%h', %d, '1')", $user_phone, $user_fio, time());
			}
		}

		//send mail user
		if (empty($user_email))
		{
			return false;
		}
		
		if(! empty($_POST['subscribe_in_order']))
		{
			$row_subscribtion = DB::query_fetch_array("SELECT * FROM {subscribtion_emails} WHERE mail='%s' AND trash='0' LIMIT 1", $user_email);
			
			if(! empty($row_subscribtion))
			{
				DB::query("UPDATE {subscribtion_emails} SET act='1' WHERE id=%d", $row_subscribtion['id']);
			}
			else
			{
				$code = md5(rand(111, 99999));
				DB::query("INSERT INTO {subscribtion_emails} (created, mail, name, code, act) VALUES (%d, '%s', '%s', '%s', '1')", time(), $user_email, $this->diafan->_user->fio, $code);
			}
		}
		
		$subject = str_replace(
				array('%title', '%url', '%id'),
				array(TITLE, BASE_URL, $order_id),
				$this->diafan->configmodules('subject', 'shop')
			);

		$message = str_replace(
				array('%title', '%url', '%id', '%message', '%order', '%payment'),
				array(
					TITLE,
					BASE_URL,
					$order_id,
					$this->message_param,
					$cart,
					$payment_name
				),
				$this->diafan->configmodules('message', 'shop')
			);

		send_mail(
				$user_email,
				$subject,
				$message,
				$this->diafan->configmodules("emailconf", 'shop') ? $this->diafan->configmodules("email", 'shop') : ''
			);
		return true;
	}

	/**
	 * Уведомляет администратора по SMS
	 * 
	 * @return void
	 */
	private function send_sms()
	{
		if (! $this->diafan->configmodules("sendsmsadmin", 'shop'))
			return false;
			
		$message = $this->diafan->configmodules("sms_message_admin", 'shop');

		$to   = $this->diafan->configmodules("sms_admin", 'shop');

		include_once ABSOLUTE_PATH.'includes/sms.php';
		Sms::send($message, $to);
	}
}