<?php
/**
 * Настройки платежной системы «Liqpay» для административного интерфейса
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(dirname(dirname(__FILE__))))).'/includes/404.php';
}

class Cart_payment_liqpay_admin
{
	public $config;

	public function __construct()
	{
		$this->config = array(
			"name" => 'Liqpay',
			"params" => array(
				'merchant_id' => array(
					'name' => 'merchant_id',
					'help' => 'id мерчанта - выдается системой',
				),
				'signature' => array(
					'name' => 'signature',
					'help' => 'сигнатура - выдается системой',
				),
				'result_url' => array(
					'name' => 'result_url',
					'help' => 'http://site.ru/cart/payment/liqpay/',
				),
				'server_url' => array(
					'name' => 'server_url',
					'help' => 'http://site.ru/cart/payment/liqpay/',
				),
				'method' => array(
					'name' => 'method',
					'help' => 'метод оплаты - с карты, с телефона, наличными (card, liqpay, delayed)',
				),
				'currency' => array(
					'name' => 'currency',
					'help' => 'валюта - RUR и т.д.',
				),
				'phone' => array(
					'name' => 'phone',
					'help' => 'телефон, на который приходит SMS при попытке оплатить товар картой',
				),
			)
		);
	}
}