<?php
/**
 * Шаблон таблицы с товарами в корзине
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */
if (!defined('DIAFAN')) {
    include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

//шапка таблицы
$text = '<table class="cart">
	<tr>
		<th class="cart_first_th"></th>
		<th>'.$this->diafan->_('Наименование товара').'</th>
		<th>'.$this->diafan->_('Количество').'</th>
		<th>'.$this->diafan->_('Цена').', '.$result["currency"].'</th>
		'.($result["discount"] ? '
		<th>'.$this->diafan->_('Скидка').'</th>
		<th>'.$this->diafan->_('Цена со скидкой').', '.$result["currency"].'</th>
		' : '').'
		<th>'.$this->diafan->_('Сумма').', '.$result["currency"].'</th>
		'.(empty($result["hide_form"]) ? '<th class="cart_last_th">'.$this->diafan->_('Удалить').'</th>' : '').'
	</tr>';
//товары
if (! empty($result["rows"]))
{
	foreach ($result["rows"] as $row)
	{
		$text .= '
		<tr>
			<td class="cart_img">';
		if (!empty($row["img"]))
		{
			$text .= '<a href="'.BASE_PATH_HREF.$row["link"].'"><img src="'.$row["img"]["src"].'" width="'.$row["img"]["width"].'" height="'.$row["img"]["height"].'" alt="'.$row["img"]["alt"].'" title="'.$row["img"]["title"].'"></a> ';
		}
		$text .= '</td>
			<td class="cart_name">';
			if(! empty($row["cat"]))
			{
				$text .= '<a href="'.BASE_PATH_HREF.$row["cat"]["link"].'">'.$row["cat"]["name"].'</a> / ';
			}
			$text .= '<a href="'.BASE_PATH_HREF.$row["link"].'">'.$row["name"];
			$text .= (!empty($row["article"]) ? '<br/>'.$this->diafan->_('Артикул').': '.$row["article"] : '');
			$text .= '</a></td>
			<td class="cart_count"><nobr>'.(empty($result["hide_form"]) ? ' <span class="cart_count_minus">-</span> <input type="text" value="'.$row["count"].'" name="editshop'.$row["id"].'" class="inpnum" size="2"> <span class="cart_count_plus">+</span> ' : $row["count"]).'</nobr></td>';
			if($result["discount"])
			{
			    $text .= '<td class="cart_old_price">'.($row["discount"] ? $row["old_price"] : '').'</td>';
			    $text .= '<td class="cart_discount">'.($row["discount"] ? $row["discount"] : '').'</td>';
			}
			$text .= '<td class="cart_price">'.$row["price"].'</td>
			<td class="cart_summ">'.$row["summ"].'</td>
			'.(empty($result["hide_form"]) ? '<td class="cart_remove"><span><input type="checkbox" name="del'.$row["id"].'" value="1"></span></td>' : '').'
		</tr>';
	}

	// общая скидка от объема
	if(! empty($result["discount_total"]) || ! empty($result["discount_next"]))
	{
		$text .= '
			<tr>
				<td colspan="3">';
		if(! empty($result["discount_next"]) && empty($result["hide_form"]))
		{
			$text .= $this->diafan->_('До скидки %s осталось %s', true, $result["discount_next"]["discount"], $result["discount_next"]["summ"]);
		}
		$text .= '</td>';
		if($result["discount"])
		{
			$text .= '<td colspan="2">&nbsp;</td>';
		}
		$text .= '<td>&nbsp;</td>
		<td class="cart_discount_total">';
		if(! empty($result["discount_total"]))
		{
			$text .= $this->diafan->_('Скидка').' '.$result["discount_total"]["discount"];
		}
		$text .= '</td>
		'.(empty($result["hide_form"]) ? '<td class="cart_last_td">&nbsp;</td>' : '').'
		</tr>';
	}

	//итоговая строка для товаров
	$text .= '
		<tr class="cart_last_tr">
			<td class="cart_total" colspan="2">'.$this->diafan->_('Итого за товары').'</td>
			<td class="cart_count">'.$result["count"].'</td>';
	if($result["discount"])
	{
		$text .= '<td colspan="2">&nbsp;</td>';
	}
	$text .= '<td>&nbsp;</td>
	<td class="cart_summ">';
	if(! empty($result["discount_total"]))
	{
		$text .= '<div class="cart_summ_old_total">'.$result["old_summ_goods"].'</div>';
	}
	$text .= $result["summ_goods"];
	$text .= '</td>
			'.(empty($result["hide_form"]) ? '<td class="cart_last_td">&nbsp;</td>' : '').'
		</tr>';

	//дополнительно
	if (! empty($result["additional_cost"])) 
	{
		$text .= '<tr><th colspan="'.($result["discount"] ? 7 : 5).'">'.$this->diafan->_('Дополнительно').'</th>
		<th class="cart_last_th">'.$this->diafan->_('Добавить').'</th></tr>';
		foreach($result["additional_cost"] as $row)
		{
			if(! empty($result["hide_form"]) && ! in_array($row["id"], $result["cart_additional_cost"]) && ! $row["required"])
				continue;

			if ($row['amount'])
			{
				$row['text'] .= '<br>'.$this->diafan->_('Бесплатно от суммы').' '.$row['amount'].' '.$result["currency"];
			}
			$text .= '
			<tr>
				<td colspan="'.($result["discount"] ? 5 : 3).'">
					<div class="cart_additional_cost_name">'.$row["name"].'</div>
					'.(empty($result["hide_form"]) ? '<div class="cart_additional_cost_text">'.$row['text'].'</div>' : '').'
				</td>
				<td class="cart_price">'.($row['percent'] ? $row['percent'].'%' : $row["price"]).'</td>
				<td class="cart_summ">'.$row["summ"].'</td>
				'.(empty($result["hide_form"]) ? '<td class="cart_check">' : '');
			if(! $row["required"] && empty($result["hide_form"]))
			{
				$text .= '<input name="additional_cost_ids[]" value="'.$row['id'].'" type="checkbox" '.(in_array($row["id"], $result["cart_additional_cost"]) ? ' checked' : '').'>';
			}
			$text  .= (empty($result["hide_form"]) ? '</td>' : '').'
			</tr>';
		}
	}

	//способы доставки
	if (! empty($result["delivery"])) 
	{
		$text .= '<tr><th colspan="'.($result["discount"] ? 7 : 5).'">'.$this->diafan->_('Способ доставки').'</th>
		<th class="cart_last_th">'.$this->diafan->_('Выбрать').'</th></tr>';
		foreach($result["delivery"] as $row)
		{
			if(! empty($result["hide_form"]) && $row["id"] != $result["cart_delivery"])
				continue;

			if (! empty($row["thresholds"]) && empty($result["hide_form"]))
			{
			    foreach($row["thresholds"]  as $r)
			    {
				if($r["amount"])
				{
				    $row['text'] .= '<br>'.($r["price"] ? $this->diafan->_('Стоимость').' '.$r["price"].' '.$result["currency"].' '.$this->diafan->_('от суммы') : $this->diafan->_('Бесплатно от суммы')).' '.$r['amount'].' '.$result["currency"];
				}
				else
				{
				    $row['text'] .= '<br>'.($r["price"] ? $this->diafan->_('Стоимость').' '.$r["price"].' '.$result["currency"] : $this->diafan->_('Бесплатно'));
				}
			    }
			}
			$text .= '
			<tr>
				<td colspan="'.($result["discount"] ? 6 : 4).'">
					<div class="cart_delivery_name">'.$row["name"].'</div>
					'.(empty($result["hide_form"]) ? '<div class="cart_delivery_text">'.$row['text'].'</div>' : '').'
				</td>
				<td class="cart_summ">'.$row["price"].'</td>
				'.(empty($result["hide_form"]) ? '<td class="cart_check"><input name="delivery_id" value="'.$row['id'].'" type="radio" '.($row["id"] == $result["cart_delivery"] ? ' checked' : '').'></td>' : '').'
			</tr>';
		}
	}
}


//итоговая строка таблицы
$text .= '
	<tr class="cart_last_tr">
		<td class="cart_total" colspan="'.($result["discount"] ? 6 : 4).'">'.$this->diafan->_('Итого к оплате').'</td>
		<td class="cart_summ">'.$result["summ"].'</td>
		'.(empty($result["hide_form"]) ? '<td class="cart_last_td">&nbsp;</td>' : '').'
	</tr>
</table>';

return $text;
