<?php
/**
 * Подключение модуля
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */
if (!defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Сomments_inc
 */
class Comments_inc extends Model
{
	/**
	 * Показывает комментарии, прикрепленные к элементу, и форму добавления комментария
	 *
	 * @param integer $element_id номер элемента
	 * @param string $module_name модуль
	 * @param integer $site_id страница сайта, к которой прикреплен элемент
	 * @param boolean $is_category это категория
	 * @return string
	 */
	public function get($element_id = 0, $module_name = '', $site_id = 0, $is_category = false)
	{
		$module_name = ! $module_name ? $this->diafan->module : $module_name;
		$site_id = ! $site_id ? $this->diafan->cid : $site_id;
		$element_id = ! $element_id ? ($is_category ? $this->diafan->cat : $this->diafan->show) : $element_id;

		if(! $this->diafan->configmodules("comments".($is_category ? "_cat" : ""), $module_name, $site_id))
		{
			return false;
		}

		$module_name = $module_name.($is_category ? "_category" : "");

		$where_form = "(module_name='".$module_name."' OR module_name='') AND show_in_"
					  .($this->diafan->_user->id ? "form_auth" : "form_no_auth")."='1'";
		$where_list = "(module_name='".$module_name."' OR module_name='') AND show_in_list='1'";

		$params_form = $this->get_params(array("module" => "comments", "where" => $where_form));
		$params_list = $this->get_params(array("module" => "comments", "where" => $where_list));

		////navigation//
		$this->diafan->_paginator->page    = $this->diafan->dpage;
		$this->diafan->_paginator->nastr   = $this->diafan->configmodules('nastr', 'comments');
		$this->diafan->_paginator->navlink = $this->diafan->_route->current_link("dpage");
		$this->diafan->_paginator->navlink_tpl = $this->diafan->_route->current_link("", array("dpage" => "%d"));
		$this->diafan->_paginator->urlpage = 'dpage%d/';
		$this->diafan->_paginator->nen = DB::query_result(
			"SELECT COUNT(*) FROM {comments}"
			." WHERE module_name='%h' AND element_id=%d"
			." AND act='1' AND trash='0' AND parent_id=0",
			$module_name, $element_id
		);
		$links = $this->diafan->_paginator->get();
		////navigation///

		$result_sql = DB::query_range(
			"SELECT created, user_id, text, id FROM {comments}"
			." WHERE module_name='%h' AND element_id=%d"
			." AND act='1' AND trash='0' AND parent_id=0 ORDER BY created ASC",
			$module_name, $element_id,
			$this->diafan->_paginator->polog, $this->diafan->_paginator->nastr
		);
		$rows = array();
		$parents = array();
		while ($row = DB::fetch_array($result_sql))
		{
			if ($this->diafan->configmodules('user_name', 'comments') && $row["user_id"])
			{
				$this->prepare_author($row["user_id"]);
			}
			$this->prepare_get_param_values($row["id"]);
			$parents[] = $row["id"];
			$rows[0][] = $row;
		}
		DB::free_result($result_sql);
		if($parents)
		{
			$result_sql = DB::query(
				"SELECT c.created, c.user_id, c.text, c.id, c.parent_id FROM {comments} AS c"
				." INNER JOIN {comments_parents} AS p ON c.id=p.element_id"
				." WHERE c.module_name='%h' AND c.element_id=%d"
				." AND c.act='1' AND c.trash='0'"
				." AND p.parent_id IN (%s)"
				." GROUP BY c.id ORDER BY c.created ASC",
				$module_name, $element_id, implode(",", $parents)
			);
			while ($row = DB::fetch_array($result_sql))
			{
				if ($this->diafan->configmodules('user_name', 'comments') && $row["user_id"])
				{
					$this->prepare_author($row["user_id"]);
				}
				$this->prepare_get_param_values($row["id"]);
				$rows[$row["parent_id"]][] = $row;
			}
			DB::free_result($result_sql);
		}
		if(! empty($rows))
		{
			foreach($rows as $parent_id => $rows_parent)
			{
				foreach($rows_parent as $i => $row)
				{
					$this->comment($rows[$parent_id][$i], $params_list, $params_form);
				}
			}
		}
		

		$result["rows"] = $this->build_tree($rows);
		$result["form"] = $this->get_form($params_form);
		$result["register_to_comment"] = $this->diafan->configmodules('only_user', 'comments') && ! $this->diafan->_user->id;

		$result["paginator"] = $this->diafan->_tpl->get('get', 'paginator', $links);

		if($this->diafan->configmodules('use_mail', 'comments')
		   && ! empty($_GET["module"]) && $_GET["module"] == 'comments'
		   && ! empty($_GET["action"]) && $_GET["action"] == 'unsubscribe'
		   && ! empty($_GET["mail"]))
		{
			if($mail_id = DB::query_result("SELECT id FROM {comments_mail} WHERE module_name='%s' AND element_id=%d AND mail='%h'", $module_name, $element_id, $_GET["mail"]))
			{
				DB::query("DELETE FROM {comments_mail} WHERE id=%d", $mail_id);
			}
			$result["unsubscribe"] = true;
		}

		$text = $this->diafan->_tpl->get('get', 'comments', $result);
		return $text;
	}

	/**
	 * Формирует данные об одном комментарие
	 *
	 * @param array $row массив данных о комментарии
	 * @return void
	 */
	private function comment(&$row, $params_list, $params_form)
	{
		if($this->diafan->timeedit < $row['created'])
		{
			$this->diafan->timeedit = $row['created'];
		}
		$row['date'] = $this->diafan->_useradmin->get($this->format_date($row['created'], "comments"), 'created', $row["id"], 'comments');

		if ($this->diafan->configmodules('user_name', 'comments') && $row["user_id"])
		{
			$row["name"] = $this->get_author($row["user_id"]);
		}

		$row["text"] = $this->diafan->_useradmin->get($row["text"], 'text', $row["id"], 'comments');

		$row["params"] = $this->get_param_values($row["id"], $params_list);
		$row["form"] = $this->get_form($params_form, $row["id"]);
	}

	/**
	 * Формирует дерево сообщений из полученного массива
	 *
	 * @param array $rows все сообщения
	 * @param integer $parent_id номер текущего сообщения-родителя
	 * @param integer $level уровень
	 * @return string
	 */
	private function build_tree($rows, $parent_id = 0, $level = 0)
	{
		$result = array();
		$count_level = $this->diafan->configmodules("count_level", "comments");

		if($count_level && $level >= $count_level)
			return $result;

		if (! empty($rows[$parent_id]))
		{
			foreach ($rows[$parent_id] as $row)
			{
				$row["children"] = $this->build_tree($rows, $row["id"], $level+1);
				$row["level"] = $level;
				if($level+1 == $count_level)
				{
					$row["form"] = false;
				}
				$result[] = $row;
			}
		}
		return $result;
	}

	/**
	 * Запоминает номера комментариев, для которых понядобятся значения доп. полей
	 * 
	 * @param integer $id номер комментария
	 * @return array
	 */
	public function prepare_get_param_values($id)
	{
		if(isset($this->cache["param_values"][$id]))
		{
			return;
		}
		if(empty($this->cache["prepare_param_values"]) || ! in_array($id, $this->cache["prepare_param_values"]))
		{
			$this->cache["prepare_param_values"][] = $id;
		}
	}

	/**
	 * Получает дополнительные поля комментариев
	 * 
	 * @param integer $id номер комментария
	 * @param array $params поля комментариев
	 * @return array
	 */
	public function get_param_values($id, $params)
	{
		if(! $params)
		{
			return array();
		}
		$this->prepare_get_param_values($id);
		if(! empty($this->cache["prepare_param_values"]))
		{
			foreach($this->cache["prepare_param_values"] as $idv)
			{
				$this->cache["param_values"][$idv] = array();
			}
			$result_el = DB::query("SELECT id, value, param_id, element_id FROM {comments_param_element} WHERE element_id IN (".implode(",", $this->cache["prepare_param_values"]).")");
			while ($row_el = DB::fetch_array($result_el))
			{
				$this->cache["param_values"][$row_el["element_id"]][$row_el["param_id"]][]  = $row_el;
			}
			DB::free_result($result_el);
			unset($this->cache["prepare_param_values"]);
		}
		$values = $this->cache["param_values"][$id];
		$param = array();
		foreach($params as $row)
		{
			switch ($row["type"])
			{
				case "text":
				case "editor":
					if (! empty($values[$row["id"]][0]["value"]))
					{
						$param[] = array(
							"id" => $row["id"],
							"name" => $row["name"],
							"value" => $values[$row["id"]][0]["value"],
							"value_id" => $values[$row["id"]][0]["id"],
							"type" => $row["type"]
						);
					}
					break;
				case "textarea":
					if (! empty($values[$row["id"]][0]["value"]))
					{
						$param[] = array(
							"id" => $row["id"],
							"name" => $row["name"],
							"value" => $values[$row["id"]][0]["value"],
							"value_id" => $values[$row["id"]][0]["id"],
							"type" => $row["type"]
						);
					}
					break;
				case "date":
					if (! empty($values[$row["id"]][0]["value"]))
					{
						$param[] = array(
							"id" => $row["id"],
							"name" => $row["name"],
							"value" => $this->diafan->formate_from_date($values[$row["id"]][0]["value"]),
							"value_id" => $values[$row["id"]][0]["id"],
							"type" => $row["type"]
						);
					}
					break;
				case "datetime":
					if (! empty($values[$row["id"]][0]["value"]))
					{
						$param[] = array(
							"id" => $row["id"],
							"name" => $row["name"],
							"value" => $this->diafan->formate_from_datetime($values[$row["id"]][0]["value"]),
							"value_id" => $values[$row["id"]][0]["id"],
							"type" => $row["type"]
						);
					}
					break;
				case "select":
					$value = ! empty($values[$row["id"]][0]["value"]) ? $values[$row["id"]][0]["value"] : '';
					if ($value)
					{	
						$param[] = array("id" => $row["id"], "name" => $row["name"], "type" => $row["type"], "value" => $row["select_values"][$value]);
						
					}
					break;
				case "multiple":
					if (! empty($values[$row["id"]]))
					{
						$value = array();
						foreach ($values[$row["id"]] as $val)
						{
							$value[] = $row["select_values"][$val["value"]];
							
						}
						$param[] = array("id" => $row["id"], "name" => $row["name"], "type" => $row["type"], "value" => $value);
					}
					break;
				case "checkbox":
					$value = ! empty($values[$row["id"]][0]["value"]) ? 1 : 0;
					if (! empty($row["select_values"][$value]))
					{
						$param[] = array("id" => $row["id"], "name" => $row["name"], "type" => $row["type"], "value" => $row["select_values"][$value]);
					}
					elseif($value == 1)
					{
						$param[] = array("id" => $row["id"], "name" => $row["name"], "type" => $row["type"], "value" => '');
					}
					break;
				case "title":
					$param[] = array(
						"id" => $row["id"],
						"name" => $row["name"],
						"type" => $row["type"],
						"value" => ''
					);
					break;
				case "images":
					$value = $this->diafan->_images->get('large', $id, "comments", 0, '', $row["id"]);
					if(! $value)
						continue 2;

					$param[] = array(
						"id" => $row["id"],
						"name" => $row["name"],
						"type" => $row["type"],
						"value" => $value
					);
					break;
				case "attachments":
					$config = unserialize($row["config"]);
					if(! $config["attachments_access_admin"])
					{
						$attachments = $this->diafan->_attachments->get($id, "comments", $row["id"]);
						if(! $attachments)
							break;
						$param[] = array(
							"id" => $row["id"],
							"name" => $row["name"],
							"type" => $row["type"],
							"value" => $attachments,
							"use_animation" => ! empty($config["use_animation"]) ? true : false,
						);
					}
					break;
				default:
					if (! empty($values[$row["id"]][0]["value"]))
					{
						$param[] = array(
							"id" => $row["id"],
							"name" => $row["name"],
							"value" => $values[$row["id"]][0]["value"],
							"value_id" => $values[$row["id"]][0]["id"],
							"type" => $row["type"]
						);
					}
					break;
			}
		}
		return $param;
	}
	
	/*
	 * Формирует данные для формы
	 * 
	 * @param integer $parent_id номер комментария-родителя
	 * @return array
	 */
	public function get_form($params, $parent_id = 0)
	{
		// форма комментариев
		if (! $this->diafan->configmodules('only_user', 'comments') || $this->diafan->_user->id)
		{
			$form["parent_id"] = $parent_id;
			$form["captcha"] = '';
			if ($this->diafan->configmodules('captcha', 'comments'))
			{
				$form["captcha"] = $this->diafan->_captcha->get("comments".$parent_id, $this->get_error("comments".$parent_id, "captcha"));
			}
			$form['params'] = array();
			if($params)
			{
				foreach ($params as $row)
				{
					$form['error_p'.$row["id"]] = $this->get_error("comments".$parent_id, 'p'.$row["id"]);
					$form['params'][] = $row;
				}
			}
			$form["error"] = $this->get_error("comments".$parent_id);
			$form["bbcode"] = $this->diafan->configmodules('use_bbcode', 'comments');
			$form['use_mail'] = $this->diafan->configmodules('use_mail', 'comments');
			$form['error_mail'] = $this->get_error("comments".$parent_id, 'mail');
		}
		else
		{
			$form = false;
		}
		return $form;
	}
}
