<?php
/**
 * Модель
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Comments_model
 */
class Comments_model extends Model
{
	/**
	 * Генерирует данные для шаблонной функции: блок комментариев
	 * 
	 * @param integer $count количество комментариев
	 * @param array $element_ids элементы
	 * @param array $modules модули
	 * @param string $sort сортировка date - по дате, rand - случайно
	 * @return array
	 */
	public function show_block($count, $element_ids, $modules, $sort)
	{
		$where = '';
		foreach($modules as $i => $module)
		{
			$modules[$i] = preg_replace('/[^a-z_]+/', '', trim($module));
			if(! $module)
			{
				unset($modules[$i]);
			}
		}
		if($modules)
		{
			$where .= " AND module_name IN ('".implode("','", $modules)."')";
		}
		foreach($element_ids as $i => $element_id)
		{
			$element_id = preg_replace('/[^0-9]+/', '', trim($element_id));
			$element_ids[$i] = $element_id;
			if(! $element_id)
			{
				unset($element_ids[$i]);
			}
		}
		if($element_ids)
		{
			$where .= " AND element_id IN (".implode(",", $element_ids).")";
		}

		if ($sort == "rand")
		{
			$max_count = DB::query_result(
				"SELECT COUNT(*) FROM {comments}"
				." WHERE act='1' AND trash='0'".$where
			);
			$rands = array();
			for ($i = 1; $i <= min($max_count, $count); $i++)
			{
				do
				{
					$rand = mt_rand(0, $max_count - 1);
				}
				while (in_array($rand, $rands));
				$rands[] = $rand;
			}
		}
		else
		{
			$rands[0] = 1;
		}

		$where_list = "show_in_list='1'";

		$params_list = $this->get_params(array("module" => "comments", "where" => $where_list));

		$this->result["rows"] = array();
		$rows = array();
		foreach ($rands as $rand)
		{
			$result = DB::query_range(
				"SELECT created, user_id, text, id, module_name, element_id FROM {comments}"
				." WHERE act='1' AND trash='0'".$where
				.($sort == "date" ? ' ORDER BY created DESC, id DESC' : ''),
				$sort == "rand" ? $rand : 0,
				$sort == "rand" ? 1 : $count
			);
			while($row = DB::fetch_array($result))
			{
				if ($this->diafan->configmodules('user_name', 'comments') && $row["user_id"])
				{
					$this->prepare_author($row["user_id"]);
				}
				if($row["module_name"] == 'site')
				{
					$this->diafan->_route->prepare("site", $row["element_id"]);
				}
				else
				{
					if(strpos($row["module_name"], "_category") !== false)
					{
						if(! isset($this->cache["prepare_site_id"][$row["module_name"]]['e'.$row["element_id"]]))
						{
							$this->cache["prepare_site_id"][$row["module_name"]]['e'.$row["element_id"]] = true;
						}
						$this->diafan->_route->prepare(str_replace("_category", "", $row["module_name"]), $row["element_id"], "cat");
					}
					else
					{
						if(! isset($this->cache["prepare_site_cat_id"][$row["module_name"]]['e'.$row["element_id"]]))
						{
							$this->cache["prepare_site_cat_id"][$row["module_name"]]['e'.$row["element_id"]] = true;
						}
						$this->diafan->_route->prepare($row["module_name"], $row["element_id"]);
					}
				}
				$this->diafan->_comments->prepare_get_param_values($row["id"]);
				$rows[] = $row;
			}
			DB::free_result($result);
		}
		if(! empty($this->cache["prepare_site_cat_id"]))
		{
			foreach($this->cache["prepare_site_cat_id"] as $pr_table_name => $arr)
			{
				$pr_ids = array();
				foreach($arr as $pr_id => $a)
				{
					$pr_ids[] = substr($pr_id, 1);
					$this->cache["link_site_cat_id"][$pr_table_name]['id'.$pr_id] = '';
				}
				$result = DB::query("SELECT site_id, cat_id, id FROM {".$pr_table_name."} WHERE id IN (".implode(",", $pr_ids).")");
				while($row = DB::fetch_array($result))
				{
					$this->cache["link_site_cat_id"][$pr_table_name]['id'.$row["id"]] = $row;
				}
				DB::free_result($result);
			}
		}
		if(! empty($this->cache["prepare_site_id"]))
		{
			foreach($this->cache["prepare_site_id"] as $pr_table_name => $arr)
			{
				$pr_ids = array();
				foreach($arr as $pr_id => $a)
				{
					$pr_ids[] = substr($pr_id, 1);
					$this->cache["link_site_id"][$pr_table_name]['id'.$pr_id] = '';
				}
				$result = DB::query("SELECT site_id, id FROM {".$pr_table_name."} WHERE id IN (".implode(",", $pr_ids).")");
				while($row = DB::fetch_array($result))
				{
					$this->cache["link_site_id"][$pr_table_name]['id'.$row["id"]] = $row["site_id"];
				}
				DB::free_result($result);
			}
		}
		foreach($rows as $row)
		{
			if($this->diafan->timeedit < $row['created'])
			{
				$this->diafan->timeedit = $row['created'];
			}
			$row['date'] = $this->diafan->_useradmin->get($this->format_date($row['created'], "comments"), 'created', $row["id"], 'comments');
	
			if ($this->diafan->configmodules('user_name', 'comments') && $row["user_id"])
			{
				$row["name"] = $this->get_author($row["user_id"]);
			}
	
			$row["text"] = $this->diafan->_useradmin->get($row["text"], 'text', $row["id"], 'comments');
			$row["params"] = $this->diafan->_comments->get_param_values($row["id"], $params_list);
			if($row["module_name"] == 'site')
			{
				$row["link"] = $this->diafan->_route->link($row["element_id"]);
			}
			else
			{
				if(strpos($row["module_name"], "_category") !== false)
				{
					$cat_id = $row["element_id"];
					$element_id = 0;
					$site_id = $this->cache["link_site_id"][$row["module_name"]]['id'.$cat_id];
					$row["module_name"] = str_replace("_category", "", $row["module_name"]);
				}
				else
				{
					$element_id = $row["element_id"];
					$site_id = $this->cache["link_site_cat_id"][$row["module_name"]]['id'.$element_id]["site_id"];
					if($this->diafan->configmodules("cat", $row["module_name"], $site_id))
					{
						$cat_id = $this->cache["link_site_cat_id"][$row["module_name"]]['id'.$element_id]["cat_id"];
					}
					else
					{
						$cat_id = 0;
					}
				}
				$row["link"] = $this->diafan->_route->link($site_id, $row["module_name"], $cat_id, $element_id);
			}
			$this->result["rows"][] = $row;
		}
		return $this->result;
	}
}