<?php
/**
 * Контроллер
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Comments
 */
class Comments extends Controller
{
	/**
	 * Шаблонная функция: выводит последние комментарии.
	 *
	 * @param array $attributes атрибуты шаблонного тега
	 * count - количество выводимых комментариев (по умолчанию 3)
	 * modules - модули (разделенные запятой), к которым подключены комментарии
	 * element_id - идентификаторы элементов модулей (разделенные запятой), к которым подключены комментарии
	 * sort - сортировка комментариев: **date** – по дате (по умолчанию), **rand** – в случайном порядке
	 * template - шаблон тега (файл modules/comments/views/comments.view.show_block_**template**.php; по умолчанию шаблон modules/comments/views/comments.view.show_block.php)
	 * 
	 * @return void
	 */
	public function show_block($attributes)
	{
		$attributes = $this->get_attributes($attributes, 'count', 'modules', 'element_id', 'sort', 'template');
		
		$count   = $attributes["count"] ? intval($attributes["count"]) : 3;
		$element_ids  = explode(",", $attributes["element_id"]);
		$modules = explode(",", $attributes["modules"]);
		$sort    = $attributes["sort"] == "date" || $attributes["sort"] == "rand" ? $attributes["sort"] : "date";

		$result = $this->model->show_block($count, $element_ids, $modules, $sort);

		if (! $attributes["template"] || ! $this->diafan->_tpl->get('show_block_'.$attributes["template"], 'comments', $result))
		{
			$this->diafan->_tpl->get('show_block', 'comments', $result);
		}
	}
}