<?php
/**
 * Модель
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

class Consultant_model extends Model
{
	/**
	 * Генерирует данные для шаблонной функции: on-line консультант
	 * @return string
	 */
	public function show_block($system)
	{
		switch($system)
		{
			case 'redhelper':
				return $this->redhelper();

			case 'jivosite':
				return $this->jivosite();

			case 'livetex':
				return $this->livetex();
		}
	}

	/**
	 * Генерирует данные для шаблонной функции: on-line консультант системы RedHelper
	 * @return string
	 */
	private function redhelper()
	{
		if(! $this->diafan->configmodules("redhelper_login", "consultant"))
		{
			return '';
		}
		$result = '
<!-- RedHelper -->
<link href="'.BASE_PATH.'modules/consultant/consultant.css" rel="stylesheet" type="text/css">';
$place = $this->diafan->configmodules("redhelper_place", "consultant");
if(! in_array($place, array('top', 'left', 'right')))
{
	$place = 'left';
}
if($this->diafan->configmodules("redhelper_small", "consultant"))
{
	$place .= '_small';
}
if($this->diafan->configmodules("redhelper_color", "consultant"))
{
	$result .= '<style type="text/css">
	.redhlp_button_diafan_'.$place.' span
	{
	background-color:'.$this->diafan->configmodules("redhelper_color", "consultant").' !important;
	}
	</style>';
}
$result  .= '<div class="redhlp_button_diafan_'.$place.' redhlp_button"><span class="offline"></span><span class="online"></span></div>
<script id="rhlpscrtg" type="text/javascript" charset="utf-8" async="async" 
	src="https://web.redhelper.ru/service/main.js?c='.$this->diafan->configmodules("redhelper_login", "consultant").'">
</script>
<script>
redhlpSettings = {';
if($this->diafan->configmodules("redhelper_chatX", "consultant"))
{
	$result .= "\n".'chatX: "'.str_replace(array('"', "\n"), '', $this->diafan->configmodules("redhelper_chatX", "consultant")).'",'."\n";
}
if($this->diafan->configmodules("redhelper_chatY", "consultant"))
{
	$result .= "\n".'chatY: "'.str_replace(array('"', "\n"), '', $this->diafan->configmodules("redhelper_chatY", "consultant")).'",'."\n";
}
if($this->diafan->configmodules("redhelper_header", "consultant"))
{
	$result .= "\n".'header: "'.str_replace(array('"', "\n"), '', $this->diafan->configmodules("redhelper_header", "consultant")).'",'."\n";
}
if($this->diafan->configmodules("redhelper_topText", "consultant"))
{
	$result .= "\n".'topText: "'.str_replace(array('"', "\n"), '', $this->diafan->configmodules("redhelper_topText", "consultant")).'",'."\n";
}
if($this->diafan->configmodules("redhelper_welcome", "consultant"))
{
	$result .= "\n".'welcome: "'.str_replace(array('"', "\n"), '', $this->diafan->configmodules("redhelper_welcome", "consultant")).'",'."\n";
}
if($this->diafan->configmodules("redhelper_inviteTime", "consultant"))
{
	$result .= "\n".'inviteTime: '.intval($this->diafan->configmodules("redhelper_inviteTime", "consultant")).','."\n";
}
if($this->diafan->configmodules("redhelper_chatWidth", "consultant"))
{
	$result .= "\n".'chatWidth: '.intval($this->diafan->configmodules("redhelper_chatWidth", "consultant")).','."\n";
}
if($this->diafan->configmodules("redhelper_chatHeight", "consultant"))
{
	$result .= "\n".'chatHeight: '.intval($this->diafan->configmodules("redhelper_chatHeight", "consultant")).','."\n";
}

	//$result .= "\n".'hideBadge: true,'."\n";
	$result .= '
}

</script>
<!--/Redhelper -->';
		return $result;
	}

	/**
	 * Генерирует данные для шаблонной функции: on-line консультант системы LiveTex
	 * @return string
	 */
	private function livetex()
	{
		if(! $this->diafan->configmodules("livetex_id", "consultant"))
		{
			return '';
		}
		$result = '<script type=\'text/javascript\'> /* build:::7 */
			var liveTex = true,
				liveTexID = '.$this->diafan->configmodules("livetex_id", "consultant").',
				liveTex_object = true;
			(function() {
				var lt = document.createElement(\'script\');
				lt.type =\'text/javascript\';
				lt.async = true;
				lt.src = \'http://cs15.livetex.ru/js/client.js\';
				var sc = document.getElementsByTagName(\'script\')[0];
				if ( sc ) sc.parentNode.insertBefore(lt, sc);
				else  document.documentElement.firstChild.appendChild(lt);
			})();
		</script>';
		return $result;
	}

	/**
	 * Генерирует данные для шаблонной функции: on-line консультант системы JivoSite
	 * @return string
	 */
	private function jivosite()
	{
		if(! $this->diafan->configmodules("jivosite_id", "consultant"))
		{
			return '';
		}
		$result = "<!-- BEGIN JIVOSITE CODE {literal} -->
<script type='text/javascript'>
(function(){ var widget_id = '".$this->diafan->configmodules("jivosite_id", "consultant")."';
var s = document.createElement('script'); s.type = 'text/javascript'; s.async = true; s.src = '//code.jivosite.com/script/widget/'+widget_id; var ss = document.getElementsByTagName('script')[0]; ss.parentNode.insertBefore(s, ss);})();</script>
<!-- {/literal} END JIVOSITE CODE -->";
		return $result;
	}
}