<?php
/**
 * Контроллер
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

class Consultant extends Controller
{
	/**
	 * Шаблонная функция: подключает on-line консультант.
	 * 
	 * @param array $attributes атрибуты шаблонного тега
	 * template - шаблон тега (файл modules/consultant/views/consultant.view.show_block_**template**.php; по умолчанию шаблон modules/consultant/views/consultant.view.show_block.php)
	 * 
	 * @return void
	 */
	public function show_block($attributes)
	{
		$attributes = $this->get_attributes($attributes, 'template', 'system');
		$attributes["system"] = ! in_array($attributes["system"], array('redhelper', 'livetext', 'jivosite')) ? 'redhelper' : $attributes["system"];

		$result = $this->model->show_block($attributes["system"]);
		if (! $attributes["template"] || ! $this->diafan->_tpl->get('show_block_'.$attributes["template"], 'consultant', $result))
		{
			$this->diafan->_tpl->get('show_block', 'consultant', $result);
		}
	}
}