<?php
/**
 * Контроллер
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Feedback
 */
class Feedback extends Controller
{
	/**
	 * Инициализация модуля
	 * 
	 * @return void
	 */
	public function init()
	{
		$this->result = $this->model->form();
	}

	/**
	 * Выводит контент модуля
	 * 
	 * @return boolean true
	 */
	public function show_module()
	{
		if (! empty($this->result["text"]))
		{
			echo $this->result["text"];
			return true;
		}
		$this->diafan->_tpl->get('form', 'feedback', $this->result);
		return true;
	}

	/**
	 * Шаблонная функция: выводит форму добавления сообщения. Для правильной работы тега должна существовать страница, к которой прикреплен модуль Обратная связь.
	 *
	 * @param array $attributes атрибуты шаблонного тега
	 * site_id - страница, к которой прикреплен модуль, по умолчанию выбирается одна страница
	 * template - шаблон тега (файл modules/feedback/views/feedback.view.form_**template**.php; по умолчанию шаблон modules/feedback/views/feedback.view.form.php)
	 * 
	 * @return void
	 */
	public function show_form($attributes)
	{
		$attributes = $this->get_attributes($attributes, 'site_id', 'template');

		$site_id = intval($attributes["site_id"]);

		$result = $this->model->form($site_id, true);
		if ($result)
		{
			if (! $attributes["template"] || ! $this->diafan->_tpl->get('form_'.$attributes["template"], 'feedback', $result))
			{
				$this->diafan->_tpl->get('form', 'feedback', $result);
			}
		}
	}
}