<?php
/**
 * Редактирование файлов в файловом архиве
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */
if (!defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Files_admin
 */
class Files_admin extends Frame_admin
{
	/**
	 * @var string таблица в базе данных
	 */
	public $table = 'files';

	/**
	 * @var array поля в базе данных для редактирования
	 */
	public $variables = array (
		'main' => array (
			'files' => array(
				'type' => 'function',
				'name' => 'Файлы',
				'help' => 'Загружаемые файлы. Доступные типы файлов %attachment_extensions изменяются в настройках модуля (параметр «Доступные типы файлов»). Можно указать ссылку для закачки файла из удаленного источника или ссылку на файл для скачивания.',
			),
			'hr' => 'hr',
			'name' => array(
				'type' => 'text',
				'name' => 'Название',
				'help' => 'Используется в ссылках на файл, заголовках.',
				'multilang' => true,
			),
			'act' => array(
				'type' => 'checkbox',
				'name' => 'Опубликовать на сайте',
				'help' => 'Если не отмечена, файл не будет отображаться на сайте.',
				'default' => true,
				'multilang' => true,
			),
			'hr1' => 'hr',
			'images' => array(
				'type' => 'module',
				'name' => 'Изображения',
				'help' => 'Изображения будут загружены автоматически после выбора. После загрузки изображения будут обработаны автоматически, согласно настройкам модуля. Параметр выводится, если в настройках модуля отмечена опция «Использовать изображения».',
			),
			'hr2' => 'hr',
			'rel_elements' => array(
				'type' => 'function',
				'name' => 'Похожие файлы',
				'help' => 'Выбор и добавление к текущему файлу связей с другими файлами. Похожие файлы выводятся шаблонным тегом show_block_rel. По умолчанию связи между файлами являются односторонними, это можно изменить, отметив опцию «В блоке похожих файлов связь двусторонняя» в настройках модуля.',
			),
			'hr_cat' => 'hr',
			'cat_id' => array(
				'type' => 'function',
				'name' => 'Категория',
				'help' => 'Категория, к которой относится файл. Возможно выбрать дополнительные категории, в которых файл также будет выводится. Чтобы выбрать несколько категорий, удерживайте CTRL. Параметр выводится, если в настройках модуля отмечена опция «Использовать категории».',
			),
			'tags' => array(
				'type' => 'module',
				'name' => 'Теги',
				'help' => 'Добавление тегов к файлу. Можно добавить либо новый тег, либо открыть и выбрать из уже существующих тегов. Параметр выводится, если в настройках модуля включен параметр «Подключить теги».',
			),
			'hr3' => 'hr',
			'site_id' => array(
				'type' => 'function',
				'name' => 'Раздел сайта',
				'help' => 'Перенос файла на другую страницу сайта, к которой прикреплен модуль. Параметр выводится, если в настройках модуля отключена опция «Использовать категории», если опция подключена, то раздел сайта задается такой же, как у основной категории.',
			),
			'hr4' => 'hr',
			'counter_view' => array(
				'type' => 'function',
				'name' => 'Счетчик просмотров',
				'help' => 'Количество просмотров на сайте текущей файла. Статистика ведется и параметр выводится, если в настройках модуля отмечена опция «Подключить счетчик просмотров».',
				'no_save' => true,
			),
			'comments' => array(
				'type' => 'module',
				'name' => 'Комментарии',
				'help' => 'Комментарии, которые оставили пользователи к текущему файлу. Параметр выводится, если в настройках модуля включен параметр «Показывать комментарии к файлам».',
			),
			'rating' => array(
				'type' => 'module',
				'name' => 'Рейтинг',
				'help' => 'Средний рейтинг, согласно голосованию пользователей сайта. Параметр выводится, если в настройках модуля включен параметр «Подключить рейтинг к файлам».',
			),
			'anons' => array(
				'type' => 'editor',
				'name' => 'Анонс',
				'help' => 'Краткое описание файла. Выводится в списке файлов и в блоках. Если отметить «Добавлять к описанию», на странице файла анонс выведется вместе с основным описанием. Иначе анонс выведется только в списке, а на отдельной странице будет только описание. Если отметить «Применить типограф», контент будет отформатирован согласно правилам экранной типографики с помощью [веб-сервиса «Типограф»](http://www.artlebedev.ru/tools/typograf/webservice/).',
				'multilang' => true,
				'height' => 200,
			),
			'text' => array(
				'type' => 'editor',
				'name' => 'Описание',
				'help' => 'Полное описание для страницы файла. Если отметить «Применить типограф», контент будет отформатирован согласно правилам экранной типографики с помощью [веб-сервиса «Типограф»](http://www.artlebedev.ru/tools/typograf/webservice/).',
				'multilang' => true,
			),
			'search' => array(
				'type' => 'module',
				'name' => 'Индексирование для поиска',
				'help' => 'Файл автоматически индексируется для модуля «Поиск по сайту» при внесении изменений.',
			),
			'map' => array(
				'type' => 'module',
				'name' => 'Индексирование для карты сайта',
				'help' => 'Файл автоматически индексируется для карты сайта sitemap.xml.',
			),
		),
		'other_rows' => array (
			'number' => array(
				'type' => 'function',
				'name' => 'Номер',
				'help' => 'Номер элемента в БД (веб-мастеру и программисту).',
			),
			'title_meta' => array(
				'type' => 'text',
				'name' => 'Заголовок окна в браузере, тег Title',
				'help' => 'Если не заполнен, тег *Title* будет автоматически сформирован как «Название файла – Название страницы – Название сайта», либо согласно шаблонам автоформирования из настроек модуля (SEO-специалисту).',
				'multilang' => true,
			),
			'keywords' => array(
				'type' => 'textarea',
				'name' => 'Ключевые слова, тег Keywords',
				'help' => 'Если не заполнен, тег *Keywords* будет автоматически сформирован согласно шаблонам автоформирования из настроек модуля (SEO-специалисту).',
				'multilang' => true,
			),
			'descr' => array(
				'type' => 'textarea',
				'name' => 'Описание, тег Description',
				'help' => 'Если не заполнен, тег *Description* будет автоматически сформирован согласно шаблонам автоформирования из настроек модуля (SEO-специалисту).',
				'multilang' => true,
			),
			'rewrite' => array(
				'type' => 'function',
				'name' => 'Псевдоссылка',
				'help' => 'ЧПУ (человеко-понятные урл url), адрес страницы вида: *http://site.ru/psewdossylka/*. Смотрите параметры сайта.',
			),
			'redirect' => array(
				'type' => 'none',
				'name' => 'Редирект на текущую страницу со страницы',
				'help' => 'Позволяет делать редирект с указанной страницы на текущую.',
				'no_save' => true,
			),
			'changefreq'   => array(
				'type' => 'function',
				'name' => 'Changefreq',
				'help' => 'Вероятная частота изменения этой страницы. Это значение используется для генерирования файла sitemap.xml. Подробнее читайте в описании [XML-формата файла Sitemap](http://www.sitemaps.org/ru/protocol.html) (SEO-специалисту).',
			),
			'priority'   => array(
				'type' => 'floattext',
				'name' => 'Priority',
				'help' => 'Приоритетность URL относительно других URL на Вашем сайте. Это значение используется для генерирования файла sitemap.xml. Подробнее читайте в описании [XML-формата файла Sitemap](http://www.sitemaps.org/ru/protocol.html) (SEO-специалисту).',
			),
			'hr_map2' => 'hr',
			'access' => array(
				'type' => 'function',
				'name' => 'Доступ',
				'help' => 'Если отметить опцию «Доступ только», файл увидят только авторизованные на сайте пользователи, отмеченных типов. Не авторизованные, в том числе поисковые роботы, увидят «404 Страница не найдена» (администратору сайта).',
			),
			'date_start' => array(
				'type' => 'date',
				'name' => 'Период показа',
				'help' => 'Если заполнить, текущий файл будет опубликована на сайте в указанный период. В иное время пользователи сайта файл не будут видеть, получая ошибку 404 «Страница не найдена» (администратору сайта).'
			),
			'date_finish' => array(
				'type' => 'date',
				'hide' => true,
			),
			'hr_period' => 'hr',
			'sort' => array(
				'type' => 'function',
				'name' => 'Сортировка: установить перед',
				'help' => 'Изменить положение текущего файла среди других файлов. Поле доступно для редактирования только для файлов, отображаемых на сайте (администратору сайта).'
			),
			'map_no_show' => array(
				'type' => 'checkbox',
				'name' => 'Не показывать на карте сайта',
				'help' => 'Скрывает отображение ссылки на файл в файле sitemap.xml и [модуле «Карта сайта»](http://cms.diafan.ru/dokument/full-manual/modules/map/).',
			),
			'hr_view' => 'hr',
			'theme' => array(
				'type' => 'function',
				'name' => 'Шаблон страницы',
				'help' => 'Возможность подключить для страницы файла шаблон сайта отличный от основного (themes/site.php). Все шаблоны для сайта должны храниться в папке *themes* с расширением *.php* (например, themes/dizain_so_slajdom.php). Подробнее в [разделе «Шаблоны сайта»](http://cms.diafan.ru/dokument/full-manual/templates/site/). (веб-мастеру и программисту, не меняйте этот параметр, если не уверены в результате!).',
			),
			'view' => array(
				'type' => 'function',
				'name' => 'Шаблон модуля',
				'help' => 'Шаблон вывода контента модуля на странице отдельного файла (веб-мастеру и программисту, не меняйте этот параметр, если не уверены в результате!).',
			),
			'hr_info' => 'hr',
			'admin_id' => array(
				'type' => 'function',
				'name' => 'Редактор',
				'help' => 'Изменяется после первого сохранения. Показывает, кто из администраторов сайта первый правил текущую страницу.',
			),
			'timeedit' => array(
				'type' => 'text',
				'name' => 'Время последнего изменения',
				'help' => 'Изменяется после сохранения элемента. Отдается в заголовке *Last Modify*.',
			),
		),
	);

	/**
	 * @var array настройки модуля
	 */
	public $config = array (
		'act', // показать/скрыть
		'del', // удалить
		'order', // сортируется
		'menu', // используется в меню
		'element_site', // делит элементы по разделам (страницы сайта, к которым прикреплен модуль)
		'element', // используются группы
		'element_multiple', // модуль может быть прикреплен к нескольким группам
		'search_name', // скать по названию
		'trash', // использовать корзину
		'image', // показать фотографию в списке
		'only_self', // показывать только материалы редактора, если это задано в правах пользователя
	);

	/**
	 * Подготавливает конфигурацию модуля
	 * @return void
	 */
	public function prepare_config()
	{
		if(! $this->diafan->configmodules("cat", "files", $this->diafan->site))
		{
			$this->diafan->config("element", false);
			$this->diafan->config("element_multiple", false);
		}
	}

	/**
	 * Выводит ссылку на добавление
	 * @return void
	 */
	public function show_add()
	{
		if ($this->diafan->config('element') && !$this->diafan->not_empty_categories)
		{
			echo '<div class="error">'.sprintf($this->diafan->_('В %sнастройках%s модуля подключены категории, чтобы начать добавлять файл создайте хотя бы одну %sкатегорию%s.'),'<a href="'.BASE_PATH_HREF.'files/config/">', '</a>', '<a href="'.BASE_PATH_HREF.'files/category/'.( $this->diafan->site ? 'site'.$this->diafan->site.'/' : '' ).'">', '</a>').'</div>';
		}
		else
		{
			$this->diafan->addnew_init('Добавить файл');
		}
	}

	/**
	 * Выводит список файлов
	 * @return void
	 */
	public function show()
	{
		$this->diafan->list_row();
	}

	/**
	 * Выводит подсказки к полю (заменяет основную функцию)
	 * @return string
	 */
	public function help($key = '')
	{
		$text = parent::__call('help', array());
		$text = str_replace('%attachment_extensions', $this->diafan->configmodules('attachment_extensions'), $text);
		return $text;
	}

	/**
	 * Редактирование поля "Файлы"
	 * @return void
	 */
	public function edit_variable_files()
	{
		$file_type = 1;
		$this->diafan->values["link"] = '';
		echo '
		<tr>
			<td align="right">'.$this->diafan->variable_name().'</td>
			<td>';
		if(!$this->diafan->addnew)
		{
			$result = DB::query("SELECT id, link FROM {files_links} WHERE element_id=%d", $this->diafan->edit);
			while ($row = DB::fetch_array($result))
			{
				echo '<input type="checkbox" name="linkdel[]" value="'.$row["id"].'" />
					<a href="'.$row["link"].'">'.$row["link"].'</a><br>
					';
			}
			DB::free_result($result);
			$result = DB::query("SELECT id,name FROM {attachments} WHERE module_name='".$this->diafan->table."' AND element_id=%d", $this->diafan->edit);
			while ($row = DB::fetch_array($result))
			{
				echo '<input type="checkbox" name="filedel[]" value="'.$row["id"].'" />
					<a href="'.BASE_PATH.'attachments/get/'.$row["id"]."/".$row["name"].'">'.$row["name"].'</a><br>
					';
			}
			DB::free_result($result);
		}
		echo '
		<input type="radio" name="file_type" value="1"'.( $file_type == 1 ? ' checked' : '' ).'> '.$this->diafan->_('Загрузить файл').'
		<input type="radio" name="file_type" value="2"> '.$this->diafan->_('Загрузить файл по ссылке').'
		<input type="radio" name="file_type" value="3"'.( $file_type == 2 ? ' checked' : '' ).'> '.$this->diafan->_('Указать ссылку на файл').'

			<div class="file_type1"><input type="file" name="attachment" size="40">'.$this->diafan->help().'</div>
			<div class="file_type2 hide"><input type="text" name="attachment_link_upload" size="40" value="">'.$this->diafan->help().'</div>
			<div class="file_type3 hide"><input type="text" name="attachment_link" size="40" value=""></div>
			</td>
		</tr>';
	}

	/**
	 * Сохранение поля "Файлы"
	 * @return void
	 */
	public function save_variable_files()
	{
		$altname = str_replace('/', '_', strtolower(substr($this->diafan->translit($_POST["name"]), 0, 40)));
		if(! empty($_POST["filedel"]))
		{
			$result = DB::query("SELECT id FROM {attachments} WHERE module_name='".$this->diafan->table."' AND element_id=%d", $this->diafan->save);
			while ($row = DB::fetch_array($result))
			{
				if (in_array($row["id"], $_POST["filedel"]))
				{
					DB::query("DELETE FROM {attachments} WHERE id=%d", $row["id"]);
					Files_inc::delete_file(USERFILES.'/'.$this->diafan->table.'/files/'.$row["id"]);
				}
			}
			DB::free_result($result);
		}
		if(! empty($_POST["linkdel"]))
		{
			$result = DB::query("SELECT id FROM {files_links} WHERE element_id=%d", $this->diafan->save);
			while ($row = DB::fetch_array($result))
			{
				if (in_array($row["id"], $_POST["linkdel"]))
				{
					DB::query("DELETE FROM {files_links} WHERE id=%d", $row["id"]);
				}
			}
			DB::free_result($result);
		}

		if (empty( $_POST["file_type"] ))
		{
			return;
		}
		if ($_POST["file_type"] == 1 && isset($_FILES["attachment"]) && is_array($_FILES["attachment"]) && $_FILES["attachment"]['name'] != '')
		{
			Customization::inc("modules/attachments/attachments.inc.php");
			if (! $this->diafan->save_site_id)
			{
				$this->diafan->get_site_id();
			}
			$config = array(
				"attachment_extensions" => $this->diafan->configmodules("attachment_extensions", 'files', $this->diafan->save_site_id),
				"recognize_image" => $this->diafan->configmodules("recognize_image", 'files', $this->diafan->save_site_id),
				"attachments_access_admin" => $this->diafan->configmodules("attachments_access_admin", 'files', $this->diafan->save_site_id),
				"attach_big_width" => $this->diafan->configmodules("attach_big_width", 'files', $this->diafan->save_site_id),
				"attach_big_height" => $this->diafan->configmodules("attach_big_height", 'files', $this->diafan->save_site_id),
				"attach_big_quality" => $this->diafan->configmodules("attach_big_quality", 'files', $this->diafan->save_site_id),
				"attach_medium_width" => $this->diafan->configmodules("attach_medium_width", 'files', $this->diafan->save_site_id),
				"attach_medium_height" => $this->diafan->configmodules("attach_medium_height", 'files', $this->diafan->save_site_id),
				"attach_medium_quality" => $this->diafan->configmodules("attach_medium_quality", 'files', $this->diafan->save_site_id),
			);

			$this->diafan->_attachments->upload($_FILES['attachment'], $this->diafan->table, $this->diafan->save, false, $config);
		}
		if ($_POST["file_type"] == 2 && !empty( $_POST['attachment_link_upload'] ))
		{
			$extension = strtolower(substr(strrchr($_POST['attachment_link_upload'], '.'), 1));
			$name = $altname.'.'.$extension;

			if ($this->diafan->configmodules('attachment_extensions', 'files', $_POST["site_id"]) && !in_array($extension, explode(',', str_replace(' ', '', strtolower($this->diafan->configmodules('attachment_extensions', 'files', $_POST["site_id"]))))))
			{
				throw new Exception('Вы не можете отправить файл '.$name.'. Доступны только следующие типы файлов: '.$this->diafan->configmodules('attachment_extensions', 'files', $_POST["site_id"]).'. Новые типы файлов добавляются в настройках модуля.');
			}

			$newid = DB::query("INSERT INTO {attachments} (name,module_name,element_id) VALUES ('%s', '%s', %d)", $name, $this->diafan->table, $this->diafan->save);

			try
			{
				Files_inc::copy_file($_POST['attachment_link_upload'], $newid, USERFILES.'/'.$this->diafan->table.'/files');
			}
			catch(Exception $e)
			{
				DB::query("DELETE FROM {attachments} WHERE id=%d", $newid);
				throw new Exception($e->getMessage());
			}

			$size = filesize(ABSOLUTE_PATH.USERFILES.'/'.$this->diafan->table.'/files/'.$newid);
			DB::query("UPDATE {attachments} SET size=%d WHERE id=%d", $size, $newid);
		}
		if ($_POST["file_type"] == 3)
		{
			DB::query("INSERT INTO {files_links} (element_id, `link`) VALUES (%d, '%h')", $this->diafan->save, $_POST["attachment_link"]);
		}
	}

	/**
	 * Сопутствующие действия при удалении элемента модуля
	 * @return void
	 */
	public function delete($del_id, $trash_id)
	{
		$this->diafan->del_or_trash_where("files_rel", "element_id=".$del_id." OR rel_element_id=".$del_id, $trash_id);
		$this->diafan->del_or_trash_where("files_links", "element_id=".$del_id, $trash_id);
		$this->diafan->del_or_trash_where("files_counter", "element_id=".$del_id, $trash_id);
	}
}