<?php
/**
 * Настройки модуля
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Forum_admin_config
 */
class Forum_admin_config extends Frame_admin
{
	/**
	 * @var array поля в базе данных для редактирования
	 */
	public $variables = array (
		'config' => array (
			'nastr' => array(
				'type' => 'numtext',
				'name' => 'Количество тем на странице',
				'help' => 'Количество одновременно выводимых тем в списке.',
			),
			'format_date' => array(
				'type' => 'select',
				'name' => 'Формат даты',
				'help' => 'Позволяет настроить отображение даты в модуле.',
			),
			'count_level' => array(
				'type' => 'numtext',
				'name' => 'Максимальная вложенность',
				'help' => 'Ограничивает вложенность дерева сообщений.',
			),
			'nastr_messages' => array(
				'type' => 'numtext',
				'name' => 'Количество сообщений на странице',
				'help' => 'Количество одновременно выводимых в сообщений верхнего уровня.',
			),
			'news_count_days' => array(
				'type' => 'numtext',
				'name' => 'Сколько дней хранить «новые» сообщения',
				'help' => 'Для чистки мусора в логе новых сообщений. При большом количестве пользователей рекомендуется устанавливать не более трех дней.',
			),
			'sort' => array(
				'type' => 'checkbox',
				'name' => 'Использовать ручную сортировку разделов',
				'help' => '',
			),
			'hr1' => 'hr',
			'captcha' => array(
				'type' => 'checkbox',
				'name' => 'Использовать защитный код (каптчу)',
				'help' => 'Для добавления сообщения пользователь должен ввести защитный код.',
			),
			'only_user' => array(
				'type' => 'checkbox',
				'name' => 'Только для зарегистрированных пользователей',
				'help' => '',
			),
			'premoderation_theme' => array(
				'type' => 'checkbox',
				'name' => 'Предмодерация темы для обсуждения',
				'help' => 'Добавленные темы отображаются на сайте только после одобрения модератором.',
			),
			'premoderation_message' => array(
				'type' => 'checkbox',
				'name' => 'Предмодерация сообщений',
				'help' => 'Добавленные сообщения отображаются на сайте только после одобрения модератором.',
			),
			'hr2' => 'hr',
			'attachments' => array(
				'type' => 'module',
				'name' => 'Разрешить добавление файлов',
				'help' => 'Позволяет пользователям прикреплять файлы к сообщениям.',
			),
			'max_count_attachments' => array(
				'type' => 'none',
				'name' => 'Максимальное количество добавляемых файлов',
				'help' => 'Количество добавляемых файлов. Если значение равно нулю, то форма добавления файлов не выводится.',
				'no_save' => true,
			),
			'attachment_extensions' => array(
				'type' => 'none',
				'name' => 'Доступные типы файлов (через запятую)',
				'no_save' => true,
			),
			'recognize_image' => array(
				'type' => 'none',
				'name' => 'Распознавать изображения',
				'help' => 'Позволяет прикрепленные к вопросу файлы в формате JPEG, GIF, PNG отображать как изображения.',
				'no_save' => true,
			),
			'attach_big' => array(
				'type' => 'none',
				'name' => 'Размер для большого изображения',
				'help' => 'Размер изображения, отображаемый в пользовательской части сайта при увеличении изображения предпросмотра.',
				'no_save' => true,
			),
			'attach_medium' => array(
				'type' => 'none',
				'name' => 'Размер для маленького изображения',
				'help' => 'Размер изображения предпросмотра.',
				'no_save' => true,
			),
			'attach_use_animation' => array(
				'type' => 'none',
				'name' => 'Использовать анимацию при увеличении изображений',
				'help' => 'Параметр добавляет JavaScript код, позволяющий включить анимацию при увеличении изображений. Параметр выводится, если отмечена опция «Распознавать изображения».',
				'no_save' => true,
			),
			'upload_max_filesize' => array(
				'type' => 'none',
				'name' => 'Максимальный размер загружаемых файлов',
				'help' => 'Параметр показывает максимально допустимый размер загружаемых файлов, установленный в настройках хостинга.',
				'no_save' => true,
			),
		),
	);

	/**
	 * @var array настройки модуля
	 */
	public $config = array (
		'config', // файл настроек модуля
	);

	/**
	 * @var array значения списков
	 */
	public $select_arr = array(
		'format_date' => array(
			0 => '01.05.2013',
			6 => '01.05.2013 14:45',
			1 => '1 мая 2013 г.',
			2 => '1 мая',
			3 => '1 мая 2013, понедельник',
			5 => 'вчера 15:30',
			4 => 'не отображать',
		),
	);
}