<?php
/**
 * Карта ссылок для модуля «Карта сайта»
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Forum_sitemap
 */
class Forum_sitemap extends Diafan
{
	/**
	 * Возвращает настройки для генерирования карты модуля
	 * 
	 * @param integer $site_id номер страницы сайта
	 * @return array
	 */
	public function config($site_id)
	{
		$ids = array();
		$rows = DB::query_fetch_all("SELECT id FROM {forum_category} WHERE trash='0' AND parent_id=0 AND act='1'");
		foreach($rows as $row)
		{
			$ids[] = $row["id"];
		}
		if (! $ids)
		{
			return true;
		}

		$result = array(
			'type' => array('element', 'category'),
			'table' => 'forum_category',
			'where' =>
			array(
				'category' => " AND parent_id IN (".implode(',', $ids).") AND act='1'",
				'element' => " AND parent_id NOT IN (0,".implode(',', $ids).") AND act='1'",
			)
		);
		return $result;
	}
}