/**
 * Подключение модуля к административной части других модулей, JS-сценарий
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */
var images_count = 0;
$(document).ready(function(){
	$('.fileupload').each(function(){
		var id = $(this).attr('id');
		var param_id = $(this).attr('param_id');
		var tmpcode = $('input[name=tmpcode]').val();
		if(tmpcode == undefined)
		{
			tmpcode = '';
		}
		$(this).fileupload({
			dataType: 'json',
			submit: function(e, data) {
				images_count = images_count+1;
				$('.errors').hide();
				data.formData = {
					action : "upload",
					ajax: 1,
					module: "images",
					id: $('input[name=id]').val(),
					tmpcode: tmpcode,
					name: $('input[name=name]').val(),
					site_id: $('input[name=site_id], select[name=site_id]').val(),
					param_id: param_id
				};
				$.each(data.files, function (k,v){
					$('td[param_id='+param_id+'] .fileupload').after('<div class="images_status" name="'+v.name+'">'+v.name+'</div>');
				});
			},
			done: function (e, data) {
				result_upload(data.result, param_id);
				$.each(data.files, function (k,v){
					$('td[param_id='+param_id+'] .images_status[name="'+v.name+'"]').html(v.name+' <span style="color:green">ok</span>').removeClass('images_status').addClass('images_status_ok');
				});
				images_count = images_count-1;
				if(images_count < 1)
				{
					$.ajax({
						type : "POST",
						data : {
							action : "show",
							module: "images",
							id: $('input[name=id]').val(),
							tmpcode: tmpcode,
							site_id: $('input[name=site_id], select[name=site_id]').val(),
							param_id: param_id
						},
						dataType: "json",
						url: window.location.href,
				
						success: function(response, statusText, xhr, form)
						{
							if (response.data && response.target)
							{
								$(response.target).html(prepare(response.data));
								$("a[rel^='prettyPhoto']").prettyPhoto({theme:'facebook', social_tools: ''});
							}
							$('td[param_id='+param_id+'] .images_status_ok').remove();
						}
					});
				}
			}
		});
	});

	$(document).on('click', ".images_actions a", function() {
		var param_id = $(this).parents('td').attr('param_id');
		var self = $(this);
		if (! self.attr("action"))
		{
			return true;
		}
		if (self.attr("confirm") && ! confirm(self.attr("confirm")))
		{
			return false;
		}
		$.ajax({
			url : window.location.href,
			type : 'POST',
			dataType : 'json',
			data : {
				action: self.attr("action"),
				module: 'images',
				element_id : self.parents(".images_actions").attr("element_id"),
				tmpcode: $('input[name=tmpcode]').val(),
				image_id : self.parents(".images_actions").attr("image_id"),
				check_hash_user : $('.check_hash_user').text()
			},
			success : (function(response)
			{
				if (response.error)
				{
					$(".error_images"+param_id).html(response.error).show();
				}
				if(response.errors && response.errors['image'])
				{
					$(form).find(".error_images"+param_id).html(response.errors['image']).show();
				}
				if (response.target)
				{
					$(response.target).html(prepare(response.data));
					$("a[rel^='prettyPhoto']").prettyPhoto({theme:'facebook', social_tools: ''});
				}
				else
				{
					$(th).parents(".images_actions").html(prepare(response.data));
				}
				if (response.hash)
				{
					$('input[name=check_hash_user]').val(response.hash);
					$('.check_hash_user').text(response.hash);
				}
			})
		});
		return false;
	});
	
	$(document).on('click', '.delete_images', function(){
		var param_id = $(this).parents('td').attr('param_id');
		var images_actions = '';
		var image_ids = new Array;
		$(this).parents('td').find('.images_container').find('input[name=image_check]').each(function(){
			if($(this).is(":checked"))
			{
				image_ids.push($(this).parents('.images_actions').attr('image_id'));
				images_actions = $(this).parents('.images_actions');
			}
		});
		if (! image_ids[0])
		{
			alert($(this).attr("empty"));
			return false;
		}
		if ($(this).attr("confirm") && ! confirm($(this).attr("confirm")))
		{
			return false;
		}
		$.ajax({
			url : window.location.href,
			type : 'POST',
			dataType : 'json',
			data : {
				action: 'delete',
				module: 'images',
				element_id : images_actions.attr("element_id"),
				tmpcode: $('input[name=tmpcode]').val(),
				image_ids : image_ids,
				check_hash_user : $('.check_hash_user').text()
			},
			success : (function(response)
			{
				if (response.error)
				{
					$(".error_images"+param_id).html(response.error).show();
				}
				if(response.errors && response.errors['image'])
				{
					$(form).find(".error_images"+param_id).html(response.errors['image']).show();
				}
				if (response.target)
				{
					$(response.target).html(prepare(response.data));
					$("a[rel^='prettyPhoto']").prettyPhoto({theme:'facebook', social_tools: ''});
				}
				if (response.hash)
				{
					$('input[name=check_hash_user]').val(response.hash);
					$('.check_hash_user').text(response.hash);
				}
			})
		});
		return false;
	});

	$(document).on('mouseover', ".images_actions", function(){
		$(this).addClass('hover');
		$(this).find('.images_button').show();
	});

	$(document).on('mouseout', ".images_actions", function(){
		$(this).removeClass('hover');
		$(this).find('.images_button').hide();
	});

	$(document).on('click', ".ajax_save_image", function(){
		var self = $(this);
		$.ajax({
			url : window.location.href,
			type : 'POST',
			dataType : 'json',
			data : {
				action: 'save',
				module: 'images',
				element_id : self.parents(".images_actions").attr("element_id"),
				tmpcode: $('input[name=tmpcode]').val(),
				image_id : self.parents(".images_actions").attr("image_id"),
				check_hash_user : $('.check_hash_user').text(),
				alt : self.parents("div").find("input[name=alt]").val(),
				title : self.parents("div").find("input[name=title]").val()
			},
			success : (function(response)
			{
				if (response.data && response.target)
				{
					$(response.target).html(prepare(response.data));
					$("a[rel^='prettyPhoto']").prettyPhoto({theme:'facebook', social_tools: ''});
				}
				if (response.hash)
				{
					$('input[name=check_hash_user]').val(response.hash);
					$('.check_hash_user').text(response.hash);
				}
			})
		});
	});
	$(document).on('click', ".images_selectarea_button", function(){
		var selectarea_div = $(this).parents('.selectarea');

		var param_id = selectarea_div.parents('td').attr('param_id');

		if(selectarea_div.find("input[name=x1]").val() == selectarea_div.find("input[name=x2]").val()
		||  selectarea_div.find("input[name=y1]").val() == selectarea_div.find("input[name=y2]").val())
		{
			alert(selectarea_div.find(".images_selectarea_info").text());
			return false;
		}
		$.ajax({
			type : "POST",
			data : {
				action: "selectarea",
				module : "images",
				x1: selectarea_div.find("input[name=x1]").val(),
				x2: selectarea_div.find("input[name=x2]").val(),
				y1: selectarea_div.find("input[name=y1]").val(),
				y2: selectarea_div.find("input[name=y2]").val(),
				id: selectarea_div.find("input[name=image_id]").val(),
				variation_id: selectarea_div.find("input[name=variation_id]").val(),
				check_hash_user : $('.check_hash_user').text()
			},
			dataType: "json",
			url: window.location.href,
	
			success: function(response, statusText, xhr, form)
			{
				if (response.hash)
				{
					$('input[name=check_hash_user]').val(response.hash);
					$('.check_hash_user').text(response.hash);
				}
				selectarea_div.text('');
				selectarea_div.hide();
				$('.imgareaselect-selection').parents('div').remove();
				$('.imgareaselect-outer').remove();
				get_selectarea(param_id);
				return false;
			}
		});
		return false;
	});
	$("input[name=images_upload_links_check]").click(function(){
		$(this).next('.div_images_links').toggle();
	});
	$(".images_upload_links").click(function(){
		var param_id = $(this).attr('param_id');
		var tmpcode = $('input[name=tmpcode]').val();
		if(tmpcode == undefined)
		{
			tmpcode = '';
		}
		var textarea_links = $(this).parents('.div_images_links').find('textarea');
		$.ajax({
			type : "POST",
			data : {
				action : "upload_links",
				links : textarea_links.val(),
				module: "images",
				id: $('input[name=id]').val(),
				tmpcode: tmpcode,
				name: $('input[name=name]').val(),
				site_id: $('input[name=site_id], select[name=site_id]').val(),
				param_id: param_id,
				check_hash_user : $('.check_hash_user').text()
			},
			dataType: "json",
			url: window.location.href,
	
			success: function(response, statusText, xhr, form)
			{
				result_upload(response, param_id);
				textarea_links.val('');
			}
		});
	});
});

function result_upload(response, param_id)
{
	if (response.selectarea)
	{
		$.each(response.selectarea, function (k, v) {
			$('td[param_id='+param_id+'] .selectarea').after('<div class="selectarea_next" style="display:none">'+prepare(v)+'</div>');
		});
		get_selectarea(param_id);
	}
	if (response.id)
	{
		$("input[name=id]").val(response.id);
	}
	if (response.error)
	{
		$(".error_images"+param_id).html(response.error).show();
	}
	if(response.errors && response.errors['image'])
	{
			$(".error_images"+param_id).html(response.errors['image']).show();
	}
	if (response.data && response.target)
	{
		$(response.target).html(prepare(response.data));
		$("a[rel^='prettyPhoto']").prettyPhoto({theme:'facebook', social_tools: ''});
	}
	if (response.hash)
	{
		$('input[name=check_hash_user]').val(response.hash);
		$('.check_hash_user').text(response.hash);
	}
}
function get_selectarea(param_id)
{
	var selectarea = $("td[param_id="+param_id+"] .selectarea");
	if(selectarea.html())
	{
		return;
	}
	if($('td[param_id='+param_id+'] .selectarea_next').length)
	{
		selectarea.html($('td[param_id='+param_id+'] .selectarea_next').last().html()).show();
		$('td[param_id='+param_id+'] .selectarea_next').last().remove();

		selectarea.find(".images_selectarea").imgAreaSelect({remove : true});

		selectarea.find(".images_selectarea").imgAreaSelect({
			aspectRatio: selectarea.find('.images_selectarea').attr('select_width')+":"+selectarea.find('.images_selectarea').attr('select_height'),
			handles: true,
			onSelectEnd: function (img, selection) {
				selectarea.find("input[name=x1]").val(selection.x1);
				selectarea.find("input[name=y1]").val(selection.y1);
				selectarea.find("input[name=x2]").val(selection.x2);
				selectarea.find("input[name=y2]").val(selection.y2);
			}
		});
	}
}