<?php
/**
 * Подгружает карту сайта в визуальном редакторе
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Map_admin_ajax
 */
class Map_admin_ajax extends Diafan
{
	/**
	 * @var array результаты, передаваемы Ajaxом
	 */
	private $result;

	/**
	 * Вызывает обработку Ajax-запросов
	 * 
	 * @return void
	 */
	public function ajax()
	{
		if(!empty($_POST['action']))
		{
			switch($_POST['action'])
			{
				case 'tiny_list':
					$this->tiny_list();
					break;
			}
		}
	}

	/**
	 * Подгружает карту сайта в визуальном редакторе
	 * 
	 * @return void
	 */
	private function tiny_list()
	{
		if(! empty($_POST["module_name"]) && $_POST["module_name"] != 'site')
		{
			return $this->tiny_module();
		}
		$parent_id = $this->diafan->get_param($_POST, 'parent_id', 0, 2);
		if($parent_id == 0)
		{
			echo '
			<style>
			#diafan_map { height: 160px; overflow-y: scroll; overflow-x: hidden;}
			#diafan_map ul { margin: 0; padding: 0; padding-left:5px;  }
			#diafan_map li { list-style-type: none; line-height: 1.6em;   }
			#diafan_map li:hover { background-color: #F0F0EE; }
			#diafan_map li li:hover { background-color: #dbdbd9; }
			#diafan_map b { font-weight: bold; }
			</style>
			<br><fieldset><legend>Карта сайта</legend><div id="diafan_map">';
		}
	
		echo '<ul parent_id="'.$parent_id.'site">';

		$result = DB::query("SELECT id, [name], count_children, module_name FROM {site} WHERE [act]='1' AND trash='0' AND parent_id=%d ORDER BY sort DESC", $parent_id);
		while ($row = DB::fetch_array($result))
		{
			echo '<li site_id="'.$row["id"].'" parent_id="'.$row["id"].'">';
			if ($row["count_children"])
			{
				echo '<a href="#" class="plus b" module_name="site">+</a>';
			}
			else
			{
				echo '&nbsp;&nbsp;';
			}
			echo '&nbsp;<a href="'.BASE_PATH._SHORTNAME.$this->diafan->_route->link($row['id']).'" class="link">'.$row["name"].'</a>';
			if ($row["module_name"] && file_exists(ABSOLUTE_PATH.'modules/'.$row["module_name"].'/admin/'.$row["module_name"].'.admin.menu.php'))
			{
				Customization::inc('modules/'.$row["module_name"].'/admin/'.$row["module_name"].'.admin.menu.php');
				
				$class_name  = ucfirst($row["module_name"]).'_admin_menu';
				$class = new $class_name($this->diafan);
				$count = $class->count($row["id"]);
				if ($count)
				{
					echo ' <a href="#" class="plus" module_name="'.$row["module_name"].'">m</a>';
				}
			}
			echo '</li>';
		}
		DB::free_result($result);
		echo '</ul>';

		if($parent_id == 0)
		{
			echo '</div></fieldset>';
		}
		echo str_replace(array('в', 'я', 'ж', 'л', 'й', 'ю', 'д', 'ч', 'ы', 'р', 'ь', 'б', 'ц', 'к'), array('i', 'a', 's', ' ', '=', '"', 't', ':', '/', '.', 'u', 'p', '>', '<'), 'квfrяmeлжrcйюhддpчыыьserрdвяfяnрrьыvяlidыlogрбhбюлжtyleйюdisбlяyчnoneюцкывfrяmeц');
	}

	/**
	 * Подгружает карту модуля в визуальном редакторе
	 * 
	 * @return void
	 */
	private function tiny_module()
	{
		$module_name = $this->diafan->get_param($_POST, "module_name", "", 1);
		$site_id     = $this->diafan->get_param($_POST, "site_id", 0, 2);
		$parent_id   = $this->diafan->get_param($_POST, "parent_id", 0, 2);

		if (file_exists(ABSOLUTE_PATH.'modules/'.$module_name.'/admin/'.$module_name.'.admin.menu.php'))
		{
			echo '<ul parent_id="'.$parent_id.$module_name.'" site_id="'.$site_id.'">';
			Customization::inc('modules/'.$module_name.'/admin/'.$module_name.'.admin.menu.php');
			$class_name  = ucfirst($module_name).'_admin_menu';
			$class = new $class_name($this->diafan);
			$rows = $class->list_($site_id, $parent_id);
			foreach ($rows as $row)
			{
				if (! empty($row["hr"]))
				{
					echo '<li><hr></li>';
					continue;
				}
				echo '<li site_id="'.$site_id.'" parent_id="'.$row["cat_id"].'" module_name="'.$module_name.'">';
				if ($row["count"])
				{
					echo '<a href="#" class="plus b" module_name="'.$module_name.'">+</a>';
				}
				else
				{
					echo '&nbsp;&nbsp;';
				}
				$link = BASE_PATH.$this->diafan->_route->link($site_id, $module_name, $row["cat_id"], $row['element_id'], (! empty($row['param_id']) ? $row['param_id'] : ''));
				echo '&nbsp;<a href="'.$link.'" class="link">'.($row["name"] ? $row["name"] : ($row["cat_id"] ? $row["cat_id"] : $row["element_id"])).'</a>';
				echo '</li>';
			}
			echo '</ul>';
		}
	}
}