<?php
/**
 * Карта сайта в XML формате
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(__FILE__)).'/includes/404.php';
}

if (! DB::query_result("SELECT id FROM {modules} WHERE module_name='map' LIMIT 1"))
{
	include ABSOLUTE_PATH."includes/404.php";
}

/**
 * Map_sitemap
 */
class Map_sitemap extends Diafan
{
	/**
	 * @var integer максимальное количество ссылок
	 */
	private $max_url = 5000;

	/**
	 * Инициирует генерирование файла sitemap.xml
	 * 
	 * @return void
	 */
	public function init()
	{
		if(! $this->diafan->configmodules("full_index", "map"))
		{
			$this->diafan->_map->index_all();
		}
		$count = DB::query_result("SELECT COUNT(*) FROM {map_index} WHERE trash='0'");
		if($count > $this->max_url)
		{
			if($_GET["rewrite"] == 'sitemap.xml')
			{
				$this->main(ceil($count / $this->max_url));
			}
			else
			{
				$page = intval($_GET["rewrite"]);
				if(! $page || $page * $this->max_url + 1 >$count)
				{
					include(ABSOLUTE_PATH.'includes/404.php');
				}
				$this->map($page);
			}
		}
		else
		{
			$this->map(1);
		}
		
	}

	/**
	 * Индекс файлов
	 * 
	 * @return void
	 */
	private function main($max)
	{
		header('Content-type: application/xml'); 
		echo '<?xml version="1.0" encoding="UTF-8"?>';
		echo '<sitemapindex xmlns="http://www.sitemaps.org/schemas/sitemap/0.9">';
		for($i = 1; $i < $max; $i++)
		{
			echo '<sitemap>
				<loc>'.BASE_PATH.'map/sitemap/'.$i.'/</loc>
			</sitemap>';
		}
		echo '</sitemapindex>';
	}

	/**
	 * Индекс ссылок
	 * 
	 * @return void
	 */
	private function map($page)
	{
		header('Content-type: application/xml'); 
		echo '<?xml version="1.0" encoding="UTF-8"?>';
		echo '<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9">';
		$rows = DB::query_range_fetch_all("SELECT * FROM {map_index} WHERE trash='0' ORDER BY id ASC", ($page - 1) * $this->max_url, $this->max_url);
		foreach($rows as $row)
		{
			echo '<url>';
			echo '<loc>'. BASE_PATH.str_replace('ROUTE_END', ROUTE_END, $row["url"]).'</loc>';
			echo '<lastmod>'.date('Y-m-d', $row["timeedit"]).'</lastmod>';
			if($row["changefreq"])
			{
				echo '<changefreq>'.$row["changefreq"].'</changefreq>';
			}
			if($row["priority"])
			{
				echo '<priority>'.$row["priority"].'</priority>';
			}
			echo '</url>';
		}
		echo '</urlset>';
	}
}


$sitemap = new Map_sitemap($this);
$sitemap->init();
exit;