<?php
/**
 * Контроллер
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Menu
 */
class Menu extends Controller
{
	/**
	 * Выводит контент модуля
	 * 
	 * @return boolean true
	 */
	public function show_module()
	{
		return true;
	}

	/**
	 * Шаблонная функция: выводит меню.
	 * 
	 * @param array $attributes атрибуты шаблонного тега
	 * id - идентификатор категории меню
	 * template - имя шаблона
	 * tag_start_номер - текст, выводимый перед каждой ссылкой меню (может содержать слово **Increment** – при выводе автоматически заменяемое на арифметическую прогресиию, 1, 2, 3, … и Level – заменяемое на номер уровня меню)
	 * tag_end_номер - текст, выводимый после каждой ссылки пункта меню (может содержать слово Increment - заменяемое на увеличивающийся номер и **Level** – заменяемое на номер уровня меню)
	 * tag_level_start_номер - текст, выводимый перед уровнем (номер) меню
	 * tag_level_end_номер - текст, выводимый после уровня (номер) меню
	 * tag_active_start_номер - текст, выводимый перед активным пунктом меню уровня (может содержать слово **Increment** - заменяемое на увеличивающийся номер и **Level** – заменяемое на номер уровня меню)
	 * tag_active_end_номер - текст, выводимый после активного пункта меню уровня (может содержать слово Increment - заменяемое на увеличивающийся номер и **Level** – заменяемое на номер уровня меню)
	 * tag_active_child_start_номер - текст, выводимый перед пунктом меню уровня (номер) с активным дочерним пунктом (может содержать слово **Increment** - заменяемое на увеличивающийся номер и **Level** – заменяемое на номер уровня меню)
	 * tag_active_child_end_номер - текст, выводимый после пункта меню уровня (номер) с активным дочерним пунктом (может содержать слово **Increment** - заменяемое на увеличивающийся номер и **Level** – заменяемое на номер уровня меню)
	 * separator_номер - текст, разделяющий пункты меню
	 * 
	 * @return void
	 */
	public function show_block($attributes)
	{
		$attributes = $this->get_attributes(
			$attributes, 'id', 'template',
			'tag_start_1', 'tag_end_1', 'tag_active_start_1', 'tag_active_end_1', 'tag_level_start_1',
			'tag_level_end_1', 'tag_active_child_start_1', 'tag_active_child_end_1', 'separator_1'
		);

		$id = intval($attributes["id"]);
		$result = $this->model->show_block($id);
		if (! $result)
		{
			return false;
		}
		
		$result["attributes"] = $attributes;

		if ($attributes["template"] === "default")
		{
			$this->diafan->_tpl->get('show_block', 'menu', $result);
		}
		if ($attributes["template"] === "select" && !empty($result['menu_template']))
		{
			$this->diafan->_tpl->get($result['menu_template'], 'menu', $result);
		}
		elseif ($attributes["template"])
		{
			$this->diafan->_tpl->get('show_block_'.$attributes["template"], 'menu', $result);
		}
		else
		{
			$this->diafan->_tpl->get('show_menu', 'menu', $result);
		}
	}
}