<?php
/**
 * Шаблон список новостей
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

echo '<div class="news_list">';

//вывод описания текущей категории новостей
if (! empty($result["text"]))
{
	echo '<div class="news_cat_text">';
	$this->htmleditor($result['text'], true);
	echo '</div>';
}

//рейтинг категории
if (! empty($result["rating"]))
{
	echo $result["rating"];
}

//вывод изображений текущей категории
if (! empty($result["img"]))
{
	echo '<div class="news_cat_all_img">';
	foreach ($result["img"] as $img)
	{
		switch($img["type"])
		{
			case 'animation':
				echo '<a href="'.BASE_PATH.$img["link"].'" rel="prettyPhoto[gallery'.$result["id"].'news]">';
				break;
			case 'large_image':
				echo '<a href="'.BASE_PATH.$img["link"].'" rel="large_image" width="'.$img["link_width"].'" height="'.$img["link_height"].'">';
				break;
			default:
				echo '<a href="'.BASE_PATH_HREF.$img["link"].'">';
				break;
		}
		echo '<img src="'.$img["src"].'" width="'.$img["width"].'" height="'.$img["height"].'" alt="'.$img["alt"].'" title="'.$img["title"].'">'
		.'</a> ';
	}
	echo '</div>';
}

//вывод подкатегорий
if (! empty($result["children"]))
{
	foreach ($result["children"] as $child)
	{
		echo '<div class="news_cat_link">';

		//изображение подкатегории
		if (! empty($child["img"]))
		{
			echo '<div class="news_cat_img">';
			foreach ($child["img"] as $img)
			{
				switch($img["type"])
				{
					case 'animation':
						echo '<a href="'.BASE_PATH.$img["link"].'" rel="prettyPhoto[gallery'.$child["id"].'news]">';
						break;
					case 'large_image':
						echo '<a href="'.BASE_PATH.$img["link"].'" rel="large_image" width="'.$img["link_width"].'" height="'.$img["link_height"].'">';
						break;
					default:
						echo '<a href="'.BASE_PATH_HREF.$img["link"].'">';
						break;
				}
				echo '<img src="'.$img["src"].'" width="'.$img["width"].'" height="'.$img["height"].'" alt="'.$img["alt"].'" title="'.$img["title"].'">'
				.'</a> ';
			}
			echo '</div>';
		}

		//название и ссылка подкатегории
		echo '<a href="'.BASE_PATH_HREF.$child["link"].'">'.$child["name"].'</a>';

		//рейтинг подкатегории
		if (! empty($child["rating"]))
		{
			echo $child["rating"];
		}

		//краткое описание подкатегории
		if ($child["anons"])
		{
			echo '<div class="news_cat_anons">';
			$this->htmleditor($child['anons']);
			echo '</div>';
		}
		//новости подкатегории
		if (! empty($child["rows"]))
		{
			foreach ($child["rows"] as $row)
			{
				echo '<div class="news">';
		
				//вывод даты новости
				if (! empty($row['date']))
				{
					echo '<div class="news_date">'.$row["date"]."</div>";
				}
		
				//вывод названия и ссылки на новость
				echo '<div class="news_name">';
				echo '<a href="'.BASE_PATH_HREF.$row["link"].'">'.$row["name"].'</a>';
				//вывод рейтинга новости за названием, если рейтинг подключен
				if (! empty($row["rating"]))
				{
					echo ' ' .$row["rating"];
				}
				echo '</div>';
		
				//вывод изображений новости
				if (! empty($row["img"]))
				{
					echo '<div class="news_img">';
					foreach ($row["img"] as $img)
					{
						switch($img["type"])
						{
							case 'animation':
								echo '<a href="'.BASE_PATH.$img["link"].'" rel="prettyPhoto[gallery'.$row["id"].'news]">';
								break;
							case 'large_image':
								echo '<a href="'.BASE_PATH.$img["link"].'" rel="large_image" width="'.$img["link_width"].'" height="'.$img["link_height"].'">';
								break;
							default:
								echo '<a href="'.BASE_PATH_HREF.$img["link"].'">';
								break;
						}
						echo '<img src="'.$img["src"].'" width="'.$img["width"].'" height="'.$img["height"].'" alt="'.$img["alt"].'" title="'.$img["title"].'">'
						.'</a> ';
					}
					echo '</div>';
				}
		
				//вывод анонса новостей
				if (! empty($row["anons"]))
				{
					echo '<div class="news_anons">';
					$this->htmleditor($row['anons']);
					echo '</div>';
				}
		
		
				//вывод прикрепленных тегов к новости
				if (! empty($row["tags"]))
				{
					echo $row["tags"];
				}
				echo '<div class="clear"></div>';
		
				echo '</div>';
			}
		}
		echo '</div>';
	}
}



//вывод списка новостей
if (! empty($result["rows"]))
{
	foreach ($result["rows"] as $row)
	{
		echo '<div class="news">';

		//вывод даты новости
		if (! empty($row['date']))
		{
			echo '<div class="news_date">'.$row["date"]."</div>";
		}

		//вывод названия и ссылки на новость
		echo '<div class="news_name">';
		echo '<a href="'.BASE_PATH_HREF.$row["link"].'">'.$row["name"].'</a>';
		//вывод рейтинга новости за названием, если рейтинг подключен
		if (! empty($row["rating"]))
		{
			echo ' ' .$row["rating"];
		}
		echo '</div>';

		//вывод изображений новости
		if (! empty($row["img"]))
		{
			echo '<div class="news_img">';
			foreach ($row["img"] as $img)
			{
				switch($img["type"])
				{
					case 'animation':
						echo '<a href="'.BASE_PATH.$img["link"].'" rel="prettyPhoto[gallery'.$row["id"].'news]">';
						break;
					case 'large_image':
						echo '<a href="'.BASE_PATH.$img["link"].'" rel="large_image" width="'.$img["link_width"].'" height="'.$img["link_height"].'">';
						break;
					default:
						echo '<a href="'.BASE_PATH_HREF.$img["link"].'">';
						break;
				}
				echo '<img src="'.$img["src"].'" width="'.$img["width"].'" height="'.$img["height"].'" alt="'.$img["alt"].'" title="'.$img["title"].'">'
				.'</a> ';
			}
			echo '</div>';
		}

		//вывод анонса новостей
		if (! empty($row["anons"]))
		{
			echo '<div class="news_anons">';
			$this->htmleditor($row['anons']);
			echo '</div>';
		}

		//вывод прикрепленных тегов к новости
		if (! empty($row["tags"]))
		{
			echo $row["tags"];
		}
		echo '<div class="clear"></div>';

		echo '</div>';
	}
}

//вывод постраничная навигация в конце списка новостей
if (! empty($result["paginator"]))
{
	echo $result["paginator"];
}

//вывод ссылок на предыдущую и последующую категории
if (! empty($result["previous"]) || ! empty($result["next"]))
{
	echo '<div class="previous_next_links">';
	if (! empty($result["previous"]))
	{
		echo '<div class="previous_link"><a href="'.BASE_PATH_HREF.$result["previous"]["link"].'">&larr; '.$result["previous"]["text"].'</a></div>';
	}
	if (! empty($result["next"]))
	{
		echo '<div class="next_link"><a href="'.BASE_PATH_HREF.$result["next"]["link"].'">'.$result["next"]["text"].' &rarr;</a></div>';
	}
	echo '</div>';
}

//вывод комментариев к категориям, если они подключены в настройках
if (! empty($result["comments"]))
{
	echo $result["comments"];
}

echo '</div>';