<?php
/**
 * Настройки модуля
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Photo_admin_config
 */
class Photo_admin_config extends Frame_admin
{
	/**
	 * @var array поля в базе данных для редактирования
	 */
	public $variables = array (
		'config'       => array (
			'nastr' => array(
				'type' => 'numtext',
				'name' => 'Количество фотографий на странице',
				'help' => 'Количество одновременно выводимых фотографий в списке.',
			),
			'hr1' => 'hr',
			'cat' => array(
				'type' => 'checkbox',
				'name' => 'Использовать альбомы',
				'help' => 'Разделение фотогалереи на альбомы-подкатегории.',
			),
			'count_list' => array(
				'type' => 'numtext',
				'name' => 'Количество фотографий в списке альбомов',
				'help' => 'Количество фотографий, выводимых в списке альбомов на главной странице модуля.',
			),
			'count_child_list' => array(
				'type' => 'numtext',
				'name' => 'Количество фотографий в списке вложенной категории',
				'help' => 'Для первой страницы модуля и для страницы категории.',
			),
			'children_elements' => array(
				'type' => 'checkbox',
				'name' => 'Показывать фотографии вложенных альбомов',
				'help' => 'Если отмечена, в списке фотоальбомов будут отображатся последние добавленные фотографии из всех вложенных альбомов.',
			),
			'hr2' => 'hr',
			'images' => array(
				'type' => 'module',
				'name' => 'Изображения',
				'hide' => true,
			),
			'images_variations' => array(
				'type' => 'none',
				'name' => 'Генерировать размеры изображений',
				'help' => 'Размеры изображений, заданные в модуле «Изобаражения» и тег латинскими буквами для подключения изображения на сайте. Обязательно должны быть заданы два размера: превью изображения в списке фотографий (тег medium) и полное изображение (тег large).',
				'no_save' => true,
			),
			'images_cat' => array(
				'type' => 'none',
				'name' => 'Использовать изображения для альбомов',
				'help' => 'Позволяет включить/отключить загрузку изображений к альбомам.',
				'no_save' => true,
			),
			'images_variations_cat' => array(
				'type' => 'none',
				'name' => 'Генерировать размеры изображений для альбомов',
				'help' => 'Размеры изображений, заданные в модуле «Изобаражения» и тег латинскими буквами для подключения изображения на сайте. Обязательно должны быть заданы два размера: превью изображения в списке альбомов (тег medium) и полное изображение (тег large).',
				'no_save' => true,
			),
			'list_img_cat' => array(
				'type' => 'none',
				'name' => 'Отображение изображений в списке альбомов',
				'help' => "Параметр принимает значения:\n\n* нет (отключает отображение изображений в списке);\n* показывать одно изображение;\n* показывать все изображения. Параметр выводится, если отмечена опция «Использовать изображения».",
				'no_save' => true,
			),
			'use_animation' => array(
				'type' => 'none',
				'name' => 'Использовать анимацию при увеличении изображений',
				'help' => 'Параметр добавляет JavaScript код, позволяющий включить анимацию при увеличении изображений. Параметр выводится, если отмечена опция «Использовать изображения».',
				'no_save' => true,
			),
			'upload_max_filesize' => array(
				'type' => 'none',
				'name' => 'Максимальный размер загружаемых файлов',
				'help' => 'Параметр показывает максимально допустимый размер загружаемых файлов, установленный в настройках хостинга. Параметр выводится, если отмечена опция «Использовать изображения».',
				'no_save' => true,
			),
			'resize' => array(
				'type' => 'none',
				'name' => 'Применить настройки ко всем ранее загруженным изображениям',
				'help' => 'Позволяет переконвертировать размер уже загруженных изображений. Кнопка необходима, если изменены настройки размеров изображений. Параметр выводится, если отмечена опция «Использовать изображения».',
				'no_save' => true,
			),
			'hr3' => 'hr',
			'multiupload_act'     => array(
				'type' => 'checkbox',
				'name' => 'Опубликовывать фотографии сразу после групповой загрузки',
				'name' => 'Позволяет показывать на сайте фотографии, загруженные с помощью ссылки «Добавить несколько фотографий».',
			),
			'page_show' => array(
				'type' => 'checkbox',
				'name' => 'Открывать фотографию на отдельной странице',
				'help' => 'Если не отмечена, фотографии из альбома будут сразу увеличиваться. Если отмечена, каждая фотография будет открываться на отдельной странице с полным текстовым описанием, ее можно будет комментировать, ставить рейтинг.',
			),
			'rel_two_sided' => array(
				'type' => 'checkbox',
				'name' => 'В блоке похожих фотографий связь двусторонняя',
				'help' => 'Если отметить, то при назначении фотографии А похожей фотографии Б, у фотографии Б автоматически станет похожая фотография А.',
			),
			'hr4' => 'hr',
			'comments' => array(
				'type' => 'module',
				'name' => 'Подключить комментарии к фотографиям',
				'help' => 'Подключение модуля «Комментарии». Параметр не будет включен, если модуль «Комментарии» не установлен. Подробности см. в разделе [модуль Комментарии»](http://cms.diafan.ru/dokument/full-manual/upmodules/comments/).',
			),
			'comments_cat' => array(
				'type' => 'none',
				'name' => 'Показывать комментарии к альбомам',
				'help' => 'Подключение модуля «Комментарии» к альбомам. Параметр не будет включен, если модуль «Комментарии» не установлен. Подробности см. в разделе [модуль Комментарии»](http://cms.diafan.ru/dokument/full-manual/upmodules/comments/).',
				'no_save' => true,
			),
			'tags' => array(
				'type' => 'module',
				'name' => 'Подключить теги к фотографиям',
				'help' => 'Подключение модуля «Теги». Параметр не будет включен, если модуль «Теги» не установлен. Подробности см. в разделе [модуль «Теги»](http://cms.diafan.ru/dokument/full-manual/modules/tags/).',
			),
			'rating' => array(
				'type' => 'module',
				'name' => 'Подключить рейтинг к фотографиям',
				'help' => 'Подключение модуля «Рейтинг». Параметр не будет включен, если модуль «Рейтинг» не установлен. Подробности см. в разделе [модуль «Рейтинг»](http://cms.diafan.ru/dokument/full-manual/upmodules/rating/).',
			),
			'rating_cat' => array(
				'type' => 'none',
				'name' => 'Подключить рейтинг к категориям',
				'help' => 'Подключение модуля «Рейтинг» к альбомам. Параметр не будет включен, если модуль «Рейтинг» не установлен. Подробности см. в разделе [модуль «Рейтинг»](http://cms.diafan.ru/dokument/full-manual/upmodules/rating/).',
				'no_save' => true,
			),
			'keywords' => array(
				'type' => 'module',
				'name' => 'Подключить перелинковку',
				'help' => 'Отображение перелинковки в модуле. Подробности см. в разделе [модуль «Перелинковка»](http://cms.diafan.ru/dokument/full-manual/upmodules/keywords/).',
			),
			'hr_count' => 'hr',
			'counter' => array(
				'type' => 'checkbox',
				'name' => 'Подключить счетчик просмотров',
				'help' => 'Позволяет считать количество просмотров отдельной фотографии.',
			),
			'counter_site' => array(
				'type' => 'checkbox',
				'name' => 'Выводить счетчик на сайте',
				'help' => 'Позволяет вывести на сайте количество просмотров отдельной фотографии. Параметр выводится, если отмечена опция «Счетчик просмотров».',
			),
			'hr7' => 'hr',
			'title_tpl' => array(
				'type' => 'text',
				'name' => 'Шаблон для автоматического генерирования Title',
				'help' => "Если шаблон задан, то заголовок автоматически генерируется по шаблону. В шаблон можно добавить:\n\n* %title – заданный заголовок,\n* %name – название,\n* %category – название альбома,\n* %parent_category – название альбома верхнего уровня (SEO-специалисту).",
				'multilang' => true
			),
			'title_tpl_cat' => array(
				'type' => 'text',
				'name' => 'Шаблон для автоматического генерирования Title для альбома',
				'help' => "Если шаблон задан, то заголовок автоматически генерируется по шаблону. В шаблон можно добавить:\n\n* %title – заданный заголовок,\n* %name – название альбома,\n* %parent – название альбома верхнего уровня,\n\n* %page – страница (текст можно поменять в интерфейсе «Языки сайта» – «Перевод интерфейса») (SEO-специалисту).",
				'multilang' => true
			),
			'keywords_tpl' => array(
				'type' => 'text',
				'name' => 'Шаблон для автоматического генерирования Keywords',
				'help' => "Если шаблон задан, то поле *Keywords* автоматически генерируется по шаблону. В шаблон можно добавить:\n\n* %keywords – заданные ключевые слова,\n* %name – название,\n* %category – название альбома,\n* %parent_category – название альбома верхнего уровня (SEO-специалисту).",
				'multilang' => true
			),
			'keywords_tpl_cat' => array(
				'type' => 'text',
				'name' => 'Шаблон для автоматического генерирования Keywords для категории',
				'help' => "Если шаблон задан, то поле *Keywords* автоматически генерируется по шаблону. В шаблон можно добавить:\n\n* %keywords – заданные ключевые слова,\n* %name – название альбома,\n* %parent – название альбома верхнего уровня (SEO-специалисту).",
				'multilang' => true
			),
			'descr_tpl' => array(
				'type' => 'text',
				'name' => 'Шаблон для автоматического генерирования Description',
				'help' => "Если шаблон задан, то поле *Description* автоматически генерируется по шаблону. В шаблон можно добавить:\n\n* %descr – заданное описание,\n* %name – название,\n* %category – название категории,\n* %parent_category – название категории верхнего уровня (SEO-специалисту).",
				'multilang' => true
			),
			'descr_tpl_cat' => array(
				'type' => 'text',
				'name' => 'Шаблон для автоматического генерирования Description для категории',
				'help' => 'Если шаблон задан, то поле Description автоматически генерируется по шаблону. В шаблон можно добавить %descr - заданное описание, %name - название категории, %parent - название категории верхнего уровня (SEO-специалисту).',
				'multilang' => true
			),
			'themes' => array(
				'type' => 'function',
				'hide' => true,
			),
			'theme_list' => array(
				'type' => 'none',
				'name' => 'Шаблон для списка элементов',
				'help' => 'По умолчанию modules/photo/views/photo.view.list.php. Параметр для разработчиков! Не устанавливайте, если не уверены в результате.',
			),
			'view_list' => array(
				'type' => 'none',
				'hide' => true,
			),
			'theme_first_page' => array(
				'type' => 'none',
				'name' => 'Шаблон для первой страницы модуля (если подключены альбомы)',
				'help' => 'По умолчанию modules/photo/views/photo.view.fitst_page.php. Параметр для разработчиков! Не устанавливайте, если не уверены в результате.',
			),
			'view_first_page' => array(
				'type' => 'none',
				'hide' => true,
			),
			'theme_id' => array(
				'type' => 'none',
				'name' => 'Шаблон для страницы элемента',
				'help' => 'По умолчанию, modules/photo/views/photo.view.id.php. Параметр для разработчиков! Не устанавливайте, если не уверены в результате.',
			),
			'view_id' => array(
				'type' => 'none',
				'hide' => true,
			),
			'hr_admin_page' => 'hr',
			'admin_page'     => array(
				'type' => 'checkbox',
				'name' => 'Отдельный пункт в меню администрирования для каждого раздела сайта',
				'help' => 'Если модуль подключен к нескольким страницам сайта, отметка данного параметра выведет несколько пунктов в меню административной части для удобства быстрого доступа (администратору сайта).',
			),
			'map' => array(
				'type' => 'module',
				'name' => 'Индексирование для карты сайта',
				'help' => 'При изменении настроек, влияющих на отображение страницы, модуль автоматически переиндексируется для карты сайта sitemap.xml.',
			),
		),
	);

	/**
	 * @var array настройки модуля
	 */
	public $config = array (
		'element_site', // делит элементы по разделам (страницы сайта, к которым прикреплен модуль)
		'config', // файл настроек модуля
	);

	/**
	 * @var array зависимости между полями
	 */
	public $show_tr_click_checkbox = array(
		'cat' => array(
			'count_list',
			'children_elements',
			'count_child_list',
			'title_tpl_cat',
			'keywords_tpl_cat',
			'descr_tpl_cat',
		),
		'counter' => array(
			'counter_site',
		),
	);

	/**
	 * Подключение js файла
	 * 
	 * @return void
	 */
	public function edit_config_variable_view_id()
	{
		echo '<script type="text/javascript" src="' . BASE_PATH . 'modules/photo/admin/photo.admin.config.js"></script>';
	}
}