<?php
/**
 * Редактирование фотографий
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */

if (!defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Photo_admin
 */
class Photo_admin extends Frame_admin
{
	/**
	 * @var string таблица в базе данных
	 */
	public $table = 'photo';

	/**
	 * @var array поля в базе данных для редактирования
	 */
	public $variables = array (
		'main' => array (
			'name' => array(
				'type' => 'text',
				'name' => 'Название фотографии',
				'help' => 'Используется в ссылках на фотографию, заголовках.',
				'multilang' => true,
			),
			'act' => array(
				'type' => 'checkbox',
				'name' => 'Опубликовать на сайте',
				'help' => 'Если не отмечена, фотография не будет отображаться на сайте.',
				'default' => true,
				'multilang' => true,
			),
			'images' => array(
				'type' => 'module',
				'name' => 'Фотография',
				'help' => 'Фотография будет загружена автоматически после выбора. После загрузки фотография будет обработана автоматически, согласно настройкам модуля.',
				'count' => 1,
			),
			'site_id' => array(
				'type' => 'function',
				'name' => 'Раздел сайта',
				'help' => 'Перенос фотографии на другую страницу сайта, к которой прикреплен модуль. Параметр выводится, если в настройках модуля отключена опция «Использовать категории», если опция подключена, то раздел сайта задается такой же, как у основной категории.',
			),
			'cat_id' => array(
				'type' => 'function',
				'name' => 'Альбом',
				'help' => 'Альбом, к которому относится фотография. Возможно выбрать дополнительные альбомы, в которых фотография также будет выводится. Чтобы выбрать несколько альбомов, удерживайте CTRL. Параметр выводится, если в настройках модуля отмечена опция «Использовать альбомы».',
			),
			'hr1' => 'hr',
			'rel_elements' => array(
				'type' => 'function',
				'name' => 'Похожие фотографии',
				'help' => 'Выбор и добавление к текущей фотографии связей с другими фотографиями. Похожие фотографии выводятся шаблонным тегом show_block_rel. По умолчанию связи между фотографиями являются односторонними, это можно изменить, отметив опцию «В блоке похожих фотографий связь двусторонняя» в настройках модуля.',
			),
			'tags' => array(
				'type' => 'module',
				'name' => 'Теги',
				'help' => 'Добавление тегов к фотографии. Можно добавить либо новый тег, либо открыть и выбрать из уже существующих тегов. Параметр выводится, если в настройках модуля включен параметр «Подключить теги».',
			),
			'hr_count' => 'hr',
			'counter_view' => array(
				'type' => 'function',
				'name' => 'Счетчик просмотров',
				'help' => 'Количество просмотров на сайте текущей фотографии. Статистика ведется и параметр выводится, если в настройках модуля отмечена опция «Подключить счетчик просмотров».',
				'no_save' => true,
			),
			'comments' => array(
				'type' => 'module',
				'name' => 'Комментарии',
				'help' => 'Комментарии, которые оставили пользователи к текущей фотографии. Параметр выводится, если в настройках модуля включен параметр «Показывать комментарии к фотографиям».',
			),
			'rating' => array(
				'type' => 'module',
				'name' => 'Рейтинг',
				'help' => 'Средний рейтинг, согласно голосованию пользователей сайта. Параметр выводится, если в настройках модуля включен параметр «Подключить рейтинг к фотографиям».',
			),
			'anons' => array(
				'type' => 'editor',
				'name' => 'Анонс',
				'help' => 'Краткое описание фотографии. Если отметить «Добавлять к описанию», на странице элемента анонс выведется вместе с основным описанием. Иначе анонс выведется только в списке, а на отдельной странице будет только описание. Если отметить «Применить типограф», контент будет отформатирован согласно правилам экранной типографики с помощью [веб-сервиса «Типограф»](http://www.artlebedev.ru/tools/typograf/webservice/).',
				'multilang' => true,
				'height' => 200,
			),
			'text' => array(
				'type' => 'editor',
				'name' => 'Описание',
				'help' => 'Полное описание для страницы фотографии. Если отметить «Применить типограф», контент будет отформатирован согласно правилам экранной типографики с помощью [веб-сервиса «Типограф»](http://www.artlebedev.ru/tools/typograf/webservice/).',
				'multilang' => true,
			),
			'search' => array(
				'type' => 'module',
				'name' => 'Индексирование для поиска',
				'help' => 'Фотография автоматически индексируется для модуля «Поиск по сайту» при внесении изменений.',
			),
			'map' => array(
				'type' => 'module',
				'name' => 'Индексирование для карты сайта',
				'help' => 'Фотография автоматически индексируется для карты сайта sitemap.xml.',
			),
		),
		'other_rows' => array (
			'number' => array(
				'type' => 'function',
				'name' => 'Номер',
				'help' => 'Номер элемента в БД (веб-мастеру и программисту).',
			),
			'admin_id' => array(
				'type' => 'function',
				'name' => 'Редактор',
				'help' => 'Изменяется после первого сохранения. Показывает, кто из администраторов сайта первый правил текущую страницу.',
			),
			'timeedit' => array(
				'type' => 'text',
				'name' => 'Время последнего изменения',
				'help' => 'Изменяется после сохранения элемента. Отдается в заголовке *Last Modify*.',
			),
			'hr_seo' => 'hr',
			'title_meta' => array(
				'type' => 'text',
				'name' => 'Заголовок окна в браузере, тег Title',
				'help' => 'Если не заполнен, тег *Title* будет автоматически сформирован как «Название фотографии – Название страницы – Название сайта», либо согласно шаблонам автоформирования из настроек модуля (SEO-специалисту).',
				'multilang' => true,
			),
			'keywords' => array(
				'type' => 'textarea',
				'name' => 'Ключевые слова, тег Keywords',
				'help' => 'Если не заполнен, тег *Keywords* будет автоматически сформирован согласно шаблонам автоформирования из настроек модуля (SEO-специалисту).',
				'multilang' => true,
			),
			'descr' => array(
				'type' => 'textarea',
				'name' => 'Описание, тег Description',
				'help' => 'Если не заполнен, тег *Description* будет автоматически сформирован согласно шаблонам автоформирования из настроек модуля (SEO-специалисту).',
				'multilang' => true,
			),
			'rewrite' => array(
				'type' => 'function',
				'name' => 'Псевдоссылка',
				'help' => 'ЧПУ, т.е. адрес страницы вида: *http://site.ru/psewdossylka/*. Смотрите параметры сайта (SEO-специалисту).'
			),
			'redirect' => array(
				'type' => 'none',
				'name' => 'Редирект на текущую страницу со страницы',
				'help' => 'Позволяет делать редирект с указанной страницы на текущую.',
				'no_save' => true,
			),
			'changefreq'   => array(
				'type' => 'function',
				'name' => 'Changefreq',
				'help' => 'Вероятная частота изменения этой страницы. Это значение используется для генерирования файла sitemap.xml. Подробнее читайте в описании [XML-формата файла Sitemap](http://www.sitemaps.org/ru/protocol.html) (SEO-специалисту).',
			),
			'priority'   => array(
				'type' => 'floattext',
				'name' => 'Priority',
				'help' => 'Приоритетность URL относительно других URL на Вашем сайте. Это значение используется для генерирования файла sitemap.xml. Подробнее читайте в описании [XML-формата файла Sitemap](http://www.sitemaps.org/ru/protocol.html) (SEO-специалисту).',
			),
			'hr_map2' => 'hr',
			'map_no_show' => array(
				'type' => 'checkbox',
				'name' => 'Не показывать на карте сайта',
				'help' => 'Скрывает отображение ссылки на фотографию в файле sitemap.xml и [модуле «Карта сайта»](http://cms.diafan.ru/dokument/full-manual/modules/map/).',
			),
			'access' => array(
				'type' => 'function',
				'name' => 'Доступ к текущей фотографии',
				'help' => 'Если отметить опцию «Доступ только», фотографию увидят только авторизованные на сайте пользователи, отмеченных типов. Не авторизованные, в том числе поисковые роботы, увидят «404 Страница не найдена» (администратору сайта).',
			),
			'date_start' => array(
				'type' => 'date',
				'name' => 'Период показа',
				'help' => 'Если заполнить, текущая фотография будет опубликована на сайте в указанный период. В иное время пользователи сайта фотографию не будут видеть, получая ошибку 404 «Страница не найдена» (администратору сайта).'
			),
			'date_finish' => array(
				'type' => 'date',
				'hide' => true,
			),
			'sort' => array(
				'type' => 'function',
				'name' => 'Сортировка: установить перед',
				'help' => 'Изменить положение текущей фотографии среди других фотографий. Поле доступно для редактирования только для фотографий, отображаемых на сайте (администратору сайта).'
			),
			
			'hr5' => 'hr',
			'theme' => array(
				'type' => 'function',
				'name' => 'Шаблон страницы',
				'help' => 'Возможность подключить для страницы фотографии шаблон сайта отличный от основного (themes/site.php). Все шаблоны для сайта должны храниться в папке *themes* с расширением *.php* (например, themes/dizain_so_slajdom.php). Подробнее в [разделе «Шаблоны сайта»](http://cms.diafan.ru/dokument/full-manual/templates/site/). (веб-мастеру и программисту, не меняйте этот параметр, если не уверены в результате!).',
			),
			'view' => array(
				'type' => 'function',
				'name' => 'Шаблон модуля',
				'help' => 'Шаблон вывода контента модуля на странице отдельной фотографии (веб-мастеру и программисту, не меняйте этот параметр, если не уверены в результате!).',
			),	
		),
	);

	/**
	 * @var array настройки модуля
	 */
	public $config = array (
		'act', // показать/скрыть
		'menu', // используется в меню
		'del', // удалить
		'order', // сортируется
		'element_site', // делит элементы по разделам (страницы сайта, к которым прикреплен модуль)
		'element', // используются группы
		'element_multiple', // модуль может быть прикреплен к нескольким группам
		'search_name', // скать по названию
		'trash', // использовать корзину
		'image', // показать фотографию в списке
		'multiupload', // мультизагрузка изображений (подключение JS-библиотек)
		'only_self', // показывать только материалы редактора, если это задано в правах пользователя
	);

	/**
	 * Подготавливает конфигурацию модуля
	 * @return void
	 */
	public function prepare_config()
	{
		if(! $this->diafan->configmodules("cat", "photo", $this->diafan->site))
		{
			$this->diafan->config("element", false);
			$this->diafan->config("element_multiple", false);
		}
		if($this->diafan->edit)
		{
			$this->diafan->config('multiupload', false);
		}
		if(! $this->diafan->configmodules("page_show", "photo", $this->diafan->site))
		{
			$this->diafan->variable_unset("view");
		}
	}

	/**
	 * Выводит ссылку на добавление
	 * @return void
	 */
	public function show_add()
	{
		if (!extension_loaded('gd') && !extension_loaded('gd2'))
		{
			$this->diafan->error = 7;
		}
		if ($this->diafan->config('element') && !$this->diafan->not_empty_categories)
		{
			echo '<div class="error">'.sprintf($this->diafan->_('В %sнастройках%s включено использование альбомов. Чтобы загрузить фотографию, создайте хотя бы один %sальбом%s.'), '<a href="'.BASE_PATH_HREF.'photo/config/">', '</a>', '<a href="'.BASE_PATH_HREF.'photo/category/'.( $this->diafan->site ? 'site'.$this->diafan->site.'/' : '' ).'">', '</a>').'</div>';
		}
		else
		{
			echo '
			<div class="add_new">
				<a href="'.URL.'addnew1/">'.$this->diafan->_('Добавить фотографию').'</a>
				/ <a href="'.URL.'" class="upload_files">'.$this->diafan->_('несколько фотографий').'</a>
			</div>
	
			<div id="upload_area_multi" class="hide">
				<p><input id="fileupload" type="file" name="images[]" data-url="'.URL.'" multiple></p>
			</div>
			<script type="text/javascript" src="'.BASE_PATH.'modules/photo/admin/photo.admin.js"></script>';
		}
	}

	/**
	 * Выводит список фотографий
	 * @return void
	 */
	public function show()
	{
		$this->upload();
		$this->diafan->list_row();
	}

	/**
	 * Добавляет элемент в базу данных
	 *
	 * @return boolean
	 */
	public function upload()
	{
		if (empty($_POST["save_upload"]))
		{
			return;
		}
		if (! isset( $_FILES["images"] ) || ! is_array($_FILES["images"]))
		{
			return;
		}

		header('Content-Type: text/html; charset=utf-8');

		// Проверяет права на добавление
		if (! $this->diafan->_user->roles('edit', 'photo'))
		{
			$this->diafan->redirect(URL);
			return false;
		}
		$names = array ();
		$values = array ();
		if ($this->diafan->config('element'))
		{
			if(! $this->diafan->cat)
			{
				$this->diafan->cat = DB::query_result("SELECT id FROM {photo_category} WHERE [act]='1' AND trash='0'".($this->diafan->site ? " AND site_id=".$this->diafan->site : '')." LIMIT 1");
			}
			$names[] = 'cat_id';
			$values[] = "'".$this->diafan->cat."'";
		}
		$names[] = 'site_id';
		if ($this->diafan->config('element') && $this->diafan->cat)
		{
			$this->diafan->site = DB::query_result("SELECT site_id FROM {photo_category} WHERE id=%d LIMIT 1", $this->diafan->cat);
		}
		elseif (! $this->diafan->site)
		{
			$this->diafan->site = DB::query_result("SELECT id FROM {site} WHERE module_name='photo' LIMIT 1");
		}
		$values[] = "'".$this->diafan->site."'";
		foreach($this->diafan->languages as $lang)
		{
			if($this->diafan->configmodules("multiupload_act", 'photo', $this->diafan->site))
			{
				$names[] = 'act'.$lang["id"];
				$values[] = "'1'";
			}
		}
		$result['hash'] = $this->diafan->_user->get_hash();

		foreach($_FILES["images"]['name'] as $i => $name)
		{
			$new_names = $names;
			$new_values = $values;
			foreach($this->diafan->languages as $lang)
			{
				$new_names[] = 'name'.$lang["id"];
				$new_values[] = "'".str_replace("'", "\\'", $name)."'";
			}
			DB::query("INSERT INTO {photo} (".implode(',', $new_names).") VALUES (".implode(',', $new_values).")");
			$save = DB::query_result("SELECT MAX(id) FROM {photo} WHERE [name]='%s'", $name);
			DB::query("UPDATE {photo} SET sort=id WHERE id=%d", $save);

			if ($this->diafan->config('element') && $this->diafan->cat)
			{
				DB::query("INSERT INTO {photo_category_rel} (element_id, cat_id) VALUES (%d, %d)", $save, $this->diafan->cat);
			}
			$new_name = strtolower($this->diafan->translit($name));
			$extension = substr(strrchr($new_name, '.'), 1);
			$new_name = substr($new_name, 0, -( strlen($extension) + 1 ));
	
			if (strlen($new_name) + strlen($extension) > 49)
			{
				$new_name = substr($new_name, 0, 49 - strlen($extension));
			}
	
			try
			{
				$this->diafan->_images->upload($save, 'photo', $this->diafan->site, $_FILES["images"]['tmp_name'][$i], $new_name);
			}
			catch(Exception $e)
			{
				Dev::$exception_field = 'images';
				Dev::$exception_result = $result;
				throw new Exception($e->getMessage());
			}
		}

		$result["file"] = $name;
		$result["success"] = true;
		$result["redirect"] = URL;

		include_once ABSOLUTE_PATH.'plugins/json.php';
		echo to_json($result);
		exit;
	}

	/**
	 * Сопутствующие действия при удалении элемента модуля
	 * @return void
	 */
	public function delete($del_id, $trash_id)
	{
		$this->diafan->del_or_trash_where("photo_rel", "element_id=".$del_id." OR rel_element_id=".$del_id, $trash_id);
		$this->diafan->del_or_trash_where("photo_counter", "element_id=".$del_id, $trash_id);
	}
}