<?php
/**
 * Подключение модуля
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Rating_inc
 */
class Rating_inc extends Model
{
	/**
	 * Показывает рейтинг для элемента
	 *
	 * @param integer $element_id номер элемента модуля
	 * @param string $module_name название модуля
	 * @param integer $site_id страница сайта, к которой прикреплен элемент
	 * @param boolean $is_category это категория
	 * @return string
	 */
	function get($element_id = 0, $module_name = '', $site_id = 0, $is_category = false)
	{
		$module_name = ! $module_name ? $this->diafan->module : $module_name;
		$site_id = ! $site_id ? $this->diafan->cid : $site_id;
		$element_id = ! $element_id ? ($is_category ? $this->diafan->cat : $this->diafan->show) : $element_id;

		if(! $this->diafan->configmodules("rating".($is_category ? "_cat" : ""), $module_name, $site_id))
		{
			return false;
		}
		$this->prepare($element_id, $module_name, $is_category);
		if(! empty($this->cache["prepare"]))
		{
			$where = array();
			$values = array();
			foreach($this->cache["prepare"] as $pr_module_name => $array)
			{
				$values[] = $pr_module_name;
				foreach($array as $pr_element_id => $a)
				{
					$this->cache["rating"][$pr_module_name][$pr_element_id] = 0;
					$values[] = $pr_element_id;
					$v_array[] = '%d';
				}
				$where[] = "module_name='%h' AND element_id".(count($array) > 1 ? " IN (".implode(",", $v_array).")" : "=%d");
			}
			$result = DB::query("SELECT rating, module_name, element_id FROM {rating} WHERE (".implode(" OR ", $where).") AND trash='0'", $values);
			while ($row = DB::fetch_array($result))
			{
				$this->cache["rating"][$row["module_name"]]['e'.$row["element_id"]] = round($row["rating"]);
			}
			DB::free_result($result);
			if (session_id() && $this->diafan->configmodules('security', 'rating', $site_id) == 3)
			{
				$values[] = $this->diafan->configmodules('security_user', 'rating', $site_id) ? $this->diafan->_user->id : session_id();
				$result = DB::query("SELECT id, module_name, element_id FROM {log_note}"
					." WHERE (".implode(" OR ", $where).") AND include_name='rating' AND session_id='%s' LIMIT 1",
					$values);
				while ($row = DB::fetch_array($result))
				{
					$this->cache["rating_log"][$row["module_name"]]['e'.$row["element_id"]] = true;
				}
				DB::free_result($result);
			}
			unset($this->cache["prepare"]);
		}

		$this->result["module_name"] = $module_name.($is_category ? "_category" : "");
		$this->result["element_id"]  = $element_id;
		
		$this->result["rating"] = $this->cache["rating"][$this->result["module_name"]]['e'.$element_id];

		$this->result["disabled"] = false;

		if ($this->diafan->configmodules('only_user', 'rating', $site_id) && ! $this->diafan->_user->id)
		{
			$this->result["disabled"] = true;
		}

		if (session_id() && $this->diafan->configmodules('security', 'rating', $site_id) == 3
		   && ! empty($this->cache["rating_log"][$this->result["module_name"]]['e'.$element_id]))
		{
			$this->result["disabled"] = true;
		}

		if (session_id() && $this->diafan->configmodules('security', 'rating', $site_id) == 4
		   && ! empty($_SESSION["rating"][$this->result["element_id"].$this->result["module_name"]]))
		{
			$this->result["disabled"] = true;
		}

		return $this->diafan->_tpl->get('get', 'rating', $this->result);
	}

	/**
	 * Запоминает данные элемента, которому нужно будет вывести рейтинг
	 *
	 * @param integer $element_id номер элемента модуля
	 * @param strint $module_name название модуля
	 * @return void
	 */
	public function prepare($element_id = 0, $module_name = '', $is_category = false)
	{
		$module_name = (! $module_name ? $this->diafan->module : $module_name).($is_category ? '_category' : '');
		$element_id = ! $element_id ? ($this->diafan->show ? $this->diafan->show : $this->diafan->cat) : $element_id;

		if(isset($this->cache["rating"][$module_name]['e'.$element_id]))
		{
			return;
		}
		if(! isset($this->cache["prepare"][$module_name]['e'.$element_id]))
		{
			$this->cache["prepare"][$module_name]['e'.$element_id] = $element_id;
		}
	}
}