<?php
/**
 * Контроллер
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Referals
 */
class Referals extends Controller
{
	/**
	 * Шаблонная функция: выводит код реферальной ссылки
	 * 
	 * @param array $attributes атрибуты шаблонного тега
	 * show_referal_id - выводить код реферальной ссылки ("true"|"false")
	 * template - шаблон тега (файл modules/referals/views/referals.view.show_block_**template**.php; по умолчанию шаблон modules/referals/views/referals.view.show_block.php)
	 * 
	 * @return void
	 */
	public function show_block($attributes)
	{
		$attributes = $this->get_attributes($attributes, 'show_referal_id', 'template');

		$show_referal_id  = (bool)$attributes["show_referal_id"];

		$result = $this->model->show_block($show_referal_id);
		if (! $attributes["template"] || ! $this->diafan->_tpl->get('show_block_'.$attributes["template"], 'referals', $result))
		{
			$this->diafan->_tpl->get('show_block', 'referals', $result);
		}
	}
}