<?php
/**
 * Контроллер модуля «Регистрация»
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Registration
 */
class Registration extends Controller
{
	/**
	 * Инициализация модуля
	 * 
	 * @return void
	 */
	public function init()
	{
		if(! empty($_GET["action"]))
		{
			switch($_GET["action"])
			{
				case "act":
					$this->result = $this->model->act();
					break;

				case "success":
					$this->result = $this->model->success();
					break;

				default:
					include ABSOLUTE_PATH.'includes/404.php';
			}
		}
		else
		{
			if($this->diafan->_user->id)
			{
				$this->diafan->redirect();
			}
			$this->result = $this->model->form();
		}
	}

	/**
	 * Выводит контент модуля
	 * 
	 * @return void
	 */
	public function show_module()
	{
		if(! empty($_GET["action"]))
		{
			switch($_GET["action"])
			{
				case "act":
					$this->diafan->_tpl->get('act', 'registration', $this->result);
					break;
				case "success":
					$this->diafan->_tpl->get('success', 'registration', $this->result);
					break;
			}
		}
		else
		{
			$this->diafan->_tpl->get('form', 'registration', $this->result);
		}
	}

	/**
	 * Шаблонная функция: выводит форму авторизации или приветствие и ссылки на редактирование данных и выход, если пользователь авторизован.
	 * 
	 * @param array $attributes атрибуты шаблонного тега
	 * template - шаблон тега (файл modules/registration/views/registration.view.show_login_**template**.php; по умолчанию шаблон modules/registration/views/registration.view.show_login.php)
	 * 
	 * @return void
	 */
	public function show_login($attributes)
	{
		$attributes = $this->get_attributes($attributes, 'template');
		$result = $this->model->show_login();

		if($attributes["template"])
		{
			$text = $this->diafan->_tpl->get('show_login_'.$attributes["template"], 'registration', $result);
			if($text)
			{
				echo $text;
			}
			else
			{
				echo $this->diafan->_tpl->get('show_login', 'registration', $result);
			}
		}
		else
		{
			echo $this->diafan->_tpl->get('show_login', 'registration', $result);
		}
	}  	
}