<?php
/**
 * Модель
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Search_model
 */
class Search_model extends Model
{
	/**
	 * Генерирует список найденных страниц
	 * 
	 * @return array
	 */
	public function show_module()
	{
		$search = '';
		if (isset($_GET["searchword"]))
		{
			if (is_array($_GET["searchword"]))
			{
				$_GET["searchword"] = '';
			}
			$search = trim(htmlspecialchars(stripslashes($_GET["searchword"])));
			if(empty($_SESSION["search"]) || ! in_array($_GET["searchword"], $_SESSION["search"]))
			{
				$_SESSION["search"][] = $_GET["searchword"];
				if($count = $this->diafan->configmodules("count_history"))
				{
					DB::query("INSERT INTO {search_history} (created, name) VALUES (%d, '%h')", time(), $_GET["searchword"]);
					if(DB::query_result("SELECT COUNT(*) FROM {search_history}") > $count)
					{
						DB::query("DELETE FROM {search_history} ORDER BY created  ASC LIMIT 1");
					}
				}
			}
		}
		$this->result = array();

		if (! empty($search))
		{
			Customization::inc('includes/searchwords.php');
			$searchwords = new Searchwords();
			$search_words = $searchwords->prepare($search);

			$keys = array();
			$result = DB::query("SELECT id, keyword FROM {search_keywords} WHERE keyword IN ('".implode("', '", $search_words)."')");
			while ($row = DB::fetch_array($result))
			{
				$keys[$row["keyword"]] = $row["id"];
			}
			DB::free_result($result);

			$temp_table = false;
			if($this->diafan->configmodules("search_all_word", "search"))
			{
				$order = '';
				// обязательны все слова
				$where = "";
				foreach($search_words as $k => $key)
				{
					$where .= " INNER JOIN {search_index} AS i".$k." ON r.id=i".$k.".result_id AND i".$k.".keyword_id=".$keys[$key];
					$order .= 'i'.$k.'.rating ASC, ';
				}
				$order .= "r.rating DESC";
			}
			else
			{
				// ищет хотя бы одно слово, сортировка по количеству найденных
				$where = "INNER JOIN {search_index} AS i ON r.id=i.result_id AND i.keyword_id IN ('".implode("', '", $keys)."')";
				if(count($search_words) > 1)
				{
					$temp_table = true;
					DB::query("CREATE TEMPORARY TABLE {search_temp} (
						keyword_id int(11) unsigned NOT NULL,
						rating tinyint(2) unsigned NOT NULL
					);");
					$where .= " INNER JOIN {search_temp} AS t ON t.keyword_id=i.keyword_id";
					$query = '';
					foreach($search_words as $i => $word)
					{
						$query .= ($query ? "," : '')." (".$keys[$word].", ".(count($search_words) - $i).")";
					}
					DB::query("INSERT INTO {search_temp} (keyword_id, rating) VALUES".$query);
				}
				$order = ($temp_table ? "tmp_rating" : "r.rating")." DESC";
			}

			$nen = DB::query_result("SELECT COUNT(DISTINCT r.id) FROM {search_results} AS r "
			.($this->diafan->_user->role_id ? " LEFT JOIN {access} AS a ON a.element_id=r.id AND a.module_name='search'" : "")
			.$where." WHERE r.lang_id=%d"
			." AND (r.access='0'"
			.($this->diafan->_user->role_id ? " OR r.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
			.")", _LANG);

			////navigation//
			if ($nastr = $this->diafan->configmodules("nastr", "search"))
			{
				$this->diafan->_paginator->nastr = $nastr;
			}
			$this->diafan->_paginator->page    = $this->diafan->page;
			$this->diafan->_paginator->navlink = $this->diafan->_route->current_link("page");
			$this->diafan->_paginator->get_nav = '?searchword='.$search;
			$this->diafan->_paginator->nen     = $nen;
			$links = $this->diafan->_paginator->get();
			////navigation///

			$k = ! $this->diafan->page ? 1 : ($this->diafan->page - 1) * $this->diafan->_paginator->nastr + 1;

			$this->result["paginator"] = $this->diafan->_tpl->get('get', 'paginator', $links);

			$count = 0;
			$result = DB::query_range("
				SELECT r.name, r.url, r.snippet".($temp_table ? ", SUM(t.rating) AS tmp_rating" : "")." FROM {search_results} as r "
				.($this->diafan->_user->role_id ? " LEFT JOIN {access} AS a ON a.element_id=r.id AND a.module_name='search'" : "")
				.$where
				." WHERE r.lang_id=%d"
				." AND (r.access='0'"
				.($this->diafan->_user->role_id ? " OR r.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
				.")"
				." GROUP BY r.id ORDER BY ".$order,
				_LANG, $this->diafan->_paginator->polog, $this->diafan->_paginator->nastr);
			while ($row = DB::fetch_array($result))
			{
				$row["link"] = str_replace('ROUTE_END', ROUTE_END, $row["url"]);
				$this->result["rows"][] = $row;
				$count++;
			}
			DB::free_result($result);

			$this->result["count"] = $this->diafan->_paginator->nen;
			$this->result["count_start"] = $this->result["count"] ? ($this->diafan->_paginator->page - 1) * $this->diafan->_paginator->nastr + 1 : 0;
			$this->result["count_finish"] = $this->result["count"] ? $this->result["count_start"] - 1 + $count : 0;
			$this->result["count_page"] =
				$this->diafan->_paginator->nen > $this->diafan->_paginator->nastr ? 
				$this->diafan->_paginator->nastr : $this->diafan->_paginator->nen;
		}
		$this->result["value"] = $search;
		$this->result["action"] = BASE_PATH_HREF.$this->diafan->_route->link($this->diafan->cid);
		$this->result["button"] = 'Найти';

		return $this->result;
	}

	/**
	 * Генерирует контент для шаблонной функции: форма поиска по сайту
	 * 
	 * @return array
	 */
	public function show_search($button)
	{
		$result["value"] = '';
		if (isset($_GET["searchword"]))
		{
			if (is_array($_GET["searchword"]))
			{
				$_GET["searchword"] = '';
			}
			$result["value"] = trim(htmlspecialchars(stripslashes($_GET["searchword"])));
		}
		$result["action"] = BASE_PATH_HREF.$this->diafan->_route->module('search', true);
		$result["button"] = $button;
		return $result;
	}
}