<?php
/**
 * Контроллер
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Search
 */
class Search extends Controller
{
	/**
	 * Инициализация модуля
	 * 
	 * @return void
	 */
	public function init()
	{
	   $this->rewrite_variable_names = array('page');
	   $this->result = $this->model->show_module();
	}

	/**
	 * Выводит контент модуля
	 * 
	 * @return void
	 */
	public function show_module()
	{
		$this->diafan->_tpl->get('show', 'search', $this->result);
	}

	/**
	 * Шаблонная функция: выводит форму поиска по сайту.
	 * 
	 * @param array $attributes атрибуты шаблонного тега
	 * button - значение кнопки «Найти». Для неосновной языковой версии значение можно перевести в административной части в меню «Языки сайта» – «Перевод интерфейса»
	 * template - шаблон тега (файл modules/search/views/search.view.show_search_**template**.php; по умолчанию шаблон modules/search/views/search.view.show_search.php)
	 * 
	 * @return void
	 */
	public function show_search($attributes)
	{
		$attributes = $this->get_attributes($attributes, 'button', 'template');
		
		$button = $this->diafan->_($attributes["button"], false);
		$result = $this->model->show_search($button);

		if (! $attributes["template"] || ! $this->diafan->_tpl->get('show_search_'.$attributes["template"], 'search', $result))
		{
			$this->diafan->_tpl->get('show_search', 'search', $result);
		}
	}
}