<?php
/**
 * Импорт/экспорт данных
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */
if ( ! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Shop_admin_importexport_element
 */
class Shop_admin_importexport_element extends Frame_admin
{
	/**
	 * @var string таблица в базе данных
	 */
	public $table = 'shop_import';

	/**
	 * @var array поля в базе данных для редактирования
	 */
	public $variables = array (
		'main' => array (
			'name' => array(
				'type' => 'text',
				'name' => 'Название',
				'help' => 'Название поля для импорта, необходимо только для наглядности в списке полей.',
			),
			'type' => array(
				'type' => 'select',
				'name' => 'Тип',
				'help' => 'Значение или свойство товара, куда будет импортироваться данное поле.',
			),
			'paramhelp' => array(
				'type' => 'function',
				'no_save' => true,
				'hide' => true,
			),
			'required' => array(
				'type' => 'checkbox',
				'name' => 'Выдавать ошибку, если значение не задано',
				'help' => 'При импорте файла выйдет ошибка, если значение поля будет не задано.',
			),
			'params' => array(
				'type' => 'function',
				'name' => 'Дополнительные настройки',
				'hide' => true,
			),
			'params_id' => array(
				'type' => 'none',
				'name' => 'Использовать в качестве идентификаторов',
				'help' => "Поле выводиться только для типов «Идентификатор», «Категория», «Родитель» и «Идентификатор связанных товаров».\n\n* собственное значение – при первом импорте все товары/категории добавляться в базу, идентификатор запишется в поле import_id. При последующем импорте товары/категории будут обновляться по идентификатору import_id;\n* идентификатор на сайте – использовать стандартный идентификатор id;\n* артикул – только для товаров, только для типов «Идентификатор» и «Идентификатор связанных товаров»;\n* название – только для категорий, только для типов «Категория» и «Родитель».",
				'no_save' => true,
			),
			'params_start_stop' => array(
				'type' => 'none',
				'name' => 'Диапазон значений',
				'help' => 'Для полей с типами «Дата и время начала показа» и «Дата и время окончания показа». Помогает исключить ошибки в файле импорта.',
				'no_save' => true,
			),
			'params_param' => array(
				'type' => 'none',
				'name' => 'Дополнительная характеристика',
				'help' => 'Список характеристик для поля с типом «Дополнительная характеристика».',
				'no_save' => true,
			),
			'params_select' => array(
				'type' => 'none',
				'name' => 'Значения списка',
				'help' => "Для дополнительных харктеристик с типами «список с выбором нескольких значений» и «выпадающий список». Возможные значения:\n\n* номер – номер значения списка из таблицы {shop_param_select};\n* название – значение списка, которое видит пользователь.",
				'no_save' => true,
			),
			'params_images' => array(
				'type' => 'none',
				'name' => 'Папка с изображениями для загрузки (относительно корня сайта)',
				'help' => 'Только для типа «Имена изображений».',
				'no_save' => true,
			),
			'params_separator' => array(
				'type' => 'none',
				'name' => 'Разделитель параметров, влияющих на цену, колечества и валюты в пределах одного значения цены/количества',
				'help' => 'Только для типов «Цена» и «Количество».',
				'no_save' => true,
			),
			'params_multiselect' => array(
				'type' => 'none',
				'name' => 'Значения параметров, влияющих на цену',
				'help' => "Только для типов «Цена» и «Количество». Возможные значения:\n\n* номер – номер значения списка из таблицы {shop_param_select};\n* название – значение списка, которое видит пользователь.",
				'no_save' => true,
			),
			'params_count' => array(
				'type' => 'none',
				'name' => 'Указывать количество',
				'help' => "Значение следует сразу за ценой через «Разделитель параметров, влияющих на цену, колечества и валюты в пределах одного значения цены/количества», только для типа «Цена».",
				'no_save' => true,
			),
			'params_currency' => array(
				'type' => 'none',
				'name' => 'Указывать валюту',
				'help' => 'Значение следует сразу за количеством или ценой (если не отмечена опция «Указывать количество») через «Разделитель параметров, влияющих на цену, колечества и валюты в пределах одного значения цены/количества»,только для типа «Цена».',
				'no_save' => true,
			),
			'params_currency_value' => array(
				'type' => 'none',
				'name' => 'Значение валюты',
				'help' => "Только для типа «Цена». Возможные значения:\n\n* номер – номер валюты из таблицы {shop_currency};\n* название – название валюты.",
				'no_save' => true,
			),
			'hr2' => 'hr',
			'cat_id' => array(
				'type' => 'select',
				'name' => 'Категория',
				'help' => 'Файл импорта.',
			),
			'hr3' => 'hr',
			'sort' => array(
				'type' => 'function',
				'name' => 'Сортировка: установить после',
				'help' => 'Изменить положение текущего поля среди других полей. В списке можно сортировать поля простым перетаскиванием мыши.',
			),
			'js' => array(
				'type' => 'function',
				'no_save' => true,
				'hide' => true,
			),
		),
		'other_rows' => array (
		),
	);

	/**
	 * @var array настройки модуля
	 */
	public $config = array (
		'del', // удалить
		'element', // используются группы
		'trash', // использовать корзину
		'order', // сортируется
		'order_asc', // сортируется от старого к новому
		'category_flat', // категори не содержат вложенности
		'category_no_multilang', // имя категории не переводиться
	);

	/**
	 * @var array значения списков
	 */
	public $select_arr = array(
		'type' => array(
			'id' => 'Идентификатор (уникальный код)',
			'name' => 'Название', // поле «Название»
			'article' => 'Артикул', // используется у товаров
			'anons' => 'Анонс', // поле «Анонс»
			'text' => 'Текст', // поле «Описание»
			'keywords' => 'Ключевые слова, тег Keywords',
			'descr' => 'Описание, тег Description',
			'title_meta' => 'Заголовок окна в браузере, тег Title',
			'price' => 'Цена', //поле «Цена», используется у товаров
			'count' => 'Количество', // поле «Количество», используется у товаров
			'cats' => 'Категория', // идентификатор категории из файла импорта категорий, используется у товаров. Чтобы категория для товара определилась правильно, нужно сначала импортировать категории
			'empty' => 'Пропуск', // неиспользуемая информация
			'parent' => 'Родитель', // идентификатор родителя (должен соответствовать данным из поля первого типа), используется у категорий
			'param' => 'Дополнительная характеристика', // характеристика товара из конструктора характеристик, используется у товаров
			'images' => 'Имена изображений', // имена изображений через «Разделитель данных внутри поля»
			'rel_goods' => 'Идентификаторы связанных товаров', // идентификаторы через «Разделитель данных внутри поля», только для товаров
			'no_buy' => 'Товар временно отсутствует', // значения 1|0|true|false, только для товаров
			'act' => 'Опубликовать на сайте', // значения 1|0|true|false
			'rewrite' => 'Псевдоссылка', // ЧПУ товара/категории
			'menu' => 'Отображать в меню', // значения 1|0|true|false
			'hit' => 'Поле «Хит»', // значения 1|0|true|false, только для товаров
			'new' => 'Поле «Новинка»', // значения 1|0|true|false, только для товаров
			'action' => 'Поле «Акция»', // значения 1|0|true|false, только для товаров
			'is_file' => 'Товар является файлом', // значения 1|0|true|false, только для товаров
			'show_yandex' => 'Выгружать в Яндекс Маркет', // значения 1|0|true|false
			'yandex' => 'Значения полей для Яндекс Маркета', // только для товаров
			'access' => 'Доступ', // если доступ ограничен, то идентификаоры типов пользователей, которым дан доступ, через «Разделитель данных внутри поля»
			'map_no_show' => 'Не показывать элемент на карте сайта', // значения 1|0|true|false
			'sort' => 'Номер для сортировки', // товары и категории сортируются по возрастанию
			'admin_id' => 'Редактор', // id пользователя на сайте
			'theme' => 'Шаблон сайта', // файл из папки themes
			'view' => 'Шаблон модуля (modules/shop/views/shop.view.шаблон.php)', // (modules/shop/views/shop.view.шаблон.php)
			'date_start' => 'Дата и время начала показа', // в формате дд.мм.гггг чч:мм
			'date_finish' => 'Дата и время окончания показа', // в формате дд.мм.гггг чч:мм
		),
		'type_cat' => array(
			'id' => 'category,good',
			'name' => 'category,good',
			'article' => 'good',
			'anons' => 'category,good',
			'text' => 'category,good',
			'keywords' => 'category,good',
			'descr' => 'category,good',
			'title_meta' => 'category,good',
			'price' => 'good',
			'count' => 'good',
			'cats' => 'good',
			'empty' => 'category,good',
			'parent' => 'category',
			'param' => 'good',
			'images' => 'category,good',
			'rel_goods' => 'good',
			'no_buy' => 'good',
			'act' => 'category,good',
			'rewrite' => 'category,good',
			'menu' => 'category',
			'hit' => 'good',
			'new' => 'good',
			'action' => 'good',
			'is_file' => 'good',
			'show_yandex' => 'category,good',
			'yandex' => 'good',
			'access' => 'category,good',
			'map_no_show' => 'category,good',
			'sort' => 'category,good',
			'admin_id' => 'category,good',
			'theme' => 'category,good',
			'view' => 'category,good',
			'date_start' => 'good',
			'date_finish' => 'good',
		),
	);

	/**
	 * Подготавливает конфигурацию модуля
	 * @return void
	 */
	public function show_import()
	{
		if ( ! empty($_POST["upload"]) || ! empty($_GET["upload"]))
		{
			Customization::inc('modules/shop/admin/shop.admin.import.php');
			$shop_admin_import = new Shop_admin_import($this->diafan);
			$shop_admin_import->upload();
		}
		elseif ( ! empty($_POST['action']))//опереации с импортированными элементами
		{
			Customization::inc('modules/shop/admin/shop.admin.import.php');
			$shop_admin_import = new Shop_admin_import($this->diafan);
			switch ($_POST['action'])
			{
				case 'act_import':
					$shop_admin_import->act(true);
					exit;
					break;

				case 'deact_import':
					$shop_admin_import->act(false);
					exit;
					break;

				case 'remove_import':
					$shop_admin_import->remove();
					exit;
					break;
			}
		}
	}

	/**
	 * Выводит ссылку на добавление
	 * @return void
	 */
	public function show_add()
	{
		$this->diafan->addnew_init('Добавить поле');
	}

	/**
	 * Выводит список сообщений
	 * @return void
	 */
	public function show()
	{
		$this->show_import();
		$this->diafan->list_row($this->diafan->cat);
		
		if (DB::query_result("SELECT id FROM {shop_import} WHERE cat_id=%d AND trash='0' LIMIT 1", $this->diafan->cat))
		{
			echo '
			<br><br><div class="block">
			<table cellpadding="5" width="100%">
			<tr><td colspan="2">И импорт и экспорт будут проводиться согласно полям, указанным выше. Вы можете самостоятельно создать необходимую структуру импорта/экспорта. Например, у Вас файл-таблица с товарами, где три колонки: «товар», «цена», «описание». Тогда вверху в списке импортируемых полей должно быть только три поля «Название товара», «Цена», «Полное описание» и именно в таком порядке.<hr></td></tr><tr><td valign="top" width="70%"><h2>Импорт</h2>

			'.$this->diafan->_('Тип файла для импорта - CSV').'
				
				<form action="" enctype="multipart/form-data" method="post">
				<input type="hidden" name="upload" value="true">
				<input type="file" name="file">
				<input type="submit" value="'.$this->diafan->_('Импортировать').'" class="button">
				<br><br>'.$this->diafan->_('Внимание! Не забудьте перед импортом создать резервную копию базы данных!').'
				</form>';

			$import = DB::query_fetch_array("SELECT * FROM {shop_import_category} WHERE id=%d LIMIT 1", $this->diafan->cat);
			$where = '';
			if($import["type"] != 'category' && $import["cat_id"])
			{
				$where .= " AND cat_id=".$import["cat_id"];
			}

			$act_import = DB::query_result("SELECT id FROM {shop".($import["type"] == 'category' ? '_category' : '')."} WHERE import='1' AND [act]='0' AND site_id=%d ".$where." LIMIT 1", $import["site_id"]);
			$deact_import = DB::query_result("SELECT id FROM {shop".($import["type"] == 'category' ? '_category' : '')."} WHERE import='1' AND [act]='1' AND site_id=%d ".$where." LIMIT 1", $import["site_id"]);
	
			if($act_import || $deact_import)
			{
				echo '
				<script type="text/javascript" src="'.BASE_PATH.'modules/shop/admin/shop.admin.importexport.element.js"></script>
				<br>
				<form method="post" action="'.URL.'">
				<input type="hidden" value="" name="action">
				Результаты последнего импорта: &nbsp; &nbsp;';
				if($act_import)
				{
					echo '<input type="submit" class="button shop_import_button" rel="act_import" value="'.$this->diafan->_('Показать на сайте').'" > &nbsp; &nbsp;';
				}
				if($deact_import)
				{
					echo '<input type="submit" class="button shop_import_button" rel="deact_import" value="'.$this->diafan->_('Скрыть на сайте').'" > &nbsp; &nbsp;';
				}
				echo '<input type="submit" class="button shop_import_button" rel="remove_import" value="'
			   .$this->diafan->_('Удалить').'" >
				</form>';
			}
			
			echo '
			</td><td width="30%" valign="top"><h2>Экспорт</h2><b><a href="'.str_replace('/'.ADMIN_FOLDER, '', BASE_PATH_HREF).'shop/export/'.$this->diafan->cat.'/">'.$this->diafan->_('Скачать файл экспорта').'</a></b> (*.csv)<br><br>
			'.$this->diafan->_('Если у Вас есть на сайте товары, Вы можете скачать этот файл как пример для импорта.');
			
			echo '</td></tr></table></div>';
		} 

	}

	/**
	 * Редактирование поля "JS"
	 * @return void
	 */
	public function edit_variable_js()
	{
		echo '<script type="text/javascript" src="'.BASE_PATH.'modules/shop/admin/shop.admin.importexport.element.js"></script>';
	}

	/**
	 * Редактирование поля "Тип"
	 * @return void
	 */
	public function edit_variable_type()
	{
		echo '
		<tr id="type">
			<td class="td_first">'.$this->diafan->variable_name().'</td>
			<td>
				<select name="type">';
				foreach ($this->diafan->select_arr('type') as $key => $value)
				{
					echo '<option value="'.$key.'"'.($this->diafan->value == $key ? ' selected' : '');
					$type = $this->diafan->select_arr('type_cat', $key);
					if(strpos($type, 'good') !== false)
					{
						echo ' good="true"';
					}
					if(strpos($type, 'category') !== false)
					{
						echo ' category="true"';
					}
					echo '>'.$value.'</option>';
				}
				echo '</select>
				'.$this->diafan->help().'
			</td>
		</tr>';
	}

	/**
	 * Редактирование поля "Ссылка на документацию"
	 * @return void
	 */
	public function edit_variable_paramhelp()
	{
		echo '<tr id="name">
			<td class="td_first">&nbsp;</td>
			<td>
				↑ <a href="http://cms.diafan.ru/dokument/full-manual/modules/shop/#importexport" target="_blank">О типах полей для импорта</a>
			</td>
		</tr>';
	}

	/**
	 * Редактирование поля "Параметры"
	 * @return void
	 */
	public function edit_variable_params()
	{
		$type = '';
		if(! $this->diafan->addnew)
		{
			$params = unserialize($this->diafan->value);
			$type = $this->diafan->values["type"];
		}
		
		// меню
		echo '
		<tr id="param_menu_id" class="params param_menu">
			<td class="td_first">'.$this->diafan->_('Категория меню').'</td>
			<td>';
		$result = DB::query("SELECT id, [name] FROM {menu_category} WHERE trash='0' ORDER BY id DESC");
		if (DB::num_rows($result) > 0)
		{
			echo '<select name="param_menu_id">';
			echo '<option value="0">-</option>';
			while ($row = DB::fetch_array($result))
			{
				echo '<option value="'.$row["id"].'"'
				.($type == 'menu' && ! empty($params["id"]) && $params["id"] == $row["id"] ? ' selected="selected" ' : '' )
				.'>'.$row["name"].'</option>';
			}
			DB::free_result($result);
			echo '</select>';
		}
		echo '
			</td>
		</tr>';

		// дополнительная характеристика
		$param_select_type = $type == 'param' && ! empty($params["select_type"]) ? $params["select_type"] : '';
		echo '
		<tr id="param_id" class="params param_param">
			<td class="td_first">'.$this->diafan->_('Характеристика').'</td>
			<td>';
		$result = DB::query("SELECT id, [name], type FROM {shop_param} WHERE trash='0' ORDER BY sort DESC, id DESC");
		if (DB::num_rows($result) > 0)
		{
			echo '<select name="param_id">';
			echo '<option value="0">-</option>';
			while ($row = DB::fetch_array($result))
			{
				echo '<option value="'.$row["id"].'"'
				.($type == 'param' && ! empty($params["id"]) && $params["id"] == $row["id"] ? ' selected="selected" ' : '' )
				.' type="'.$row["type"].'">'.$row["name"].'</option>';
			}
			DB::free_result($result);
			echo '</select>';
		}
		echo '
			</td>
		</tr>
		<tr id="param_select_type" class="params param_param">
			<td class="td_first">'.$this->diafan->_('Значения списка').'</td>
			<td><select name="param_select_type">
			<option value="key"'.($param_select_type == 'key' ? ' selected' : '').'>'.$this->diafan->_('номер').'</option>
			<option value="value"'.($param_select_type == 'value' ? ' selected' : '').'>'.$this->diafan->_('название').'</option>
			</select>
			</td>
		</tr>';

		// цена, количество
		$param_delimitor = ($type == 'price' || $type == 'count') && ! empty($params["delimitor"]) ? $params["delimitor"] : '&';
		$param_select_type = ($type == 'price' || $type == 'count') && ! empty($params["select_type"]) ? $params["select_type"] : '';
		$param_count = $type == 'price' && ! empty($params["count"]) ? $params["count"] : '';
		$param_currency = $type == 'price' && ! empty($params["currency"]) ? $params["currency"] : '';
		$param_select_currency = $type == 'price' && ! empty($params["select_currency"]) ? $params["select_currency"] : '';
		echo '
		<tr id="param_delimitor" class="params param_price param_count">
			<td class="td_first">'.$this->diafan->_('Разделитель параметров, влияющих на цену, количества и валюты в пределах одного значения цены/количества').'</td>
			<td>
				<input name="param_delimitor" type="text" value="'.$param_delimitor.'" size="20">
			</td>
		</tr>
		<tr id="param_price_select_type" class="params param_price param_count">
			<td class="td_first">'.$this->diafan->_('Значения параметров, влияющих на цену').'</td>
			<td><select name="param_price_select_type">
			<option value="key"'.($param_select_type == 'key' ? ' selected' : '').'>'.$this->diafan->_('номер').'</option>
			<option value="value"'.($param_select_type == 'value' ? ' selected' : '').'>'.$this->diafan->_('название').'</option>
			</select>
			</td>
		</tr>
		<tr id="param_count" class="params param_price">
			<td class="td_first">'.$this->diafan->_('Указывать количество').'</td>
			<td><input name="param_count" value="1" type="checkbox"'.($param_count ? ' checked' : '').'>
			</td>
		</tr>
		<tr id="param_currency" class="params param_price">
			<td class="td_first">'.$this->diafan->_('Указывать валюту').'</td>
			<td><input name="param_currency" value="1" type="checkbox"'.($param_currency ? ' checked' : '').'>
			</td>
		</tr>
		<tr id="param_select_currency" class="params param_price">
			<td class="td_first">'.$this->diafan->_('Значение валюты').'</td>
			<td><select name="param_select_currency">
			<option value="key"'.($param_select_currency == 'key' ? ' selected' : '').'>'.$this->diafan->_('номер').'</option>
			<option value="value"'.($param_select_currency == 'value' ? ' selected' : '').'>'.$this->diafan->_('название').'</option>
			</select>
			</td>
		</tr>';

		// id,  rel_goods
		$param_type = (in_array($type, array('id', 'rel_goods')) && ! empty($params["type"]) ? $params["type"] : '');
		echo '
		<tr id="param_type" class="params param_id param_rel_goods">
			<td class="td_first">'.$this->diafan->_('Использовать в качестве идентификаторов').'</td>
			<td>
				<select name="param_type">
				<option value=""'.(! $param_type ? ' selected' : '').'>'.$this->diafan->_('собственное значение').'</option>
				<option value="site"'.($param_type == 'site' ? ' selected' : '').'>'.$this->diafan->_('идентификатор на сайте').'</option>
				<option value="article"'.($param_type == 'article' ? ' selected' : '').'>'.$this->diafan->_('артикул').'</option>
				</select>
			</td>
		</tr>';

		// parent, cats
		$param_type = (in_array($type, array('cats', 'parent')) && ! empty($params["type"]) ? $params["type"] : '');
		echo '
		<tr id="param_cats_type" class="params param_cats param_parent">
			<td class="td_first">'.$this->diafan->_('Использовать в качестве идентификаторов').'</td>
			<td>
				<select name="param_cats_type">
				<option value=""'.(! $param_type ? ' selected' : '').'>'.$this->diafan->_('собственное значение').'</option>
				<option value="site"'.($param_type == 'site' ? ' selected' : '').'>'.$this->diafan->_('идентификатор на сайте').'</option>
				<option value="name"'.($param_type == 'name' ? ' selected' : '').'>'.$this->diafan->_('название').'</option>
				</select>
			</td>
		</tr>';

		// date_start, date_finish
		$date_start = (in_array($type, array('date_start', 'date_finish')) && ! empty($params["date_start"]) ? $params["date_start"] : '');
		$date_finish = (in_array($type, array('date_start', 'date_finish')) && ! empty($params["date_finish"]) ? $params["date_finish"] : '');
		echo '
		<tr id="param_date_start" class="params param_date_start param_date_finish">
			<td class="td_first">'.$this->diafan->_('Диапазон значений').'</td>
			<td>
				<input type="text" name="param_date_start" size="20" value="'
				.($date_start ? date("d.m.Y H:i", $date_start) : '')
				.'" class="timecalendar" showTime="true">
				-
				<input type="text" name="param_date_finish" size="20" value="'
				.($date_finish ? date("d.m.Y H:i", $date_finish) : '')
				.'" class="timecalendar" showTime="true">
			</td>
		</tr>';

		// изображения
		echo '
		<tr id="param_directory" class="params param_images">
			<td class="td_first">'.$this->diafan->_('Папка с изображениями для загрузки (относительно корня сайта)').'</td>
			<td>
				<input name="param_directory" type="text" value="'.($type == 'images' && ! empty($params["directory"]) ? $params["directory"] : '').'" size="40">
			</td>
		</tr>';
	}

	/**
	 * Редактирование поля "Категория"
	 * @return void
	 */
	public function edit_variable_cat_id()
	{
		$options = array();
		$result = DB::query("SELECT id, name, type FROM {shop_import_category} WHERE trash='0'");
		while($row = DB::fetch_array($result))
		{
			$options[] = $row;
		}
		DB::free_result($result);
		if(! $this->diafan->value)
		{
			$this->diafan->value = $this->diafan->cat;
		}
		echo '
		<tr id="cat_id">
			<td class="td_first">'.$this->diafan->variable_name().'</td>
			<td>
				<select name="cat_id">';
				foreach ($options as $row)
				{
					echo '<option value="'.$row["id"].'"'.($this->diafan->value == $row["id"] ? ' selected' : '').' type="'.$row["type"].'">'.$row["name"].'</option>';
				}
				echo '</select>
				'.$this->diafan->help().'
			</td>
		</tr>';
	}

	/**
	 * Валидация поля "Тип"
	 * @return void
	 */
	public function validate_variable_type()
	{
		if($_POST["type"] == 'menu' || $_POST["type"] == 'param' || $_POST["type"] == 'empty')
		{
			return;
		}
		if($id = DB::query_result("SELECT id FROM {shop_import} WHERE cat_id=%d AND type='%h' AND trash='0' LIMIT 1", $this->diafan->cat, $_POST["type"]))
		{
			if($this->diafan->addnew || $id != $this->diafan->edit)
			{
				$this->diafan->set_error('param_type', 'Поле с такими настройками уже существует');
			}
		}
	}

	/**
	 * Валидация поля "Параметры"
	 * @return void
	 */
	public function validate_variable_params()
	{
		switch($_POST["type"])
		{
			case 'menu':
				if(! $_POST["param_menu_id"])
				{
					$this->diafan->set_error('param_menu_id', 'Выберите категорию меню');
				}
				else
				{
					$params = array("id" => $this->diafan->get_param($_POST, "param_menu_id", 0, 2));
					if($id = DB::query_result("SELECT id FROM {shop_import} WHERE cat_id=%d AND type='menu' AND params='%s' AND trash='0' LIMIT 1", $this->diafan->cat, serialize($params)))
					{
						if($this->diafan->addnew || $id != $this->diafan->edit)
						{
							$this->diafan->set_error('param_menu_id', 'Поле с такими настройками уже существует');
						}
					}
				}
				break;

			case 'param':
				if(! $_POST["param_id"])
				{
					$this->diafan->set_error('param_id', 'Выберите характеристику');
				}
				else
				{
					$params = array("id" => $this->diafan->get_param($_POST, "param_id", 0, 2));
					if($id = DB::query_result("SELECT id FROM {shop_import} WHERE cat_id=%d AND type='param' AND params='%s' AND trash='0' LIMIT 1", $this->diafan->cat, serialize($params)))
					{
						if($this->diafan->addnew || $id != $this->diafan->edit)
						{
							$this->diafan->set_error('param_id', 'Поле с такими настройками уже существует');
						}
					}
				}
				break;

			case 'date_start':
			case 'date_finish':
				$params = array();
				if(! empty($_POST["param_date_start"]))
				{
					$this->diafan->set_error('param_date_start', Validate::datetime($_POST["param_date_start"]));
				}
				if(! empty($_POST["param_date_finish"]))
				{
					$this->diafan->set_error('param_date_start', Validate::datetime($_POST["param_date_finish"]));
				}
				break;

			case 'images':
				if(empty($_POST["param_directory"]))
				{
					$this->diafan->set_error('param_directory', 'Задайте папку с изображениями');
				}
				break;
		}
	}

	/**
	 * Сохранение поля "Параметры"
	 * @return void
	 */
	public function save_variable_params()
	{
		switch($_POST["type"])
		{
			case 'menu':
				$params = array("id" => $this->diafan->get_param($_POST, "param_menu_id", 0, 2));
				break;

			case 'param':
				$params = array(
						"id" => $this->diafan->get_param($_POST, "param_id", 0, 2),
						"select_type" => $_POST["param_select_type"] == 'key' ? 'key' : 'value',
					);
				break;

			case 'price':
				$params = array(
						"delimitor" => $this->diafan->get_param($_POST, "param_delimitor", 0, 1),
						"select_type" => $_POST["param_price_select_type"] == 'key' ? 'key' : 'value',
						"count" => ! empty($_POST["param_count"]) ? 1 : 0,
						"currency" => ! empty($_POST["param_currency"]) ? 1 : 0,
						"select_currency" => $_POST["param_select_currency"] == 'key' ? 'key' : 'value'
					);
				break;

			case 'count':
				$params = array(
						"delimitor" => $this->diafan->get_param($_POST, "param_delimitor", 0, 1),
						"select_type" => $_POST["param_price_select_type"] == 'key' ? 'key' : 'value'
					);
				break;

			case 'id':
			case 'rel_goods':
				$params = array("type" => in_array($_POST["param_type"], array('site', 'article')) ? $_POST["param_type"] : '');
				break;

			case 'cats':
			case 'parent':
				$params = array("type" => in_array($_POST["param_cats_type"], array('site', 'name'))  ? $_POST["param_cats_type"] : '');
				break;

			case 'date_start':
			case 'date_finish':
				$params = array();
				if(! empty($_POST["param_date_start"]))
				{
					$params["date_start"] = $this->diafan->unixdate($_POST["param_date_start"]);
				}
				if(! empty($_POST["param_date_finish"]))
				{
					$params["date_finish"] = $this->diafan->unixdate($_POST["param_date_finish"]);
				}
				break;

			case 'images':
				$params = array('directory' => strip_tags($_POST["param_directory"]));
				break;
		}
		if(empty($params))
		{
			$params = '';
		}
		else
		{
			$params = serialize($params);
		}
		$this->diafan->set_query("params='%s'");
		$this->diafan->set_value($params);
	}
}