<?php
/**
 * Настройки модуля
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */
if (!defined('DIAFAN'))
{
    include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Site_admin_config
 */
class Site_admin_config extends Frame_admin
{
	/**
	 * @var array поля в базе данных для редактирования
	 */
	public $variables = array (
		'config' => array (
			'protect' => array(
				'type' => 'checkbox',
				'name' => 'Защита от копирования',
				'help' => 'Если отмечена, на сайте будет отключена возможность копирования текста в буфер. См. шаблонную функцию show_protect.',
			),
			'comments' => array(
				'type' => 'module',
				'name' => 'Прикрепить комментарии к страницам сайта',
				'help' => 'Если отмечена, пользователи сайта будут иметь возможность оставлять комментарии к каждой странице сайта. Комментарии для страницы сайта выводятся с помощью шаблонной функции show_comments. Комментарии выводятся только на страницах, к которым не подключен иной модуль со своими комментариями. Параметр не будет включен, если модуль «Комментарии» не установлен. Подробности см. в разделе [модуль Комментарии»](http://cms.diafan.ru/dokument/full-manual/upmodules/comments/).',
			),
			'tags' => array(
				'type' => 'module',
				'name' => 'Подключить теги',
				'help' => 'Если отмечена, к страницам сайта можно будет прикреплять теги. Теги для страницы сайта выводятся с помощью шаблонной функции show_tags. Параметр не будет включен, если модуль «Теги» не установлен. Подробности см. в разделе [модуль «Теги»](http://cms.diafan.ru/dokument/full-manual/modules/tags/).',
			),
			'hr7' => 'hr',
			'images' => array(
				'type' => 'module',
				'name' => 'Использовать изображения',
				'help' => 'Если отмечена, к страницам сайта можно будет прикреплять дополнительные изображения. Изобаржения для страницы сайта выводятся с помощью шаблонной функции show_images.',
			),
			'images_variations' => array(
				'type' => 'none',
				'name' => 'Генерировать размеры изображений',
				'help' => 'Размеры изображений, заданные в модуле «Изобаражения» и тег латинскими буквами для подключения изображения на сайте. Параметр выводится, если отмечена опция «Использовать изображения».',
				'no_save' => true,
			),
			'upload_max_filesize' => array(
				'type' => 'none',
				'name' => 'Максимальный размер загружаемых файлов',
				'help' => 'Параметр показывает максимально допустимый размер загружаемых файлов, установленный в настройках хостинга. Параметр выводится, если отмечена опция «Использовать изображения».',
				'no_save' => true,
			),
			'hr' => 'hr',	
			'keywords' => array(
				'type' => 'module',
				'name' => 'Подключить перелинковку',
				'help' => 'Отображение перелинковки в модуле. Подробности см. в разделе [модуль «Перелинковка»](http://cms.diafan.ru/dokument/full-manual/upmodules/keywords/).',
			),			
			'title_tpl' => array(
				'type' => 'text',
				'name' => 'Шаблон для автоматического генерирования Title',
				'help' => "Если шаблон задан, то заголовок автоматически генерируется по шаблону. В шаблон можно добавить:\n\n* %title – заданный заголовок,\n* %name – название,\n* %parent – название страницы верхнего уровня (SEO-специалисту).",
				'multilang' => true
			),
			'keywords_tpl' => array(
				'type' => 'text',
				'name' => 'Шаблон для автоматического генерирования Keywords',
				'help' => 'Если шаблон задан, то поле Keywords автоматически генерируется по шаблону. В шаблон можно добавить %keywords - заданные ключевые слова, %name - название, %parent - название страницы верхнего уровня (SEO-специалисту).',
				'help' => "Если шаблон задан, то поле *Keywords* автоматически генерируется по шаблону. В шаблон можно добавить:\n\n* %keywords – заданные ключевые слова,\n* %name – название,\n* %parent – название страницы верхнего уровня (SEO-специалисту).",
				'multilang' => true
			),
			'descr_tpl' => array(
				'type' => 'text',
				'name' => 'Шаблон для автоматического генерирования Description',
				'help' => "Если шаблон задан, то поле *Description* автоматически генерируется по шаблону. В шаблон можно добавить:\n\n* %descr – заданное описание,\n* %name – название,\n* %parent – название страницы верхнего уровня (SEO-специалисту).",
				'multilang' => true
			),
		),
	);

	/**
	 * @var array настройки модуля
	 */
	public $config = array (
		'config', // файл настроек модуля
	);
}