<?php
/**
 * База номеров телефонов для SMS рассылки
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */
if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Subscribtion_admin_phones
 */
class Subscribtion_admin_phones extends Frame_admin
{
	/**
	 * @var string таблица в базе данных
	 */
	public $table = 'subscribtion_phones';
	
	/**
	 * @var string категории рассылок
	 */
	public $subscribtion = '';

	/**
	 * @var array поля в базе данных для редактирования
	 */
	public $variables = array (
		'main' => array (
			'phone' => array(
				'type' => 'text',
				'name' => 'Номер телефона в федеральном формате',
				'help' => '11 цифр номера мобильного телефона.',
			),
			'name' => array(
				'type' => 'text',
				'name' => 'Имя',
				'help' => 'Имя получателя. В рассылке не участвует.',
			),
			'created' => array(
				'type' => 'date',
				'name' => 'Дата добавления',
				'help' => 'дата добавления номера в базу данных.',
			),
			'act' => array(
				'type' => 'checkbox',
				'name' => 'Получает рассылку',
				'help' => 'Позволяет отключить телефон от рассылки.',
			),
		),
	);

	/**
	 * @var array настройки модуля
	 */
	public $config = array (
		'del', // удалить
		'trash', // удалить в корзину
		'act', // показать/скрыть
	);
	
	/**
	 * @var array текст для ссылки на редактирование в списке
	 */
	public $text_for_base_link = array(
		'variable' => 'phone'
	);

	/**
	 * Выводит ссылку на добавление
	 * @return void
	 */
	public function show_add()
	{
		$this->diafan->addnew_init('Добавить номер телефона');
	}

	/**
	 * Выводит список рассылок
	 * @return void
	 */
	public function show()
	{
		$this->upload();

		$this->diafan->list_row();

		$this->form_upload();
	}

	/**
	 * Выводит форму импорт/экспорт ключевиков
	 * 
	 * @return void
	 */
	private function form_upload()
	{
		echo '<div class="block">';
		echo '<table width="100%"><tr><td valign="top" width="70%"><h2>'.$this->diafan->_('Импорт').'</h2>';
		echo '<form action="" method="post" enctype="multipart/form-data">
		<input type="hidden" name="upload" value="1">
		<input type="checkbox" name="delete_old" value="1"> '.$this->diafan->_('удалить неописанные в файле строки').'<br><br>
		<input type="file" name="file">
		<input type="submit" class="button" value="'.$this->diafan->_('Загрузить').'"><br>
		'.$this->diafan->_('*файл .txt, каждый подписчик с новой строки в формате «Имя;79998886655»').'
		</form>';
		echo '</td><td valign="top" width="30%"><h2>'.$this->diafan->_('Экспорт').'</h2><a href="'.BASE_PATH.'subscribtion/export/phones/">'.$this->diafan->_('Скачать файл phones.txt').'</a></td></tr></table>';
		echo '</div>';
	}

	/**
	 * Загружает файл перевода
	 * 
	 * @return void
	 */
	private function upload()
	{
		if(! empty($_POST["delete_old"]))
		{
			DB::query("TRUNCATE TABLE {subscribtion_phones}");
		}
		if (! isset($_FILES["file"]) || ! is_array($_FILES["file"]) || $_FILES["file"]['name'] == '')
		{
			return;
		}
		$oldphones  = array();
		if(empty($_POST["delete_old"]))
		{
			$result = DB::query("SELECT * FROM {subscribtion_phones} WHERE trash='0'");
			while($row = DB::fetch_array($result))
			{
				$oldphones[$row["phone"]] = $row["id"];
			}
			DB::free_result($result);
		}

		$file = file_get_contents($_FILES["file"]['tmp_name']);

		$newphones = explode("\n", $file);
		foreach($newphones as $s)
		{
			if(! trim($s))
			{
				continue;
			}
			list($name, $phone) = explode(';', $s);
			if(! empty($oldphones[$phone]))
			{
				DB::query("UPDATE {subscribtion_phones} SET act='1', name='%s' WHERE id=%d", $name, $oldphones[$phone]);
			}
			else
			{
				DB::query("INSERT INTO {subscribtion_phones} (act, name, phone, created) VALUES ('1', '%s', '%s', %d)", $name, $phone, time());
			}
		}
		unlink($_FILES["file"]['tmp_name']);

		$this->diafan->redirect(URL.'success1/');
	}

	/**
	 * Выводит системное сообщение
	 *
	 * @return void
	 */
	public function show_error_message()
	{
		if ($this->diafan->error)
		{
			echo '<div class="error">'.$this->diafan->_('Файл не верного формата.').'</div>';
		}

		if ($this->diafan->success)
		{
			echo '<div class="ok">'.$this->diafan->_('Изменения сохранены!').'</div>';
		}
	}
}