/**
 * Редактирование тегов, JS-сценарий
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */
$(document).ready(function(){
	$('.tags_upload').click(function(){
		var button = $(this);
		$(this).parents('form').ajaxSubmit({
			type : 'POST',
			data : {action: 'upload', module : 'tags'},
			dataType: 'json',
			url: window.location.href,

			beforeSubmit: function(a,form,o) {
				$('.errors').hide();
			},

			success: function(response, statusText, xhr, form)
			{
				if (response.error)
				{
					$(form).find(".error_tags").html(response.error).show();
				}
				if (response.id)
				{
					$(form).find("input[name=id]").val(response.id);
				}
				if (response.data && response.target)
				{
					$(response.target).html(prepare(response.data));
					$('input[name=tag]').val('');
					$('textarea[name=tags]').val('');
				}
				if (response.hash)
				{
					$('input[name=check_hash_user]').val(response.hash);
					$('.check_hash_user').text(response.hash);
				}
				$(".tags_search").hide();
				return false;
			}
		});
		return false;
	});

	$(document).on('click', ".tags_delete", function() {
		var self = $(this);
		if (! confirm(self.attr("confirm")))
		{
			return false;
		}
		$.ajax({
			url : window.location.href,
			type : 'POST',
			dataType : 'json',
			data : {
				action: 'delete',
				module: 'tags',
				tag_id : self.attr("tag_id"),
				check_hash_user : $('.check_hash_user').text()
			},
			success : (function(response)
			{
				if (response.error)
				{
					$(".error_tags").html(response.error).show();
				}
				else
				{
					$(".tags_container").html(prepare(response.data));
				}
				if (response.hash)
				{
					$('input[name=check_hash_user]').val(response.hash);
					$('.check_hash_user').text(response.hash);
				}
				$(".tags_search").hide();
			})
		});
		return false;
	});

	$('.tags_cloud').click(function() {
		var self = $(this);
		$.ajax({
			url : window.location.href,
			dataType : 'json',
			data : {
				action: 'search',
				module: 'tags',
				element_id : self.attr("element_id"),
				check_hash_user : $('.check_hash_user').text()
			},
			type : 'POST',
			success : (function(response)
			{
				if (response.error)
				{
					$(".error_tags").html(response.error).show();
				}
				if (response.data)
				{
					$(".tags_search").html(prepare(response.data)).show();
				}
				else
				{
					$(".tags_search").hide();
				}
				if (response.hash)
				{
					$('input[name=check_hash_user]').val(response.hash);
					$('.check_hash_user').text(response.hash);
				}
			})
		});
		return false;
	});
	$(document).on('click', '#tags_multiple', function(){
		if($(this).is(':checked'))
		{
			$(this).parents('#tags').find('input[name=tag]').hide();
			$(this).parents('#tags').find('textarea[name=tags]').show();
			$(this).parents('#tags').find('textarea[name=tags]').val($(this).parents('#tags').find('input[name=tag]').val());
			$(this).parents('#tags').find('input[name=tag]').val('');
		}
		else
		{
			$(this).parents('#tags').find('input[name=tag]').show();
			$(this).parents('#tags').find('textarea[name=tags]').hide();
			$(this).parents('#tags').find('input[name=tag]').val($(this).parents('#tags').find('textarea[name=tags]').val());
			$(this).parents('#tags').find('textarea[name=tags]').val('');
		}
	});

	$(document).on('click', ".tags_add", function() {
		$("input[name=tag]").val($(this).text());
		$(".tags_upload").click();
	});
});