<?php
/**
 * Редактирование тегов
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */
if (!defined('DIAFAN'))
{
    include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Tags_admin
 */
class Tags_admin extends Frame_admin
{
    /**
     * @var string таблица в базе данных
     */
    public $table = 'tags_name';

	/**
	 * @var array поля в базе данных для редактирования
	 */
	public $variables = array (
		'main' => array (
			'name' => array(
				'type' => 'text',
				'name' => 'Название',
				'multilang' => true,
			),
			'rewrite' => array(
				'type' => 'function',
				'name' => 'Псевдоссылка',
				'help' => 'ЧПУ (человеко-понятные урл url), адрес страницы вида: *http://site.ru/psewdossylka/*. Смотрите параметры сайта.',
			),
			'redirect' => array(
				'type' => 'none',
				'name' => 'Редирект на текущую страницу со страницы',
				'help' => 'Позволяет делать редирект с указанной страницы на текущую.',
				'no_save' => true,
			),
			'images' => array(
				'type' => 'module',
				'name' => 'Изображения',
				'help' => 'Назначить тегу изображение.',
			),
			'hr_map' => 'hr',
			'changefreq'   => array(
				'type' => 'function',
				'name' => 'Changefreq',
				'help' => 'Вероятная частота изменения этой страницы. Это значение используется для генерирования файла sitemap.xml. Подробнее читайте в описании [XML-формата файла Sitemap](http://www.sitemaps.org/ru/protocol.html) (SEO-специалисту).',
			),
			'priority'   => array(
				'type' => 'floattext',
				'name' => 'Priority',
				'help' => 'Приоритетность URL относительно других URL на Вашем сайте. Это значение используется для генерирования файла sitemap.xml. Подробнее читайте в описании [XML-формата файла Sitemap](http://www.sitemaps.org/ru/protocol.html) (SEO-специалисту).',
			),
			'hr_map2' => 'hr',
			'sort' => array(
				'type' => 'function',
				'name' => 'Сортировка: установить перед',
				'help' => 'Редактирование порядка отображения пункта.',
			),
			'map' => array(
				'type' => 'module',
				'name' => 'Индексирование для карты сайта',
				'help' => 'Тег автоматически индексируется для карты сайта sitemap.xml.',
			),
			'map_no_show' => array(
				'type' => 'checkbox',
				'name' => 'Не показывать на карте сайта',
				'help' => 'Скрывает отображение ссылки на новость в файле sitemap.xml и [модуле «Карта сайта»](http://cms.diafan.ru/dokument/full-manual/modules/map/).',
			),
		),
	);

	/**
	 * @var array настройки модуля
	 */
	public $config = array (
		'del', // удалить
		'trash', // использовать корзину
		'order', // сортируется
	);

	/**
	 * Выводит ссылку на добавление
	 * @return void
	 */
	public function show_add()
	{
		if(! $this->diafan->_user->roles('edit', 'tags'))
		{
			return;
		}
		echo '
		<script type="text/javascript" src="'.BASE_PATH.'modules/tags/admin/tags.admin.js"></script>
		<div class="add_new">
			<a href="'.URL.'addnew1/">'.$this->diafan->_('Добавить тег').'</a>
			/ <a href="'.URL.'" id="tags_mulitupload">'.$this->diafan->_('несколько тегов').'</a>
		</div>
		<div class="tags_mulitupload">
			<form method="post">
				<input type="hidden" name="check_hash_user" value="'.$this->diafan->_user->get_hash().'">
				<input type="hidden" name="module" value="tags">
				<input type="hidden" name="action" value="multiupload">
				<input type="hidden" name="ajax" value="">
				<textarea name="tags" cols="60" rows="7"></textarea>
				<span class="help_img"><img src="'.BASE_PATH.'adm/img/quest.gif" title="'
				.$this->diafan->_('Тег1;Псевдоссылка1')
				."Enter\n".$this->diafan->_('Тег2;Псевдоссылка2')
				."Enter\n".$this->diafan->_('Тег3;Псевдоссылка3')
				.'"></span>
				<div class="error"></div>
				<p><input type="submit" value="'.$this->diafan->_('Сохранить').'" class="button"></p>
			</form>
		</div>';
	}

	/**
	 * Вывод списка тэгов
	 * @return void
	 */
	public function show()
	{
		$this->diafan->list_row();
	}

	/**
	 * Выводит объект, к которому прикреплен тэг, в списке
	 * 
	 * @return string
	 */
	public function other_row_element_id($row)
	{
		$name = DB::query_result("SELECT name FROM {".$row["module_name"]."} WHERE id=%d LIMIT 1", $row["element_id"]);
		return '</td><td>'.($name ? $name : $row["element_id"]);
	}

	/**
	 * Выводит название модуля в списке
	 * 
	 * @return string
	 */
	public function other_row_module_name($row)
	{
		if(empty($this->cache["modules"][$row["module_name"]]))
		{
			$this->cache["modules"][$row["module_name"]] = DB::query_result("SELECT title FROM {modules} WHERE name='%h' LIMIT 1", $row["module_name"]);
		}
		return '</td><td class="other_row">'.$this->cache["modules"][$row["module_name"]];
	}

	/**
	 * Сохранение поля "Псевдоссылка"
	 * @return void
	 */
	public function edit_variable_rewrite()
	{
		$this->diafan->values["site_id"] = DB::query_result("SELECT id FROM {site} WHERE module_name='tags' LIMIT 1");
		parent::__call('edit_variable_rewrite', array());
	}

	/**
	 * Сохранение поля "Псевдоссылка"
	 * @return void
	 */
	public function save_variable_rewrite()
	{
		$_POST["site_id"] = DB::query_result("SELECT id FROM {site} WHERE module_name='tags' LIMIT 1");
		parent::__call('save_variable_rewrite', array());
	}

	/**
	 * Сопутствующие действия при удалении элемента модуля
	 * @return void
	 */
	public function delete($del_id, $trash_id)
	{
		$this->diafan->del_or_trash_where("tags", "tags_name_id=".$del_id, $trash_id);
	}
}