<?php
/**
 * Подключение для работы с тегами
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Tags_inc
 */
class Tags_inc extends Model
{
	/**
	 * @var integer номер страницы тэгов
	 */
	public $site_id;

	/*
	 * @var boolean модуль "Теги" установлен
	 */
	private $installed = 'no_check';

	/**
	 * Выводит подключенные к элементу тэги
	 *
	 * @param integer $element_id номер элемента, к котором прикреплены теги
	 * @param strint $module_name название модуля
	 * @param integer $site_id страница сайта, к которой прикреплен элемент
	 * @return string|boolean false
	 */
	public function get($element_id = 0, $module_name = '', $site_id = 0)
	{
		if($this->installed === 'no_check')
		{
			$this->site_id = DB::query_result("SELECT id FROM {site} WHERE module_name='tags' AND [act]='1' LIMIT 1");
			if(! $this->site_id)
			{
				$this->installed = false;
			}
		}
		if(! $this->installed)
			return false;

		$module_name = ! $module_name ? $this->diafan->module : $module_name;
		$site_id = ! $site_id ? $this->diafan->cid : $site_id;
		$element_id = ! $element_id ? ($this->diafan->show ? $this->diafan->show : $this->diafan->cat) : $element_id;

		if (! $this->diafan->configmodules("tags", $module_name, $site_id) || ! $element_id)
			return false;

		$this->prepare($element_id, $module_name);
		if(! empty($this->cache["prepare"]))
		{
			$where = array();
			$values = array();
			foreach($this->cache["prepare"] as $pr_module_name => $array)
			{
				$values[] = $pr_module_name;
				foreach($array as $pr_element_id => $a)
				{
					$this->cache["tags"][$pr_module_name][$pr_element_id] = array();
					$values[] = $pr_element_id;
					$v_array[] = '%d';
				}
				$where[] = "t.module_name='%h' AND t.element_id".(count($array) > 1 ? " IN (".implode(",", $v_array).")" : "=%d");
			}
			$result = DB::query("SELECT n.[name], n.id, t.module_name, t.element_id FROM {tags_name} AS n"
				." INNER JOIN {tags} AS t ON t.tags_name_id=n.id"
				." WHERE (".implode(" OR ", $where).") AND n.trash='0' AND t.trash='0'"
				." ORDER BY n.sort DESC", $values);
			$rows = array();
			
			while ($row = DB::fetch_array($result))
			{
				$row["link"] = $this->diafan->_route->link($this->site_id, "tags", 0, $row["id"]);
				$this->cache["tags"][$row["module_name"]]['e'.$row["element_id"]][] = $row;
			}
			DB::free_result($result);
			unset($this->cache["prepare"]);
		}
	
		return $this->diafan->_tpl->get('get', 'tags', $this->cache["tags"][$module_name]['e'.$element_id]);
	}

	/**
	 * Запоминает данные элемента, которому нужно будет вывести теги
	 *
	 * @param integer $element_id номер элемента, к котором прикреплены теги
	 * @param strint $module_name название модуля
	 * @return void
	 */
	public function prepare($element_id = 0, $module_name = '')
	{
		$module_name = ! $module_name ? $this->diafan->module : $module_name;
		$element_id = ! $element_id ? ($this->diafan->show ? $this->diafan->show : $this->diafan->cat) : $element_id;

		if(isset($this->cache["tags"][$module_name]['e'.$element_id]))
		{
			return;
		}
		if(! isset($this->cache["prepare"][$module_name]['e'.$element_id]))
		{
			$this->cache["prepare"][$module_name]['e'.$element_id] = $element_id;
		}
	}
}