<?php
/**
 * Контроллер
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Tags
 */
class Tags extends Controller
{
	/**
	 * Инициализация модуля
	 * 
	 * @return void
	 */
	public function init()
	{
		$this->rewrite_variable_names = array('page', 'show');
		if (! $this->diafan->show)
		{
			$this->result = $this->model->show_block(true);
		}
		else
		{
			$this->result = $this->model->list_module();
		}

		if (! empty($this->result["title"]))
		{
			$this->diafan->name = $this->result["title"];
		}
	}

	/**
	 * Выводит контент модуля
	 * 
	 * @return void
	 */
	public function show_module()
	{
		if (! $this->diafan->show)
		{
			$this->diafan->_tpl->get('show_block', 'tags', $this->result);
		}
		else
		{
			$this->diafan->_tpl->get('list', 'tags', $this->result);
		}
	}

	/**
	 * Шаблонная функция: выводит список тегов.
	 * 
	 * @param array $attributes атрибуты шаблонного тега
	 * template - шаблон тега (файл modules/tags/views/tags.view.show_block_**template**.php; по умолчанию шаблон modules/tags/views/tags.view.show_block.php)
	 * 
	 * @return void
	 */
	public function show_block($attributes)
	{
		if ($this->diafan->module == "tags" && ! $this->diafan->show)
			return;

		$attributes = $this->get_attributes($attributes, 'template');
		$result = $this->model->show_block();

		if (! $attributes["template"] || ! $this->diafan->_tpl->get('show_block_'.$attributes["template"], 'tags', $result))
		{
			$this->diafan->_tpl->get('show_block', 'tags', $result);
		}
	}
}