<?php
/**
 * Установка/удаление модулей
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Update_admin_install
 */
class Update_admin_install extends Frame_admin
{
	/**
	 * Выводит контент модуля
	 * @return void
	 */
	public function show()
	{
		$rows = $this->get_rows();
		$module_rows = array('news', 'clauses', 'feedback', 'faq', 'shop', 'ab', 'files', 'comments', 'rating', 'tags', 'photo', 'votes', 'subscribtion', 'users', 'forum', 'search', 'map', 'keywords', 'filemanager', 'mistakes');
		$modules = array();
		foreach ($module_rows as $val)
		{
			if (! empty($rows[$val]))
			{
				$modules[] = $rows[$val];
			}
		}
		foreach ($rows as $row)
		{
			if (! in_array($row["module_name"], $module_rows))
			{
				$modules[] = $row;
			}
		}

		if ($this->diafan->page == 2)
		{
			echo '<font color="red">'.$this->diafan->_('Все модули установлены!').'</font>';
		}
		echo '<form action="'.$this->diafan->get_admin_url().'save1/" method="POST">';
		echo '<p>'.$this->diafan->_('Доступны следующие модули для установки/удаления').':</p>
		<input type="hidden" name="check_hash_user" value="'.$this->diafan->_user->get_hash().'">';
		foreach ($modules as $row)
		{
			echo '<p><input type="checkbox" name="'.$row["module_name"].'" '.($row["installed"] ? 'checked' : '').'> <b>'.$row["name"].'</b></p>';
			$k = 1;
		}
		echo '<hr><p><input type="checkbox" name="example_yes" value="1"> '.$this->diafan->_('Заполнить сайт примерами из <a href="http://demo.cms.diafan.ru/" target="_blank">демо-версии</a> (может занять время). Только для устанавливаемых модулей.').'</p>';
		echo '<input type="submit" value="'.$this->diafan->_('Установить').'" class="button" onmouseover="this.style.cursor=\'hand\';">';
		echo '
		</form>';
	}

	/**
	 * Установка/удаление модулей
	 * @return void
	 */
	public function save()
	{
		// Прошел ли пользователь проверку идентификационного хэша
		if (! $this->diafan->_user->checked)
		{
			$this->diafan->redirect(URL);
			return;
		}

		$rows = $this->get_rows(false);
		if (! $rows)
		{
			$this->diafan->redirect($this->diafan->get_admin_url('page').'page2/');
		}
		$inst = new Install($this->diafan->languages);
		foreach ($rows as $module => $row)
		{
			if (empty($_POST[$module]) && ! $row["installed"] || ! empty($_POST[$module]) && $row["installed"])
				continue;

			// удаление модуля
			if (empty($_POST[$module]) && $row["installed"])
			{
				$inst->uninstall($module);
			}
			else
			{
				$inst->install($module, (!empty($_POST["example_yes"])));
				//установка прав на административную часть установленного модуля текущему пользователю
				if(! $this->diafan->_user->roles('all', 'all'))
				{
					$result = DB::query("SELECT rewrite FROM {adminsite} WHERE rewrite='%s' OR rewrite LIKE '%s%%'", $module, $module);
					while ($r = DB::fetch_array($result))
					{
						DB::query("INSERT INTO {users_role_perm} (role_id, perm, rewrite, type) VALUES (%d, 'all', '%s', 'admin')", $this->diafan->_user->role_id, $r["rewrite"]);
					}
					DB::free_result($result);
				}
			}
		}

		$this->diafan->redirect($this->diafan->get_admin_url('page').'page2/');
	}

	/**
	 * Получает список всех модулей которые можно установить
	 *
	 * @param boolean $add_title добавить в массив информацию о названии модуля
	 * @return array
	 */
	private function get_rows($add_title = true)
	{
		$modules = array();
		$result = DB::query("SELECT * FROM {modules} WHERE module_name=name");
		while($row = DB::fetch_array($result))
		{
			$modules[$row["module_name"]] = $row;
		}
		DB::free_result($result);
		Customization::inc("includes/install.php");
		$rows = array();
		$dirr = opendir(ABSOLUTE_PATH."modules");
		while (($module = readdir($dirr)) !== false)
		{	  
			if (file_exists(ABSOLUTE_PATH.'modules/'.$module.'/'.$module.'.install.php'))
			{
				$row["installed"] = in_array($module, array_keys($modules));
				if($add_title)
				{
					if($row["installed"])
					{
						$row["name"] = $modules[$module]["title"];
					}
					else
					{
						$title = '';
						include(ABSOLUTE_PATH.'modules/'.$module.'/'.$module.'.install.php');
						$row["name"] = ! empty($title) ? $title : '';
					}
					if(! $row["name"])
					{
						$row["name"] = $module;
					}
					$row["module_name"] = $module;
				}
				$rows[$module] = $row;
			}
		}
		closedir($dirr);
		return $rows;
	}
}