<?php
/**
 * Модель модуля «Страница пользователя»
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */
if (!defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))) . '/includes/404.php');
}

/**
 * Userpage_model
 */
class Userpage_model extends Model
{
	/**
	 * Генерирует данные для страницы пользователя
	 * 
	 * @return array
	 */
	public function show()
	{
		if(empty($_GET["name"]) && ! $this->diafan->_user->id)
		{
			include ABSOLUTE_PATH.'includes/404.php';
		}
		if(empty($_GET["name"]))
		{
			$name = $this->diafan->_user->name;
		}
		else
		{
			$name = $_GET["name"];
		}

		$this->result = DB::query_fetch_array("SELECT id, fio, name, created FROM {users} WHERE name='%s' AND act='1' AND trash='0' LIMIT 1", $name);
		if(! $this->result)
		{
			include ABSOLUTE_PATH.'includes/404.php';
		}

		$this->result['created'] = $this->format_date($this->result['created'], 'users');

		if ($this->diafan->configmodules("avatar", "users"))
		{
			$this->result["avatar"] = file_exists(ABSOLUTE_PATH . USERFILES.'/avatar/' . $this->result['name'] . '.png');
			$this->result["avatar_width"] = $this->diafan->configmodules("avatar_width", "users");
			$this->result["avatar_height"] = $this->diafan->configmodules("avatar_height", "users");
		}

		$this->result['param'] = $this->get_params(array("module" => "users", "where" => "show_in_page='1'"));
		$param_types_array = array();
		foreach ($this->result["param"] as $i => $row)
		{
			if($row["type"] == "attachments")
			{
				$config = unserialize($row["config"]);
				if($config["attachments_access_admin"])
				{
					unset($this->result["param"][$i]);
					continue;
				}
				$this->result["param"][$i]["use_animation"] = ! empty($config["use_animation"]) ? true : false;
			}
			$param_types_array[$row["id"]] = $row;
		}

		$result = DB::query("SELECT value, param_id FROM {users_param_element} WHERE trash='0' AND element_id=%d", $this->result["id"]);
		while ($row = DB::fetch_array($result))
		{
			if(empty($param_types_array[$row["param_id"]]))
				continue;

			switch ($param_types_array[$row["param_id"]]["type"])
			{
				case 'multiple':
				case 'select':
					$user_param[$row["param_id"]][] = $param_types_array[$row["param_id"]]["select_values"][$row["value"]];
					break;
				case 'checkbox':
					$user_param[$row["param_id"]] = @$param_types_array[$row["param_id"]]["select_values"][$row["value"]];
					break;
				case 'date':
					$user_param[$row["param_id"]] = $this->diafan->formate_from_date($row["value"]);
					break;
				case 'datetime':
					$user_param[$row["param_id"]] = $this->diafan->formate_from_datetime($row["value"]);
					break;
				default:
					$user_param[$row["param_id"]] = $row["value"];
			}
		}
		DB::free_result($result);
		foreach($this->result['param'] as $i => $row)
		{
			if($row["type"] == "attachments")
			{
				$row["value"] = $this->diafan->_attachments->get($this->result["id"], "users", $row["id"]);
			}
			elseif($row["type"] == "images")
			{
				$row["value"] = $this->diafan->_images->get('large', $this->result["id"], "users", 0, '', $row["id"]);
			}
			else
			{
				$row["value"] = ! empty($user_param[$row["id"]]) ? $user_param[$row["id"]] : '';
			}
			if(! $row["value"] && $row["type"] == 'checkbox')
			{
				$row["value"] = @$row["select_values"][0];
			}
			$this->result['param'][$i] = $row;
		}

		$this->result['form_messages'] = $this->diafan->_user->id && $this->result["id"] != $this->diafan->_user->id && $this->diafan->_route->id_module("messages");

		$this->result['orders'] = $this->orders();

		return $this->result;
	}

	/**
	 * Формирует список заказов пользователя
	 * @return array
	 */
	public function orders()
	{
		if(! $this->diafan->_user->id)
			return;

		if(! $this->diafan->_route->id_module('cart'))
			return;

		$orders = array();

		$result = DB::query("SELECT id, [name] FROM {shop_order_status} ORDER BY sort DESC");
		while($row = DB::fetch_array($result))
		{
			$status[$row["id"]] = $row["name"];
		}
		DB::free_result($result);

		$result = DB::query("SELECT id, status, status_id, summ, created FROM {shop_order} WHERE trash='0' AND user_id='%d' ORDER by created DESC", $this->diafan->_user->id);

		$itogo = 0;
		while ($row = DB::fetch_array($result))
		{
			$order = array(
				'status'  => $row['status'],
				'status_name'  => $status[$row['status_id']],
				'summ'    => $this->diafan->_shop->price_format($row["summ"]),
				'created' => $this->format_date($row['created'], 'users'),
				'id'      => $row['id']);

			if ($row["status"] == '3')
			{
				$itogo = $itogo + $row["summ"];
			}

			$good_ids = array();
			$r  = DB::query("SELECT good_id, price, id FROM {shop_order_goods} WHERE trash='0' AND order_id=%d", $row['id']);
			while ($r2 = DB::fetch_array($r))
			{
				$r2["price"] = $this->diafan->_shop->price_format($r2["price"]);
				$result_p = DB::query("SELECT * FROM {shop_order_goods_param} WHERE order_good_id=%d", $r2["id"]); 
				while ($row_p = DB::fetch_array($result_p))
				{
					if(! $row_p["value"])
						continue;
					$param_name  = DB::query_result("SELECT [name] FROM {shop_param} WHERE id=%d LIMIT 1", $row_p["param_id"]);
					$param_value = DB::query_result("SELECT [name] FROM {shop_param_select} WHERE id=%d AND param_id=%d LIMIT 1", $row_p["value"], $row_p["param_id"]);
					$r2["params"][] = array("name" => $param_name, "value" => $param_value);
				}
				DB::free_result($result_p);
				$order['goods'][] = $r2;
				$good_ids[] = $r2["good_id"];
			}
			DB::free_result($r);

			if (!empty($good_ids))
			{
				$r  = DB::query("SELECT id, site_id, cat_id, [name] FROM {shop} WHERE trash='0' AND id IN (%s)", implode(",", $good_ids));
				while ($r2 = DB::fetch_array($r))
				{
					$goods[$r2["id"]] = array(
						"link" => $this->diafan->_route->link($r2['site_id'], 'shop', $r2['cat_id'], $r2['id']),
						"name" => $r2["name"],
					);
				}
				DB::free_result($r);
			}
			foreach($order['goods'] as $i => $good)
			{
				$order['goods'][$i]["name"] = $goods[$good["good_id"]]["name"];
				$order['goods'][$i]["link"] = $goods[$good["good_id"]]["link"];
			}

			$orders[] = $order;
		}
		DB::free_result($result);

		$total = $this->diafan->_shop->price_format($itogo);

		return array('rows' => $orders, 'total' => $total, 'currency' => $this->diafan->configmodules("currency", "shop"));
	}
}
