<?php
/**
 * Редактирование ответов для голосования
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Votes_admin_element
 */
class Votes_admin_element extends Frame_admin
{
	/**
	 * @var string таблица в базе данных
	 */
	public $table = 'votes';

	/**
	 * @var array поля в базе данных для редактирования
	 */
	public $variables = array (
		'main' => array (
			'name' => array(
				'type' => 'text',
				'name' => 'Ответ',
				'multilang' => true,
			),
			'act' => array(
				'type' => 'checkbox',
				'name' => 'Опубликовать на сайте',
				'help' => 'Публикация на сайте, активность.',
				'default' => true,
				'multilang' => true,
			),
			'count_votes' => array(
				'type' => 'numtext',
				'name' => 'Количество голосов',
				'help' => 'Количество выбравших данный ответ.',
			),
			'cat_id' => array(
				'type' => 'function',
				'name' => 'Вопрос',
			),
			'sort' => array(
				'type' => 'function',
				'name' => 'Сортировка: установить перед',
				'help' => 'Редактирование порядка отображения пункта. Поле доступно для редактирования только для показанных на сайте ответов.',
			),
		),
	);

	/**
	 * @var array настройки модуля
	 */
	public $config = array (
		'del', // удалить
		'act', // показать/скрыть
		'trash', // использовать корзину
		'order', // сортируется
		'element', // используются группы
		'category_flat', // категори не содержат вложенности
	);

	/**
	 * @var array выводить в списке содержание полей:
	 */
	public $config_other_row = array (
		'count_votes' => 'string',
	);

	/**
	 * Выводит ссылку на добавление
	 * @return void
	 */
	public function show_add()
	{
		$this->diafan->addnew_init('Добавить вариант ответа');
	}

	/**
	 * Выводит списко ответов
	 * @return void
	 */
	public function show()
	{	
		$this->diafan->list_row($this->diafan->cat);
	}
}