<?php
/**
 * Модель
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Votes_model
 */
class Votes_model extends Model
{
	/**
	 * Генерирует данные для шаблонной функции: опросы
	 *
	 * @param integer $id идентификатор опроса
	 * @param integer $count количество опросов
	 * @return array
	 */
	public function show_block($id, $count)
	{
		$this->result["rows"] = array();
		if (! empty($id))
		{
			$result = DB::query(
				"SELECT c.id, c.[name], c.no_result, c.userversion FROM {votes_category} as c"
				." INNER JOIN {votes_category_site_rel} AS r ON r.element_id=c.id AND (r.site_id=%d OR r.site_id=0)"
				." WHERE c.[act]='1' AND c.trash='0'"
				." AND c.id=%d GROUP BY c.id", $this->diafan->cid, $id
			);
			$this->result["rows"] = array();

			while ($row = DB::fetch_array($result))
			{
				$this->result["rows"][] = $row;
			}
			DB::free_result($result);
		}
		else
		{
			$rows = array();
			$result = DB::query(
				"SELECT c.id, c.[name], c.no_result, c.userversion FROM {votes_category} as c"
				." INNER JOIN {votes_category_site_rel} AS r ON r.element_id=c.id AND (r.site_id=%d OR r.site_id=0)"
				." WHERE c.[act]='1' AND c.trash='0'"
				." GROUP BY c.id ORDER BY c.sort ASC", $this->diafan->cid
			);

			while ($row = DB::fetch_array($result))
			{
				$rows[] = $row;
			}
			DB::free_result($result);
			$max_count = count($rows);

			if($count === "all" || $count >= $max_count)
			{
				$this->result["rows"] = $rows;
			}
			else
			{
				if (! empty($rows))
				{
					$rands = array();
					while($count)
					{
						$rand = mt_rand(0, $max_count - 1);
						if(! in_array($rand, $rands))
						{
							$rands[] = $rand;
							$this->result["rows"][] = $rows[$rand];
							$count--;
						}
					}
				}
			}
		}
		foreach($this->result["rows"] as $i => $row)
		{
			if(empty($this->cache["prepare"]) || ! in_array($row["id"], $this->cache["prepare"]))
			{
				$this->cache["prepare"][] = $row["id"];
			}
		}
		foreach($this->result["rows"] as $i => $row)
		{
			$this->result["rows"][$i] = $this->answers($row);
		}

		return $this->result["rows"];
	}

	/**
	 * Форматирует данные о запросе
	 *
	 * @param resource $result результат выполнения SQL-запроса
	 * @return array
	 */
	private function answers($row)
	{
		if(! empty($this->cache["prepare"]))
		{
			foreach($this->cache["prepare"] as $id)
			{
				$this->cache["answers"][$id] = array();
				$this->cache["summ"][$id] = 0;
				$this->cache["userversion_summ"][$id] = 0;
			}
			if($this->diafan->configmodules("sort_count_votes", "votes"))
			{
				$sort = "count_votes DESC";
			}
			else
			{
				$sort = "sort DESC";
			}
			$result_answer = DB::query("SELECT id, [name], cat_id, count_votes FROM {votes} WHERE trash='0' AND cat_id IN (%s) AND [act]='1' ORDER BY ".$sort, implode(",", $this->cache["prepare"]));
			while ($row_answer = DB::fetch_array($result_answer))
			{
				$this->cache["answers"][$row_answer["cat_id"]][] = $row_answer;
				$this->cache["summ"][$row_answer["cat_id"]] += $row_answer["count_votes"];
			}
			DB::free_result($result_answer);
			$result_uv = DB::query("SELECT COUNT(*) as count, cat_id FROM {votes_userversion} WHERE trash='0' AND cat_id IN (%s) GROUP BY cat_id", implode(",", $this->cache["prepare"]));
			while ($row_uv = DB::fetch_array($result_uv))
			{
				$this->cache["userversion_summ"][$row_uv["cat_id"]] = $row_uv["count"];
				$this->cache["summ"][$row_uv["cat_id"]] += $row_uv["count"];
			}
			DB::free_result($result_uv);
			unset($this->cache["prepare"]);
		}

		$result = array();
		$result["question_id"] = $row["id"];
		$result["answers"] = array();
		$result["no_result"] = $row["no_result"];
		$result["userversion"] = $row["userversion"];
		if ($this->check_log($row["id"]))
		{
			$result["captcha"] = '';
			if ($this->diafan->configmodules('security', 'votes') == 2)
			{
				$result["captcha"] = $this->diafan->_captcha->get("votes".$row["id"], $this->get_error("votes".$row["id"], "captcha"));
			}
			$result["answers"] = $this->cache["answers"][$row["id"]];
			foreach($result["answers"] as $i => $answer)
			{
				$result["answers"][$i]["name"] = $this->diafan->_useradmin->get($answer["name"], 'name', $answer["id"], 'votes', _LANG);
			}
			$result["answers"] = $this->diafan->_tpl->get('form', 'votes', $result);
		}
		else
		{
			$result["answers"] = $this->cache["answers"][$row["id"]];
			foreach($result["answers"] as $i => $answer)
			{
				$result["answers"][$i]["count"] = $answer["count_votes"];
				$result["answers"][$i]["persent"] = $this->cache["summ"][$row["id"]] ? round($answer["count_votes"] / $this->cache["summ"][$row["id"]] * 100) : 0;
			}
			
			if($row["userversion"])
			{
				$ra["count"] = $this->cache["userversion_summ"][$row["id"]];
				$ra["persent"] = $this->cache["summ"][$row["id"]] ? round($this->cache["userversion_summ"][$row["id"]] / $this->cache["summ"][$row["id"]] * 100) : 0;
				$ra["name"] = $this->diafan->_('Свой вариант');
				$result["answers"][] = $ra;
			}

			$result["summ"] = $this->cache["summ"][$row["id"]];
			$result["answers"] = $this->diafan->_tpl->get('answers', 'votes', $result);
		}			
		$result["question"] = $this->diafan->_useradmin->get($row["name"], 'name', $row["id"], 'votes_category', _LANG);
		$result["error"] = $this->get_error("votes".$row["id"]);
		return $result;
	}

	/**
	 * Проверяет доступ к голосованию
	 * 
	 * @return boolean
	 */
	private function check_log($id)
	{
		if ($this->diafan->configmodules('security_user', 'votes') && ! $this->diafan->_user->id)
		{
			return false;
		}
		if ($this->diafan->configmodules('security', 'votes') == 3)
		{
			if (DB::query_result("SELECT id FROM {log_note} WHERE session_id='%s' AND element_id='%d' AND include_name='votes' LIMIT 1",
			                    $this->diafan->configmodules('security_user', 'votes') ? $this->diafan->_user->id : session_id(), $id))
			{
				return false;
			}
		}
		elseif ($this->diafan->configmodules('security', 'votes') == 4)
		{
			if (! empty($_SESSION["votes"][$id]))
			{
				return false;
			}
		}
		return true;
	}
}