<?php
/**
 * Контроллер
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Votes
 */
class Votes extends Controller
{
	/**
	 * Шаблонная функция: выводит опросы.
	 * 
	 * @param array $attributes атрибуты шаблонного тега
	 * id - задает номер вопроса
	 * count - количество вопросов. Значение all выведет все вопросы. По умолчанию 1
	 * template - шаблон тега (файл modules/votes/views/votes.view.show_block_**template**.php; по умолчанию шаблон modules/votes/views/votes.view.show_block.php)
	 * 
	 * @return void
	 */
	public function show_block($attributes)
	{
		if ($this->diafan->configmodules('security_user', 'votes') && ! $this->diafan->_user->id)
			return;

		$attributes = $this->get_attributes($attributes, 'id', 'count', 'template');
		
		$id   = intval($attributes["id"]);
		if($attributes["count"] === "all")
		{
			$count = "all";
		}
		else
		{
			$count   = intval($attributes["count"]);
			if($count < 1)
			{
				$count = 1;
			}
		}
		$result = $this->model->show_block($id, $count);
		if (! $attributes["template"] || ! $this->diafan->_tpl->get('show_block_'.$attributes["template"], 'votes', $result))
		{
			$this->diafan->_tpl->get('show_block', 'votes', $result);
		}
	}
}