<?php
/**
 * Основной шаблон сайта
 * 
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */
 
if(! defined("DIAFAN"))
{
	include dirname(dirname(__FILE__)).'/includes/404.php';
}
?><!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html><head>
<!-- Это обычный HTML-файл, какой получается у любого верстальщика. Если данный файл поместить в папку themes, то diafan.CMS выведет его в качестве дизайна для сайта. Если diafan.CMS находит специальные шаблонные теги, то вместо них выводится необходимая информация. Устроен специальный шаблонный тег так: insert name="..." плюс атрибуты, все в угловых скобках -->
<!-- шаблонный тег вывода заголовка сайта в браузере -->
<title><insert name="show_title"></title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<!-- шаблонный тег вывода тега описания -->
<meta name="description" content="<insert name="show_description">">
<!-- шаблонный тег вывода ключевых слов -->
<meta name="keywords" content="<insert name="show_keywords">">
<meta content="Russian" name="language">
<meta content="DiAfan http://www.diafan.ru/" name="author">
<link href="<insert name="path">css/default.css" rel="stylesheet" type="text/css">
<link href="<insert name="path">css/style.css" rel="stylesheet" type="text/css">

<!-- шаблонный тег <insert name="path"> выводит абсолютный путь к сайту. Нужен, если CMS находится в подпапке. Если сайт лежит на домене, то можно заменить на / -->
<link rel="alternate" type="application/rss+xml" title="RSS" href="<insert name="path_url">news/rss/">

<!-- шаблонный тег show_js выводит список поключаемых JS-скриптов. В целом, все теги без указания модулей правятся в файле includes/function.php в соответствующих одноименных функциях. -->
<insert name="show_js">

<script type="text/javascript" src="<insert name="path">js/hoverIntent.js" charset="UTF-8"></script>
<script type="text/javascript" src="<insert name="path">js/superfish.js" charset="UTF-8"></script>
<link href="<insert name="path">css/menu.css" rel="stylesheet" type="text/css">
<script type="text/javascript">
	$(document).ready(function() {  $('ul.sf-menu').superfish(); });
</script>
</head>

<body <insert name="show_protect">> <!-- шаблонный тег вывода скрипта блокировки правой кнопки мыши и копирования текста -->
	<div class="page">
		<div class="page_top">
			<div class="page_bottom">
				<div class="main">
					<div class="head">
						<div class="home_icon">
							<!-- шаблонный тег вывода "умной ссылки" в виде картинки, которая не ссылается сама на себя и на активной странице выводит другую картинку. Если это не требуется, можно заменить на классические <a href="/"><img src="/img/home.png"></a>  -->
							<insert name="show_href" rewrite="" img="img/home.png" img_act="img/home_act.png"  alt="Главная страница">
						</div>
						<div class="feedback_icon">
							<!-- шаблонный тег show_href выведет ссылку на обратную связь <a href="/feedback/"><img src="/img/feedback.png"></a>, на странице обратной связи тег выведет активную иконку -->
							<insert name="show_href" rewrite="feedback" img="img/feedback.png"  img_act="img/feedback_act.png" alt="Обратная связь">
						</div>
						<div class="map_icon">
							<!-- шаблонный тег show_href выведет ссылку на карту сайта <a href="/map/"><img src="/img/map.png"></a>, на странице карты сайта тег выведет активную иконку -->
							<insert name="show_href" rewrite="map" img="img/map.png"  img_act="img/map_act.png" alt="Карта сайта">
						</div>
						<div class="logo">
							<!-- шаблонный тег вывода "умной ссылки", которая не ссылается сама на себя. Если это не требуется, можно заменить на классические <a href="/">Название сайта</a>  -->
							<span><insert name="show_href" rewrite="" alt="title"></span>
						</div>
						
						<div class="top_phone_text">
							<insert value="Контактный телефон">
						</div>
						<div class="top_phone">
							<insert name="show_block" module="site" id="1">
						</div>
						
						<div class="top_clock_text">
							<insert value="Часы работы">
						</div>
						<div class="top_clock">
							<insert value="09:00 -19:00">
						</div>
						
						<div class="add_favorites">
							<a onclick="add2Fav(this)" href="#">
								<span><insert value="Добавить в избранное"></span>
							</a>
						</div>

						<!-- шаблонный тег вывода блока ссылок на разные языковые версии сайта. Вид формы редактируется в файле modules/languages/views/languages.view.show_block.php. -->
						<insert name="show_block" module="languages">
						
						<!-- шаблонный тег вывода формы поиска. Вид формы редактируется в файле modules/shop/views/search.view.show_search.php. -->
						<insert name="show_search" module="search" template="top">
						
						<div class="top_menu">
							<div class="top_menu_right">
								<div class="top_menu_x">
									<!-- шаблонный тег вывода первого меню (параметр id=1). Настраивается в файле modules/menu/views/menu.view.show_block_topmenu.php 
									Документация тега http://cms.diafan.ru/dokument/full-manual/templates-functions/#show_block_menu -->
									<insert name="show_block" module="menu" id="1" template="topmenu">
								</div>
							</div>
						</div>
						
					</div>
					
					<div class="content">
					<table cellpadding="0" cellspacing="0" width="100%"><tr>
						<td class="col_left">
							<div class="left_menu">
							<div class="left_menu_top"></div>
							<div class="left_menu_bottom"></div>
								<!-- шаблонный тег вывода третьего меню (параметр id=3). Настраивается в файле modules/menu/views/menu.view.show_block.php
									Документация тега http://cms.diafan.ru/dokument/full-manual/templates-functions/#show_block_menu -->
								<insert name="show_block" module="menu" id="3" template="default">
							</div>
							
							<div class="left_catalog">
								<!-- шаблонный тег вывода второго меню (параметр id=2). Настраивается в файле modules/menu/views/menu.view.show_menu.php, так как параметр template не был передан. Тогда в оформлении используются параметры tag 
									Документация тега http://cms.diafan.ru/dokument/full-manual/templates-functions/#show_block_menu -->
								<insert name="show_block" module="menu" 
								id="2" 
								tag_level_start_1="[ul]"
								tag_start_1="[li]" 
								tag_end_1="[/li]" 
								tag_level_end_1="[/ul]"
								tag_level_start_2=""
								tag_start_2="[li class='podmenu']" 
								tag_end_2="[/li]"
								tag_level_end_2=""
								>
							</div>

						<!-- шаблонный тег вывода форма добавления купона. Вид формы редактируется в файле modules/shop/views/shop.view.show_add_coupon.php. -->
							<insert name="show_add_coupon" module="shop">
							
							<!-- шаблонный тег вывода формы поиска по товарам. Вид формы редактируется в файле modules/shop/views/search.view.show_search.php. -->
							<insert name="show_search" module="shop" cat_id="current" ajax="true">
							
							<!-- шаблонный тег вывода блока вопросов и ответов сайта. Вид блока редактируется в файле modules/faq/views/faq.view.show_block.php. -->
							<insert name="show_block" module="faq" count="2" often="0">
							
							<!-- шаблонный тег вывода блока некоторых товаров из магазина. Вид блока товаров редактируется в файле modules/shop/views/shop.view.show_block.php. -->
							<insert name="show_block" module="shop" sort="rand" count="1" images="1">
							
							<!-- шаблонный тег вывода блока некоторых позиций из файлового архива. Вид блока файлов редактируется в файле modules/files/views/files.view.show_block.php. -->
							<insert name="show_block" module="files" count="2" images="1">
							
							<!-- шаблонный тег вывода блока некоторых позиций из объявлений. Вид блока объявлений редактируется в файле modules/as/views/as.view.show_block.php. -->
							<insert name="show_block" module="ab" count="2" images="1">
							
						</td>
						
						<td class="col_center">
							<!-- шаблонный тег вывода навигации "Хлебные крошки"-->
							<insert name="show_path">
							
							<!-- шаблонный тег вывода основного контента сайта -->
							<insert name="show_body">
							
							<!-- шаблонный тег вывода блока товаров, связанных с текущим товаром. Блок выводиться только на странице товара. Вид блока файлов редактируется в файле modules/shop/views/shop.view.show_block_rel.php. -->
							<insert name="show_block_rel" module="shop" count="3" images="1">
							
							<!-- шаблонный тег вывода блока файлов, связанных с текущим файлом. Блок выводиться только на странице файла. Вид блока файлов редактируется в файле modules/files/views/files.view.show_block_rel.php. -->
							<insert name="show_block_rel" module="files" count="3" images="1">
							
							<!-- шаблонный тег вывода блока фотографий, связанных с текущей фотографией. Блок выводиться только на странице фотографии. Вид блока файлов редактируется в файле modules/photo/views/photo.view.show_block_rel.php. -->
							<insert name="show_block_rel" module="photo" count="3">
							
							<!-- шаблонный тег вывода блока вопросов, связанных с текущим вопросом. Блок выводиться только на странице вопроса. Вид блока файлов редактируется в файле modules/faq/views/faq.view.show_block_rel.php. -->
							<insert name="show_block_rel" module="faq" count="3">
							
							<!-- шаблонный тег вывода блока новостей, связанных с текущей новостью. Блок выводиться только на странице новости. Вид блока файлов редактируется в файле modules/news/views/news.view.show_block_rel.php. -->
							<insert name="show_block_rel" module="news" count="3" images="1">
							
							<!-- шаблонный тег вывода блока статей, связанных с текущей статьей. Блок выводиться только на странице статьи. Вид блока файлов редактируется в файле modules/clauses/views/clauses.view.show_block_rel.php. -->
							<insert name="show_block_rel" module="clauses" count="3" images="1">
							
							<!-- шаблонный тег вывода блока похожих тем форума. Вид блока файлов редактируется в файле modules/forum/views/forum.view.show_block_rel.php. -->
							<insert name="show_block_rel" module="forum" count="3" cat_id="all">
							
							<!-- шаблонный тег вывода блока последних тем форума. Вид блока файлов редактируется в файле modules/forum/views/forum.view.show_block.php. -->
							<insert name="show_block" module="forum" count="3" cat_id="all">
							
							<!-- шаблонный тег вывода блока последних сообщений на форуме. Вид блока файлов редактируется в файле modules/forum/views/forum.view.show_block_messages.php. -->
							<insert name="show_block_messages" module="forum" count="3" cat_id="all">
							
							<!-- шаблонный тег вывода блока похожих объявлений. Вид блока файлов редактируется в файле modules/as/views/as.view.show_block_rel.php. -->
							<insert name="show_block_rel" module="ab" count="3" images="1">
							
							<!-- шаблонный тег вывода блока товаров, которые обычно покупают с текущим товаром. Блок выводиться только на странице товара. Вид блока файлов редактируется в файле modules/shop/views/shop.view.show_block_order_rel.php. -->
							<insert name="show_block_order_rel" module="shop" count="3" images="1">
							
							<!-- шаблонный тег вывода изображений к странице, если в настройках сайта стоит параметр "Прикрепить изображения к страницам сайта. Вид блока редактируется в файле modules/site/views/site.view.show_images.php. -->
							<insert name="show_images" module="site">
							
							<!-- шаблонный тег вывода списка ссылок на вложенные страницы, если у текущей страницы они есть. Вид списка редактируется в файле modules/site/views/site.view.show_links.php. -->
							<insert name="show_links" module="site">
							
							<!-- шаблонный тег вывода ссылок на соседние страницы сайта в виде "Следующая Предыдущая". Вид блока редактируется в файле modules/site/views/site.view.show_previous_next.php. -->
							<insert name="show_previous_next" module="site">

							<!-- шаблонный тег вывода комментариев, прикрепленных к старинце сайта. Вид блока редактируется в файле modules/site/views/site.view.show_comments.php. Вид списока комментариев - modules/comments/views/comments.get.view.php и форма добавления комментария - modules/comments/views/comments.form.view.php. -->
							<insert name="show_comments" module="site">
							
							<!-- шаблонный тег вывода тегов, прикрепленных к старинце сайта. Вид блока редактируется в файле modules/site/views/site.view.show_tags.php. Вид списока тегов - modules/tags/views/tags.get.view.php. -->
							<insert name="show_tags" module="site">	
							
							<!-- шаблонный тег вывода кнопок социальных сетей. Правится в файле общих функций includes/function.php, строка 567 -->
							<insert name="show_social_links">
							
							<!-- шаблонный тег вывода баннеров. Блок выводит все баннеры. Вид блока редактируется в файле modules/bs/views/bs.view.show_block.php-->
							<insert name="show_block" module="bs" count="1">
				
						</td>
						
						<td class="col_right">
							
							<!-- шаблонный тег вывода формы корзины. Вид формы редактируется в файле modules/cart/views/cart.view.show_block.php. -->
							<insert name="show_block" module="cart">
							
							<!-- шаблонный тег вывода формы входа и регистрации пользователей. Вид формы редактируется в файле modules/registration/views/registration.view.show_login.php. -->
							<insert name="show_login" module="registration">
							
							<!-- шаблонный тег вывода календаря новостей (если открыта страница новостей. Вид календаря редактируется в файле modules/news/views/news.view.show_calendar.php. -->
							<insert name="show_calendar" module="news" only_news="1">
							
							<!-- шаблонный тег вывода календаря новостей с детализацией по дням (если открыта страница новостей. Вид календаря редактируется в файле modules/news/views/news.view.show_calendar_day.php. -->
							<insert name="show_calendar" module="news" only_news="1" detail="day">
							
							<!-- шаблонный тег вывода блока новостей. Вид блока новостей редактируется в файле modules/news/views/news.view.show_block.php. -->
							<insert name="show_block" module="news" count="3" images="1">
							
							<!-- шаблонный тег вывода блока статей. Вид блока статей редактируется в файле modules/clauses/views/clauses.view.show_block.php. -->
							<insert name="show_block" module="clauses" images="1">

							<!-- шаблонный тег вывода блока с облаком тегов. Вид блока тегов редактируется в файле modules/tags/views/tags.view.show_block.php. -->
							<insert name="show_block" module="tags">
							
							<!-- шаблонный тег вывода блока с голосованиями. Вид блока редактируется в файле modules/votes/views/votes.view.show_block.php. -->
							<insert name="show_block" module="votes">

							<!-- шаблонный тег вывода блока некоторых изображений из фотогалереи. Вид блока фотографий редактируется в файле modules/photo/views/photo.view.show_block.php. -->
							<insert name="show_block" module="photo" sort="rand" count="1" cat_id="1">
							    
							<insert name="show_form" module="subscribtion">
						
							<insert name="show_block" module="comments" modules="photo, news, shop">
						</td>
						</tr></table>
						
					</div>

					<div class="bottom">
						<div class="copyright">
							<!-- шаблонный тег вывода текущего года. С параметром year выводит: 2003-2013 -->
							&copy; <insert name="show_year" year="2003">
						</div>
						<div class="bottom_menu">
							<insert name="show_block" module="menu" separator_1=" | " count_level="1">
							<br>
							<!-- шаблонный тег ошибка на сайте -->
							<insert name="show_block" module="mistakes">
						</div>
						<div class="now_online">
							<!-- шаблонный тег вывода количества пользователей on-line. Вид блока редактируется в файле modules/users/views/users.view.show_block.php. -->
							<insert name="show_block" module="users">
						</div>
						<!-- шаблонный тег подключает файл-блок -->
						<insert name="show_include" file="diafan">
					</div>

				</div>
			</div>
		</div>
	</div>
	<!-- шаблонный тег подключает on-line консультант -->
	<insert name="show_block" module="consultant" system="redhelper">
	<insert name="show_include" file="counters">
</body>
</html>
