<?php
/**
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.3
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2013 OOO «Диафан» (http://diafan.ru)
 */

define('DIAFAN', 1);
define('ABSOLUTE_PATH', dirname(__FILE__).'/');

include_once(ABSOLUTE_PATH."config.php");


if (!defined('VERSION_CMS') || VERSION_CMS != '5.2')
{
	exit('Обновление работает только для версии 5.2');
}

define('IS_ADMIN', 1);

include_once ABSOLUTE_PATH.'includes/customization.php';
include_once(ABSOLUTE_PATH.'includes/developer.php');
include_once(ABSOLUTE_PATH.'includes/diafan.php');
include_once(ABSOLUTE_PATH.'includes/files.php');

$dev = new Dev();
$dev->init();
try
{
if(! Files_inc::is_writable("config.php"))
{
	exit('Установите права 777 для config.php');
}
if(! defined('CACHE_MEMCACHED'))
{
	define('CACHE_MEMCACHED', false);
}
define("VERSION", "5.3");
define("D_UPDATE", 1400495613);


include_once(ABSOLUTE_PATH.'includes/core.php');
include_once ABSOLUTE_PATH.'includes/init.php';
$diafan = new Init();

global $langs;
$languages = array();
$langs = array();
$result = DB::query("SELECT * FROM {languages}");
while ($row = DB::fetch_array($result))
{
	$languages[] = $row["id"];
	$langs[] = $row;
}
$modules = array();
$result = DB::query("SELECT name FROM {modules}");
while ($row = DB::fetch_array($result))
{
    $modules[] = $row["name"];
}

DB::query("ALTER TABLE {menu} ADD `attributes` VARCHAR( 250 ) NOT NULL,
ADD `param_id` INT( 11 ) UNSIGNED NOT NULL DEFAULT '0',
ADD `target_blank` ENUM( '0', '1' ) NOT NULL DEFAULT '0'");

DB::query("UPDATE {menu} SET target_blank='1' WHERE othurl<>''");
if(in_array('feedback', $modules))
{
	DB::query("ALTER TABLE {feedback} ADD `readed` ENUM( '0', '1' ) NOT NULL DEFAULT '0'");
	DB::query("UPDATE {feedback} SET readed='1'");
}
if(in_array('files', $modules))
{
	DB::query("CREATE TABLE {files_links} (
		id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		element_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
		link VARCHAR( 255 ) NOT NULL DEFAULT '',
		trash ENUM('0', '1') NOT NULL DEFAULT '0',
		PRIMARY KEY  (id),
		KEY element_id (element_id)
	) CHARSET=utf8");
	$result = DB::query("SELECT link, id FROM {files} WHERE trash='0'");
	while($row = DB::fetch_array($result))
	{
		if($row["link"])
		{
			DB::query("INSERT INTO {files_links} (element_id, `link`) VALUES (%d, '%s')", $row["id"], $row["link"]);
		}
	}
	DB::query("ALTER TABLE {files} DROP `link`");
}
// раздел "Статистика"
if(in_array('shop', $modules))
{
	$adminsite_id = DB::query_result("SELECT id FROM {adminsite} WHERE rewrite='shop' AND parent_id=0");
	DB::query("INSERT INTO {adminsite} (parent_id, group_id, name, rewrite, act, sort, docs) VALUES (%d, '4', 'Статистика', 'shop/counter', '1', 6, 'http://cms.diafan.ru/moduli/magazin/')", $adminsite_id);
	$last_adminsite_id = DB::last_id("adminsite");
	DB::query("INSERT INTO {adminsite_parents} (parent_id, element_id) VALUES (%d, %d)", $adminsite_id, $last_adminsite_id);
	DB::query("UPDATE {adminsite} SET count_children=count_children+1 WHERE id=%d", $adminsite_id);
}
if(in_array('news', $modules))
{
	$adminsite_id = DB::query_result("SELECT id FROM {adminsite} WHERE rewrite='news' AND parent_id=0");
	DB::query("INSERT INTO {adminsite} (parent_id, group_id, name, rewrite, act, sort, docs) VALUES (%d, '4', 'Статистика', 'news/counter', '1', 6, '')", $adminsite_id);
	$last_adminsite_id = DB::last_id("adminsite");
	DB::query("INSERT INTO {adminsite_parents} (parent_id, element_id) VALUES (%d, %d)", $adminsite_id, $last_adminsite_id);
	DB::query("UPDATE {adminsite} SET count_children=count_children+1 WHERE id=%d", $adminsite_id);
}
if(in_array('clauses', $modules))
{
	$adminsite_id = DB::query_result("SELECT id FROM {adminsite} WHERE rewrite='clauses' AND parent_id=0");
	DB::query("INSERT INTO {adminsite} (parent_id, group_id, name, rewrite, act, sort, docs) VALUES (%d, '4', 'Статистика', 'clauses/counter', '1', 6, '')", $adminsite_id);
	$last_adminsite_id = DB::last_id("adminsite");
	DB::query("INSERT INTO {adminsite_parents} (parent_id, element_id) VALUES (%d, %d)", $adminsite_id, $last_adminsite_id);
	DB::query("UPDATE {adminsite} SET count_children=count_children+1 WHERE id=%d", $adminsite_id);
}
if(in_array('faq', $modules))
{
	$adminsite_id = DB::query_result("SELECT id FROM {adminsite} WHERE rewrite='faq' AND parent_id=0");
	DB::query("INSERT INTO {adminsite} (parent_id, group_id, name, rewrite, act, sort, docs) VALUES (%d, '4', 'Статистика', 'faq/counter', '1', 6, '')", $adminsite_id);
	$last_adminsite_id = DB::last_id("adminsite");
	DB::query("INSERT INTO {adminsite_parents} (parent_id, element_id) VALUES (%d, %d)", $adminsite_id, $last_adminsite_id);
	DB::query("UPDATE {adminsite} SET count_children=count_children+1 WHERE id=%d", $adminsite_id);
}
if(in_array('ads', $modules))
{
	$adminsite_id = DB::query_result("SELECT id FROM {adminsite} WHERE rewrite='ads' AND parent_id=0");
	DB::query("INSERT INTO {adminsite} (parent_id, group_id, name, rewrite, act, sort, docs) VALUES (%d, '4', 'Статистика', 'ads/counter', '1', 6, '')", $adminsite_id);
	$last_adminsite_id = DB::last_id("adminsite");
	DB::query("INSERT INTO {adminsite_parents} (parent_id, element_id) VALUES (%d, %d)", $adminsite_id, $last_adminsite_id);
	DB::query("UPDATE {adminsite} SET count_children=count_children+1 WHERE id=%d", $adminsite_id);
}
if(in_array('photo', $modules))
{
	$adminsite_id = DB::query_result("SELECT id FROM {adminsite} WHERE rewrite='photo' AND parent_id=0");
	DB::query("INSERT INTO {adminsite} (parent_id, group_id, name, rewrite, act, sort, docs) VALUES (%d, '4', 'Статистика', 'photo/counter', '1', 6, '')", $adminsite_id);
	$last_adminsite_id = DB::last_id("adminsite");
	DB::query("INSERT INTO {adminsite_parents} (parent_id, element_id) VALUES (%d, %d)", $adminsite_id, $last_adminsite_id);
	DB::query("UPDATE {adminsite} SET count_children=count_children+1 WHERE id=%d", $adminsite_id);
}
if(in_array('files', $modules))
{
	$adminsite_id = DB::query_result("SELECT id FROM {adminsite} WHERE rewrite='files' AND parent_id=0");
	DB::query("INSERT INTO {adminsite} (parent_id, group_id, name, rewrite, act, sort, docs) VALUES (%d, '4', 'Статистика', 'files/counter', '1', 6, '')", $adminsite_id);
	$last_adminsite_id = DB::last_id("adminsite");
	DB::query("INSERT INTO {adminsite_parents} (parent_id, element_id) VALUES (%d, %d)", $adminsite_id, $last_adminsite_id);
	DB::query("UPDATE {adminsite} SET count_children=count_children+1 WHERE id=%d", $adminsite_id);
}
// сортировка ADC на DESC
$array = array(
	'core' => array('adminsite', 'images', 'site', 'users_param', 'users_param_select'),
	'ads' => array('ads_param', 'ads_param_select'),
	'clauses' => array('clauses'),
	'comments' => array('comments_param', 'comments_param_select'),
	'feedback' => array('feedback_param', 'feedback_param_select'),
	'files' => array('files'),
	'photo' => array('photo'),
	'shop' => array('shop', 'shop_additional_cost', 'shop_delivery', 'shop_import', 'shop_order_param', 'shop_order_param_select', 'shop_order_status', 'shop_param', 'shop_param_select', 'shop_payment'),
	'tags' => array('tags_name'),
	'votes' => array('votes', 'votes_category'),
);
foreach($array as $module => $tables)
{
	if(in_array($module, $modules) || $module == 'core')
	{
		foreach($tables as $table)
		{
			$sort = 0;
			$result = DB::query("SELECT id FROM {".$table."} ORDER BY sort DESC");
			while($row = DB::fetch_array($result))
			{
				$sort++;
				DB::query("UPDATE {".$table."} SET sort=%d WHERE id=%d", $sort, $row["id"]);
			}
		}
	}
}
if(in_array('comments', $modules))
{
	DB::query("CREATE TABLE {comments_mail} (
		id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		mail VARCHAR( 64 ) NOT NULL DEFAULT '',
		element_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
		module_name VARCHAR(17) NOT NULL DEFAULT '',
		trash ENUM('0', '1') NOT NULL DEFAULT '0',
		PRIMARY KEY  (id),
		KEY element_id (element_id),
		KEY module_name (module_name(2))
	) CHARSET=utf8");
}

if(in_array('forum', $modules))
{
	DB::query("ALTER TABLE {forum_category} ADD `sort` int(11) unsigned NOT NULL");
	$sort = 0;
	$result = DB::query("SELECT id FROM {forum_category} ORDER BY created ASC");
	while($row = DB::fetch_array($result))
	{
		$sort++;
		DB::query("UPDATE {forum_category} SET sort=%d WHERE id=%d", $sort, $row["id"]);
	}
}

DB::query("ALTER TABLE {images} ADD folder_num TINYINT(3) UNSIGNED NOT NULL DEFAULT '0';");

if(in_array('shop', $modules))
{
	DB::query("ALTER TABLE {shop_order_param} ADD `info` VARCHAR(30) NOT NULL DEFAULT ''");

	$infos = array(
		'адрес' => 'address',
		'улица' => 'street',
		'улица, проспект и пр.' => 'street',
		'номер дома' => 'building',
		'дом' => 'building',
		'корпус' => 'suite',
		'квартира' => 'flat',
		'квартира, офис' => 'flat',
		'подъезд' => 'entrance',
		'этаж' => 'floor',
		'домофон' => 'intercom',
		'город' => 'city',
		'country' => 'страна',
		'индекс' => 'zip',
		'станция метро' => 'metro',
		'наличие грузового лифта' => 'cargolift',
		'фио' => 'name',
		'название' => 'name',
		'фио или название компании' => 'name',
		'имя' => 'firstname',
		'фамилия' => 'lastname',
		'отчество' => 'fathersname',
		'телефон' => 'phone',
		'контактные телефоны (с кодом города)' => 'phone',
		'дополнительный телефон' => 'phone-extra',
		'email' => 'электронный адрес для связи',
		'comment' => 'комментарий к адресу'
	);
	$result = DB::query("SELECT id, name".$languages[0]." AS name FROM {shop_order_param} WHERE trash='0'");
	while ($row = DB::fetch_array($result))
	{
		$row["name"] = str_replace(array('А', 'Б', 'В', 'Г', 'Д', 'Е', 'Ё', 'Ж', 'З', 'И', 'Й', 'К', 'Л', 'М', 'Н', 'О', 'П', 'Р', 'С', 'Т', 'У', 'Ф', 'Х', 'Ц', 'Ч', 'Ш', 'Щ', 'Ы', 'Э', 'Ю', 'Я'),
		array('а', 'б', 'в', 'г', 'д', 'е', 'ё', 'ж', 'з', 'и', 'й', 'к', 'л', 'м', 'н', 'о', 'п', 'р', 'с', 'т', 'у', 'ф', 'х', 'ц', 'ч', 'ш', 'щ', 'ы', 'э', 'ю', 'я'), $row["name"]);
		if(! empty($infos[$row["name"]]))
		{
			DB::query("UPDATE {shop_order_param} SET info='%s' WHERE id=%d", $infos[$row["name"]], $row["id"]);
		}
	}
	DB::query("ALTER TABLE {shop_order_param} ADD `show_in_form` ENUM('0', '1') NOT NULL DEFAULT '0', ADD `show_in_form_one_click` ENUM('0', '1') NOT NULL DEFAULT '0'");
	DB::query("UPDATE {shop_order_param} SET `show_in_form`='1'");

	DB::query("DELETE FROM {shop_price} WHERE threshold>0 OR threshold_cumulative>0");
	
	DB::query("ALTER TABLE {shop_price} ADD `person` ENUM('0', '1') NOT NULL DEFAULT '0'");
	DB::query("UPDATE {shop_price} SET person='1' WHERE user_id>0");

	DB::query("ALTER TABLE {shop_price} DROP `user_id`, DROP threshold, DROP threshold_cumulative");

	DB::query("CREATE TABLE {shop_discount_person} (
		id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		discount_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
		user_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
		session_id VARCHAR(64) NOT NULL DEFAULT '',
		coupon_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
		trash ENUM('0', '1') NOT NULL DEFAULT '0',
		PRIMARY KEY  (id)
	) CHARSET=utf8");
	$result = DB::query("SELECT * FROM {shop_discount} WHERE user_id>0 AND trash='0'");
	while($row = DB::fetch_array($result))
	{
		DB::query("INSERT INTO {shop_discount_person} (discount_id, user_id) VALUES (%d, %d)", $row["id"], $row["user_id"]);
	}
	DB::query("ALTER TABLE {shop_discount} ADD `person` ENUM('0', '1') NOT NULL DEFAULT '0', DROP `user_id`");

	DB::query("CREATE TABLE {shop_discount_coupon} (
		id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		discount_id VARCHAR( 10 ) NOT NULL,
		coupon VARCHAR( 10 ) NOT NULL,
		count_use TINYINT(3) UNSIGNED NOT NULL,
		used TINYINT(3) UNSIGNED NOT NULL,
		trash ENUM('0', '1') NOT NULL DEFAULT '0',
		PRIMARY KEY  (id)
	) CHARSET=utf8");
	$result = DB::query("SELECT * FROM {shop_discount} WHERE coupon<>''");
	while($row = DB::fetch_array($result))
	{
		DB::query("INSERT INTO {shop_discount_coupon} (discount_id, coupon, count_use) VALUES (%d, %d, %d)", $row["id"], $row["used"], $row["count_use"]);
	}
	DB::query("ALTER TABLE {shop_discount} DROP `coupon`, DROP `count_use`");

	DB::query("ALTER TABLE {shop_order} ADD `discount_summ` FLOAT NOT NULL DEFAULT '0',
			  ADD `discount_id` VARCHAR( 10 ) NOT NULL");
}
DB::query("ALTER TABLE {users} ADD start_adminsite VARCHAR(30) NOT NULL DEFAULT '', ADD copy_files enum('0','1') NOT NULL DEFAULT '0', ADD useradmin enum('0','1') NOT NULL DEFAULT '0', ADD phone VARCHAR(20) NOT NULL DEFAULT ''");

DB::query("ALTER TABLE {rewrite} ADD INDEX ( `element_id` ), ADD INDEX ( `site_id` ), ADD INDEX ( `cat_id` ),  ADD INDEX ( `module_name` ) ;");
if(in_array('forum', $modules))
{
	$cat_ids = array();
	$element_ids = array();
	$result = DB::query("SELECT id FROM {forum_category} WHERE del='1'");
	while($row = DB::fetch_array($result))
	{
		if(! in_array($row["id"], $cat_ids))
		{
			$cat_ids[] = $row["id"];
		}
		$result2 = DB::query("SELECT element_id FROM {forum_category_parents} WHERE parent_id=%d", $row["id"]);
		while($row2 = DB::fetch_array($result2))
		{
			if(! in_array($row2["element_id"], $element_ids))
			{
				$cat_ids[] = $row2["element_id"];
			}
		}
	}
	$result = DB::query("SELECT id FROM {forum} WHERE del='1'".($cat_ids ? " OR cat_id IN (".implode(",", $cat_ids).")" : ''));
	while($row = DB::fetch_array($result))
	{
		if(! in_array($row["id"], $element_ids))
		{
			$element_ids[] = $row["id"];
		}
		$result2 = DB::query("SELECT element_id FROM {forum_parents} WHERE parent_id=%d", $row["id"]);
		while($row2 = DB::fetch_array($result2))
		{
			if(! in_array($row2["element_id"], $element_ids))
			{
				$element_ids[] = $row2["element_id"];
			}
		}
	}
	if($element_ids)
	{
		DB::query("DELETE FROM {forum} WHERE id IN (%s)", implode(",", $element_ids));
		DB::query("DELETE FROM {forum_show} WHERE element_id IN (%s) AND table_name='forum'", implode(",", $element_ids));
	}
	if($cat_ids)
	{
		DB::query("DELETE FROM {forum_category} WHERE id IN (%s)", implode(",", $cat_ids));
		DB::query("DELETE FROM {rewrite} WHERE module_name='forum' AND (element_id IN (%s) OR cat_id IN (%s))", implode(",", $cat_ids), implode(",", $cat_ids));
		DB::query("DELETE FROM {forum_show} WHERE element_id IN (%s) AND table_name='forum_category'", implode(",", $element_ids));
	}
	DB::query("ALTER TABLE {forum} DROP `del`");
	DB::query("ALTER TABLE {forum_category} DROP `del`");
}
if(defined('RECAPTCHA') && RECAPTCHA)
{
	$diafan->configmodules("type", "captcha", "reCAPTCHA");
	$diafan->configmodules("recaptcha_private_key", "captcha", RECAPTCHA_PRIVATE_KEY);
	$diafan->configmodules("recaptcha_public_key", "captcha", RECAPTCHA_PUBLIC_KEY);
}
DB::query("CREATE TABLE {captcha} (
	id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
	".multilang("nameLANG TEXT NOT NULL DEFAULT '',")."
	".multilang("actLANG ENUM('0', '1') NOT NULL DEFAULT '0',")."
	trash ENUM('0', '1') NOT NULL DEFAULT '0',
	PRIMARY KEY  (id)
) CHARSET=utf8");

DB::query("CREATE TABLE {captcha_answers} (
	id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
	".multilang("textLANG TEXT NOT NULL DEFAULT '',")."
	is_right ENUM('0', '1') NOT NULL DEFAULT '0',
	captcha_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
	trash ENUM('0', '1') NOT NULL DEFAULT '0',
	PRIMARY KEY  (id),
	KEY captcha_id (captcha_id)
) CHARSET=utf8");

if(in_array('forum', $modules))
{
	DB::query("ALTER TABLE {subscribtion_emails} ADD name varchar(250) NOT NULL;");
	DB::query("ALTER TABLE {subscribtion_phones} ADD name varchar(250) NOT NULL;");
}

DB::query("CREATE TABLE {site_blocks} (
	id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
	".multilang("nameLANG VARCHAR(100) NOT NULL DEFAULT '',")."
	".multilang("textLANG TEXT NOT NULL DEFAULT '',")."
	".multilang("actLANG ENUM('0', '1') NOT NULL DEFAULT '0',")."
	title_no_show ENUM('0', '1') NOT NULL DEFAULT '0',
	access ENUM('0', '1') NOT NULL DEFAULT '0',
	date_start INT(10) UNSIGNED NOT NULL DEFAULT '0',
	date_finish INT(10) UNSIGNED NOT NULL DEFAULT '0',
	admin_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
	sort INT(11) UNSIGNED NOT NULL DEFAULT '0',
	timeedit INT(10) UNSIGNED NOT NULL DEFAULT '0',
	trash ENUM('0', '1') NOT NULL DEFAULT '0',
	PRIMARY KEY  (id)
) CHARSET=utf8");

$adminsite_id = DB::query_result("SELECT id FROM {adminsite} WHERE rewrite='site' AND parent_id=0");

DB::query("INSERT INTO {adminsite} (parent_id, group_id, name, rewrite, act, sort) VALUES (%d, '1', 'Страницы сайта', 'site', '1', 2)", $adminsite_id);
$last_adminsite_id = DB::last_id("adminsite");
DB::query("INSERT INTO {adminsite_parents} (parent_id, element_id) VALUES (%d, %d)", $adminsite_id, $last_adminsite_id);

DB::query("INSERT INTO {adminsite} (parent_id, group_id, name, rewrite, act, sort) VALUES (%d, '1', 'Блоки на сайте', 'site/blocks', '1', 1)", $adminsite_id);
$last_adminsite_id = DB::last_id("adminsite");
DB::query("INSERT INTO {adminsite_parents} (parent_id, element_id) VALUES (%d, %d)", $adminsite_id, $last_adminsite_id);

DB::query("UPDATE {adminsite} SET count_children=count_children+2 WHERE id=%d", $adminsite_id);

$result = DB::query("SELECT * FROM {site} WHERE block='1' AND trash='0'");
while($row = DB::fetch_array($result))
{
	$data = array(
		"id" => $row["id"],
		"access" => $row["access"],
		"title_no_show" => $row["title_no_show"],
		"date_start" => $row["date_start"],
		"date_finish" => $row["date_finish"],
		"admin_id" => $row["admin_id"],
		"sort" => $row["sort"],
		"timeedit" => $row["timeedit"],
	);
	foreach($langs as $lang)
	{
		$data["name".$lang] = str_replace("'", "\\'", $row["name".$lang]);
		$data["text".$lang] = str_replace("'", "\\'", $row["text".$lang]);
		$data["act".$lang] = $row["act".$lang];
	}
	
	DB::query("INSERT INTO {site_blocks} (".implode(",", array_keys($data)).") VALUES ('".implode("','", $data)."')");
	
	DB::query("UPDATE {access} SET module_name='site_blocks' WHERE module_name='site' AND element_id=%d", $row["id"]);
	DB::query("DELETE FROM {site} WHERE id=%d", $row["id"]);
}
DB::query("ALTER TABLE {site} DROP `block`");

$data = array(
	'news' => array('news', 'news_category'),
	'clauses' => array('clauses', 'clauses_category'),
	'faq' => array('faq_category'),
	'files' => array('files', 'files_category'),
	'photo' => array('photo', 'photo_category'),
	'shop' => array('shop', 'shop_category'),
	'ads' => array('ads', 'ads_category'),
);
foreach($data as $m => $ts)
{
	if(in_array($m, $modules))
	{
		foreach($ts as $t)
		{
			foreach($languages as $lang)
			{
				DB::query("ALTER TABLE {".$t."} ADD anons_plus".$lang." ENUM('0', '1') NOT NULL DEFAULT '0';");
			}
		}
	}
}
if(in_array('ads', $modules))
{
	DB::query("UPDATE {config} SET module_name='ab' WHERE module_name='ads'");
	DB::query("UPDATE {modules} SET module_name='ab' WHERE module_name='ads'");
	DB::query("UPDATE {modules} SET name='ab' WHERE name='ads'");
	DB::query("UPDATE {access} SET module_name='ab' WHERE module_name='ads'");
	$result = DB::query("SELECT * FROM {adminsite} WHERE rewrite LIKE 'ads%%' OR rewrite='ads'");
	while($row = DB::fetch_array($result))
	{
		DB::query("UPDATE {adminsite} SET rewrite='%s' WHERE id=%d", str_replace('ads', 'ab', $row["rewrite"]), $row["id"]);
	}
	DB::query("RENAME TABLE {ads} TO {ab}");
	DB::query("RENAME TABLE {ads_category} TO {ab_category}");
	DB::query("RENAME TABLE {ads_category_parents} TO {ab_category_parents}");
	DB::query("RENAME TABLE {ads_category_rel} TO {ab_category_rel}");
	DB::query("RENAME TABLE {ads_counter} TO {ab_counter}");
	DB::query("RENAME TABLE {ads_param} TO {ab_param}");
	DB::query("RENAME TABLE {ads_param_category_rel} TO {ab_param_category_rel}");
	DB::query("RENAME TABLE {ads_param_element} TO {ab_param_element}");
	DB::query("RENAME TABLE {ads_param_select} TO {ab_param_select}");
	DB::query("RENAME TABLE {ads_rel} TO {ab_rel}");
	DB::query("UPDATE {attachments} SET module_name='ab' WHERE module_name='ads'");
	if(in_array('comments', $modules))
	{
		DB::query("UPDATE {comments} SET module_name='ab' WHERE module_name='ads'");
		DB::query("UPDATE {comments} SET module_name='ab_category' WHERE module_name='ads_category'");
		DB::query("UPDATE {comments_param} SET module_name='ab' WHERE module_name='ads'");
	}
	DB::query("UPDATE {images} SET module_name='ab' WHERE module_name='ads'");
	DB::query("UPDATE {images} SET module_name='abcat' WHERE module_name='adscat'");
	DB::query("UPDATE {languages_translate} SET module_name='ab' WHERE module_name='ads'");
	DB::query("UPDATE {menu} SET module_name='ab' WHERE module_name='ads'");
	if(in_array('rating', $modules))
	{
		DB::query("UPDATE {rating} SET module_name='ab' WHERE module_name='ads'");
		DB::query("UPDATE {rating} SET module_name='ab_category' WHERE module_name='ads_category'");
	}
	DB::query("UPDATE {redirect} SET module_name='ab' WHERE module_name='ads'");
	DB::query("UPDATE {rewrite} SET module_name='ab' WHERE module_name='ads'");
	if(in_array('search', $modules))
	{
		DB::query("UPDATE {search_results} SET table_name='ab' WHERE table_name='ads'");
		DB::query("UPDATE {search_results} SET table_name='ab_category' WHERE table_name='ads_category'");
	}
	DB::query("UPDATE {site} SET module_name='ab' WHERE module_name='ads'");
	if(in_array('tags', $modules))
	{
		DB::query("UPDATE {tags} SET module_name='ab' WHERE module_name='ads'");
	}
}

if(in_array('banners', $modules))
{
	DB::query("UPDATE {config} SET module_name='bs' WHERE module_name='banners'");
	DB::query("UPDATE {modules} SET module_name='bs' WHERE module_name='banners'");
	DB::query("UPDATE {modules} SET name='bs' WHERE name='banners'");
	DB::query("UPDATE {access} SET module_name='bs' WHERE module_name='banners'");
	$result = DB::query("SELECT * FROM {adminsite} WHERE rewrite LIKE 'banners%%' OR rewrite='banners'");
	while($row = DB::fetch_array($result))
	{
		DB::query("UPDATE {adminsite} SET rewrite='%s' WHERE id=%d", str_replace('banners', 'bs', $row["rewrite"]), $row["id"]);
	}
	DB::query("RENAME TABLE {banners} TO {bs}");
	DB::query("RENAME TABLE {banners_category} TO {bs_category}");
	DB::query("RENAME TABLE {banners_site_rel} TO {bs_site_rel}");
	DB::query("UPDATE {attachments} SET module_name='bs' WHERE module_name='banners'");
	DB::query("UPDATE {images} SET module_name='bs' WHERE module_name='banners'");
	DB::query("UPDATE {languages_translate} SET module_name='bs' WHERE module_name='banners'");
}

if(in_array('consultant', $modules))
{
	$adminsite_id = DB::query_result("SELECT id FROM {adminsite} WHERE rewrite='consultant' AND parent_id=0");
	DB::query("INSERT INTO {adminsite} (parent_id, name, rewrite, act, sort) VALUES (%d, 'LiveTex', 'consultant', '1', 3)", $adminsite_id);
	$last_adminsite_id = DB::last_id("adminsite");
	DB::query("INSERT INTO {adminsite_parents} (parent_id, element_id) VALUES (%d, %d)", $adminsite_id, $last_adminsite_id);

	DB::query("INSERT INTO {adminsite} (parent_id, name, rewrite, act, sort) VALUES (%d, 'JivoSite', 'consultant/jivosite', '1', 2)", $adminsite_id);
	$last_adminsite_id = DB::last_id("adminsite");
	DB::query("INSERT INTO {adminsite_parents} (parent_id, element_id) VALUES (%d, %d)", $adminsite_id, $last_adminsite_id);

	DB::query("INSERT INTO {adminsite} (parent_id, name, rewrite, act, sort) VALUES (%d, 'RedHelper', 'consultant/redhelper', '1', 1)", $adminsite_id);
	$last_adminsite_id = DB::last_id("adminsite");
	DB::query("INSERT INTO {adminsite_parents} (parent_id, element_id) VALUES (%d, %d)", $adminsite_id, $last_adminsite_id);

	DB::query("UPDATE {adminsite} SET count_children=3 WHERE id=%d", $adminsite_id);

	$result = DB::query("SELECT * FROM {config} WHERE module_name='consultant'");
	while($row = DB::fetch_array($result))
	{
		DB::query("UPDATE {config} SET name='%s' WHERE id=%d", 'redhelper_'.$row["name"], $row["id"]);
	}
}
if(in_array('map', $modules))
{
	DB::query("CREATE TABLE {map_index} (
		`id` int(11) unsigned NOT NULL AUTO_INCREMENT,
		`url` text NOT NULL,
		`table_name` varchar(50) NOT NULL DEFAULT '',
		`element_id` int(11) unsigned NOT NULL DEFAULT '0',
		`timeedit` int(10) unsigned NOT NULL,
		`changefreq` enum('always','hourly','daily','weekly','monthly','yearly','never') NOT NULL,
		`priority` varchar(3) NOT NULL,
		`trash` enum('0','1') NOT NULL DEFAULT '0',
		PRIMARY KEY (`id`)
	) CHARSET=utf8");
}
if(in_array('search', $modules))
{
	DB::query("ALTER TABLE {search_index} ADD `rating` tinyint(2) unsigned NOT NULL");
}
$ms = array('rating', 'comments', 'tags', 'map', 'search', 'bbcode', 'cart', 'wishlist', 'images', 'attachments', 'keywords', 'languages');
foreach($ms as $m)
{
	if(in_array($m, $modules))
	{
		DB::query("UPDATE {modules} SET site='1' WHERE name='".$m."'");
	}
}

$diafan->_cache->delete("");

//////////////////////config
$new_values = array(
	'VERSION_CMS' => VERSION,
	'DATE_UPDATE' => D_UPDATE
);

include_once(ABSOLUTE_PATH.'includes/config.php');
Config::save($new_values, $langs);

echo '<font color="green">Обновление успешно завершено!</font>';
}
catch (Exception $e)
{
	$dev->exception($e);
}

function multilang($str)
{
	global $langs;
	if(! $langs)
		return;

	$result = '';

	$arg = func_get_args();
	$i = 0;

	foreach($langs as $lang)
	{
		if (! isset($arg[$i]))
		{
			$arg[$i] = $arg[$i - 1];
		}
		$str = $arg[$i];
		$result .= str_replace('LANG', $lang["id"], $str).' ';
		$i++;
	}
	return $result;
}
